#算法思路：hashfunction和rehash保持不变，负载因子达到2/3后散列表自动扩充一倍。后续数据仍采用线性探测
#这样做会导致查找效率很低，时间复杂度逼近O（n），但暂时想不到解决办法
class hashtable:
    def __init__(self):
        self.initsize=23        #初始散列表大小记为23
        self.slots=[None]*self.initsize
        self.data=[None]*self.initsize
  #保持hash和rehash函数不变
    def hashfunction(self,key):
        return key%23
    def rehash(self,oldhash):
        return (oldhash+1)%23
  #计算负载因子
    def size(self):
        count=0
        for slot in self.slots:
            if slot!=None:
                count+=1
            else:
                pass
        return count
   #定义put方法
    def put(self,key,data):
    # 负载因子达到2/3后自动扩充一倍
        if (self.size()/self.initsize)>=2/3:
            self.initsize+= 23
            self.slots.extend([None]*23)
            self.data.extend([None]*23)
    #以下为普通的线性探测散列表的实现
        hashvalue=self.hashfunction(key)
        if self.slots[hashvalue]==None:
            self.slots[hashvalue]=key
            self.data[hashvalue]=data       #key值不存在，直接加入
        else:
            if self.slots[hashvalue]==key:
                self.data[hashvalue]=data   #key值存在，更新
            else:
                nextslot=self.rehash(hashvalue)     #否则，发生冲突，rehash
                while self.slots[nextslot]!=None and self.slots[nextslot]!=key:
                    nextslot=self.rehash(nextslot)
                if self.slots[nextslot]==None:
                    self.slots[nextslot]=key
                    self.data[nextslot]=data
                else:
                    self.data[nextslot]=data        #rehash直到将该数据项加入散列表
  #定义get方法
    def get(self,key):
        startslot=self.hashfunction(key)
        data=None
        stop=False
        found=False
        poslot=startslot    #slot值初始化
        while self.slots[poslot]!=None and not found and not stop:
            if self.slots[poslot]==key:
                found=True
                data=self.data[poslot]
            else:
                poslot=self.rehash(poslot)
                if poslot==startslot:
                    stop=True       #重复rehash直到找到该数据项
        return data     #返回data