import turtle
import random
def randomtree(branchlen,branchwidth,colorR,colorG,colorB,t):       # randomtree中树枝长度、角度随机变化，但每个小分叉还是对称的
    b = random.uniform(5,branchlen)                                 # 为使每画一个小分叉后画笔仍能回到起点，先随机确定一个树杈的长度
    if b > 5:
        t.color(colorR,colorG,colorB)                               # 用三个参数确定树枝的颜色
        t.pensize(branchwidth)
        t.forward(b)
        a = random.uniform(15,45)                                   # 为使每个小分叉对称，先随机确定一个偏转角度
        t.right(a)
        randomtree(branchlen - 15,branchwidth - 1,colorR + 0.05,colorG + 0.05,colorB - 0.05,t)   # 在每次画小树杈时，不断缩短长度和粗细，并改变颜色
        t.left(2*a)
        randomtree(branchlen - 15,branchwidth - 1,colorR + 0.05,colorG + 0.05,colorB - 0.05,t)
        t.right(a)
        t.up()
        t.backward(b)
        t.down()
    else:
        leaf(5,9.66,2)               # 当树杈长度足够小时，停止画树杈，在树梢画一片树叶（树叶可以用自定义的leaf函数，也可以用stamp印上去）

def leaf(len1,len2,pensize):        # 定义树叶函数
    t.pensize(pensize)
    t.begin_fill()
    t.left(30)
    t.forward(len1)
    t.right(45)
    t.forward(len2)
    t.right(150)
    t.forward(len2)
    t.right(45)
    t.forward(len1)
    t.right(150)
    t.end_fill()
    t.fillcolor()

t = turtle.Turtle()
w = turtle.Screen()
w.tracer(0)
t.up()
t.goto(0,-250)
t.down()
t.left(90)
randomtree(150,10,0.1,0.2,0.6,t)
t.hideturtle()
w.update()
w.exitonclick()

