#最短编辑距离问题
def Edit(source,target,costInsert,costDelete,costCopy,stepused):
    # 原字符串长度
    l1 = len(source)
    # 目标字符串长度
    l2 = len(target)
    # 列表保存将原字符串的前i个字符转化为目标字符串的前j项字符的最小得分
    cost = [[0 for j in range(l2 + 1)] for i in range(l1 + 1)]
    for i in range(l1 + 1):
        # 原字符串转化为空字符串，相当于删除i次
        cost[i][0] = costDelete*i
        # 将删除操作（含对象）以字符串形式存入列表相应位置
        stepused[i][0]=str('删除'+source[i-1])
    for j in range(l2 + 1):
        # 空字符串转化为目标字符串，相当于插入j次
        cost[0][j] = costInsert*j
        # 将插入操作（含对象）以字符串形式存入列表相应位置
        stepused[0][j] = str('插入'+target[j-1])

    # 进行递归
    for i in range(1, l1 + 1):
        for j in range(1, l2 + 1):
            # 一步插入
            cost[i][j]=cost[i][j-1]+costInsert
            # 将操作存入stepused
            stepused[i][j]=str('插入'+target[j-1])
            if cost[i-1][j]<cost[i][j-1]:
                # 一步删除
                cost[i][j]=cost[i-1][j]+costDelete
                # 将操作存入stepused
                stepused[i][j] = str('删除'+ source[i - 1])
                # 末位相同字符
            if source[i-1]==target[j-1]:
                if cost[i-1][j-1]+costCopy<cost[i][j]:
                    # 一步复制
                    cost[i][j]=cost[i-1][j-1]+costCopy
                    # 将操作存入stepused
                    stepused[i][j]=str('复制'+source[i-1])
    return cost[l1][l2]

#输出方案
def printstep(stepused,l1,l2):
    # 创建新列表储存最终方案的每一步
    steplist=[]
    # i,j初始值分别为l1,l2
    i=l1
    j=l2
    #回溯至空对空的情况
    while i>0 or j>0:
        #判断是三种操作的哪一种
        # 最后一步为插入
        if stepused[i][j][0]=='插':
            # 放在列表末尾
            steplist.append(stepused[i][j])
            # 退回至插入前
            j-=1
            # 若最后一步为删除
        elif stepused[i][j][0]=='删':
            # 步骤放在列表末尾
            steplist.append(stepused[i][j])
            # 退回至删除前
            i-=1
            # 若最后一步为复制
        elif stepused[i][j][0]=='复':
            # 该步骤放在列表末尾
            steplist.append(stepused[i][j])
            i-=1
            # 退回至复制前
            j-=1
    # 由于逆推时步骤是反的，需将其反转
    steplist.reverse()
    print('得到最小得分的方案为：',(',').join(steplist))

def main():
    print("请输入原字符串：")
    source=input()
    print("请输入目标字符串：")
    target=input()
    print("请输入一次插入操作的得分：")
    costInsert=int(input())
    print("请输入一次删除操作的得分：")
    costDelete = int(input())
    print("请输入一次复制操作的得分：")
    costCopy = int(input())
    l1 = len(source)  # 原字符串长度
    l2 = len(target)  # 目标字符串长度
    # 创建二维的表来储存修改的步骤方便回溯
    stepused = [[0 for j in range(l1 + 1)] for i in range(l2 + 1)]
    # 输出最小编辑距离，相当于是得分取值分别为1,1,0的特殊情况
    print('最短编辑距离为：', Edit(source, target, 1, 1, 0, stepused))
    Edit(source, target, costInsert, costDelete, costCopy, stepused)
    cost = Edit(source, target, costInsert, costDelete, costCopy, stepused)  # 调用函数，返回总表
    print('最小得分为：', cost)
    printstep(stepused, l1, l2)  # 输出方案


main()
