# 计时实验，Dict的get item和set item

import timeit  # 导入timeit模块
import random  # 导入random模块
for i in range(1000000, 100000001, 1000000):  # 循环进行共100次计时实验
    dic = {j: None for j in range(i)}  # 生成字典
    getitem = timeit.Timer('dic[random.randrange(i)]', 'from __main__ import random,i,dic')  # 创建Timer对象，参数1为按字典按key取值的语句，参数2为"安装语句"
    gt = getitem.timeit(number=100)  # 调用timeit方法，反复运行100次，计时完毕后返回以秒为单位的时间
    setitem = timeit.Timer('dic[random.randrange(i)] = "sessdsa"', 'from __main__ import random,i,dic')   # 创建Timer对象，参数1为按字典按key赋值的语句，参数2为"安装语句"
    st = setitem.timeit(number=100)   # 调用timeit方法，反复运行100次，计时完毕后返回以秒为单位的时间
    print('%.8f %.8f' % (gt, st))  # 输出key值及相应的执行时间

# 实验结果可发现，Dict的get item和set item用时不随字典长度增加而发生显著变化，都为O(1)数量级
