# 计时实验，List和Dict的del操作符性能

import timeit  # 导入timeit模块
import random  # 导入rando
for i in range(1000000, 100000001, 1000000):  # 循环进行共100次计时实验
    t = timeit.Timer('del x[random.randrange(i) ]',
                     'from __main__ import random,i,x')  # 创建Timer对象，参数1为del操作的语句，参数2为"安装语句"
    x = list(range(i))  # 生成列表
    lst = t.timeit(number=100)  # 调用timeit方法，反复运行100次，计时完毕后返回以秒为单位的时间
    x = {j: None for j in range(i)}  # 生成字典
    dic = t.timeit(number=100)  # 调用timeit方法，反复运行100次，计时完毕后返回以秒为单位的时间
    print('%.8f, %.8f' % (lst,dic))  # 输出List和Dict相应时间

# 实验结果可发现，List的del操作时间随列表规模加大而线性上升，为O(n)数量级，而Dict的del操作时间不随字典长度增加而发生显著变化，为O(1)数量级


