from UnorderList import UnorderedList
from Node import Node

class OrderedList(UnorderedList):  #有序表类继承自无序表类

    def __cmp__(self, b):  #定义cmp,用于sorted函数
        if self.head < b:
            return -1
        elif self.head == b:
            return 0
        elif self.head > b:
            return 1

    def add(self,item):  #改写无序表类的add方法，使之在输入后能够完成排序
        current = self.head
        previous = None
        stop = False
        temp = Node(item)
        while current != None and not stop:#输入一个元素时，元素不断与有序表内已有元素比较大小
            if current.getData() > item:
                stop = True #直到按照大小找到自己的位置才停下
            else:
                previous = current
                current = current.getNext()
        if previous == None: #当加入元素要被放在表头位置时，需要特别考虑
            temp.setNext(current)
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)

    def index(self,item):#输入一个元素，返回这个元素在有序表中的索引
        current = self.head
        found = False
        stop = False
        while current!=None and not found and not stop: #其核心思想是，当发现有序表中遍历的数据已大于所查找的数据时
            if current.getData()==item:#应该立即停止寻找，以降低时间成本
                found = True
            elif current.getData()>item:
                stop = True
            else:
                current = current.getNext()
        return found

rawinput = input()
readin = rawinput.split(' ')

thelist = OrderedList()#此范例展示了无序表的append方法，和可以使用的sorted方法
for i in readin:
    thelist.add(i)
print(thelist)#此处范例是针对字符串做处理的

mylist=[]
for i in readin:
    mylist.append(i)
print(sorted(mylist))



