from Node import Node

class UnorderedList:
    def __init__(self): #此处是UnorderedList的初始化方法
        self.head = None

    def add(self,item): #定义UnorderedList的add方法——从无序表头加入新元素
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp

    def size(self): #定义UnorderedList的size方法——返回无需表中的元素个数
        count=0
        current=self.head
        while current != None:
            count = count + 1
            current = current.getNext()
        return count

    def search(self,num):
        current=self.head
        for i in range(num-1):
            current = current.getNext()
        return current

    def append(self,item):#定义UnorderedList的append方法——在无序表的表位加入新元素item
        temp = Node(item)#现将待加入的元素item转化成无序表中的元素的格式Node
        find = None
        current = self.head
        if current == None:  #如果表中没有元素，那加入的元素就直接成为表头元素
            self.head = temp
        else:
            while current != None:#如果表中已经有元素
                find = current #那么就从从表头开始，不断向后查找元素，直到表尾为止
                current = current.getNext()
            find.setNext(temp)

    def index(self,n):#index方法是输入一个元素，返回这个元素在无序表中的位置
        find=False
        index=0
        current=self.head
        while find == False and current != None: #一直在无序表中进行查找，直到找到了所查找的元素或者查找到了无序表的表尾
            if n == current.getData():
                find = True
            else:
                current = current.getNext()
                index = index + 1
        if find:
            return index
        else:
            return -1 #若未找到所查找的元素，则index方法返回值为-1

    def pop(self):#pop方法是弹出并删除无序表头的一个元素
        assert self.size()>0
        find=self.head
        findnext=find.getNext()
        self.head=findnext
        return find.getData()

    def insert(self,position,item):
        temp=Node(item)

        if position==1:
            find=self.head
            self.head=temp
            temp.setNext(find)
        else:
            current = self.head
            for i in range(position-2):#找到插入位置的前一个元素current
                current = current.getNext()
            after = current.getNext() #找到插入位置的后一个元素after
            current.setNext(temp)#把新元素插入
            temp.setNext(after)


    def __str__(self):
        current = self.head
        word = ''
        while current != None:
            result = current.getData()
            word = word + str(result) + ' '
            current = current.getNext()
        return word

    def __getitem__(self, item):
        output = UnorderedList()
        if isinstance(item,slice):
            start = item.start
            end = item.stop
            current=self.search(start)#找到开始截取的那个数current
            for i in range(start,end+1): #把要截取的部分一个个加入到新的无序表output中
                result=current.getData()
                output.append(result)
                current=current.getNext()
        return output#返回值依然为无序表格式