class HashTable():
    def __init__(self,len): #HashTable的初始化函数，Hash表由一个二维的列表构造
        self.size = len #len为Hash表的长度
        self.slots = [[None]*self.size for i in range(self.size)]#slots在Hash表中存储Hash表中元素原来在列表中的键值
        self.data = [ [None]*self.size for i in range(self.size)]#slots在Hash表中存储Hash表中元素原来在列表中的值

    def hashfunction(self,key):#求取列表元素的散列值，此处使用了简单求余数的办法来实现散列函数；使用数据链的方法来解决冲突
        return (key % self.size)

    def put(self,key,data):  #向散列表中添加元素
        hashvalue = self.hashfunction(key)
        order = 0

        if self.slots[hashvalue][order] == None: #如果想要向hash表中添加数值的位置为空，则直接添加
            self.slots[hashvalue][order] = key
            self.data[hashvalue][order] = data
        else:#如果想要向hash表中添加数值的位置不为空，则判断现在是要更新散列表中的数值还是按照数据链技术做冲突处理
            if self.slots[hashvalue][order] == key:
                self.data[hashvalue][order] = data #这是更新hash表中数值的函数
            else:
                order = order + 1
                while self.slots[hashvalue][order] != None and self.slots[hashvalue][order] != key:#冲突处理
                    order = order + 1
                if self.slots[hashvalue][order] == None:
                    self.slots[hashvalue][order] = key
                    self.data[hashvalue][order] = data
                elif self.slots[hashvalue][order] == key:
                    self.data[hashvalue][order] = data

    def get(self,key):#此函数是按照原列表的索引查找值
        data = None
        stop = False
        found = False
        position = self.hashfunction(key)
        order = 0

        while self.slots[position][order]!=None and not stop and not found:
            if self.slots[position][order] == key:
                found = True
                data = self.data[position]
            else:
                order = order + 1
                if self.slots[position][order] == None:
                    stop = True
        return data

    def __delitem__(self, key):#此函数是按照原列表的索引同时删除散列表中存储的索引和值
        position = self.hashfunction(key)
        order = 0
        stop = False
        while self.slots[position][order] != None and not stop:
            if self.slots[position][order] == key:
                self.slots[position][order] = None
                self.data[position][order] = None
            else:
                order = order + 1
                if self.slots[position][order] == None:
                    stop = True
        if stop:
            raise IndexError("Not Found")

    def __contains__(self,key):#此函数是按照原列表的索引判断该元素是否在散列表中
        position = self.hashfunction(key)
        order = 0
        stop = False
        found = False
        while self.slots[position][order] != None and not stop and not found:
            if self.slots[position][order] == key:
                found = True
            else:
                order = order + 1
                if self.slots[position][order] == None:
                    stop = True
        return found

    def __len__(self):#此函数是返回散列表中有效值的数量
        length = 0
        for i in range(0,self.size):
            for j in range(0,self.size):
                if self.slots[i][j] != None:
                    length = length + 1
        return length

h = HashTable(7)
alist = ['apple','pear','banana','pineapple','watermelon','mango','grape','orange','grass','cucomber','vegetable']
for i in range(len(alist)):
    h.put(i,alist[i])
print(h.slots)
print(h.data)
print(h.__len__())
print(h.__contains__(3))

h.__delitem__(0)
print(h.data)
print(h.__len__())

