#我的算法思路是：首先，在定义一个散列表时，将slots和data都定义成不定长的列表，初始化是先按照预定的散列表长度向两个列表内填充一定量的None
# 每次向散列表中加入元素后，都判断散列表中元素的个数是否等于散列表的长度
# 若两者相等，则在散列表slots和data中再加入一项None，从而延长散列表的长度，这样的话，可以使得散列表不会溢出
class HashTable:
    def __init__(self,length):
        self.size = length
        self.slots=[None]
        self.data=[None]
        for i in range(self.size):
            self.slots.append(None)
            self.data.append(None)

    def hashfunction(self,key):
        return key% self.size

    def rehash(self,oldhash):
        return (oldhash + 1)%self.size

    def get(self,key):
       myslot=self.hashfunction(key)
       data = None
       stop = False
       found = False
       position = myslot
       while self.slots[position] != None and not found and not stop:
           if self.slots[position] == key:
               found = True
               data = self.data[position]
           else:
               position = self.rehash(position)
               if position == myslot:
                   stop = True
       return data

    def put(self,key,data):
        hashvalue = self.hashfunction(key)
        if self.slots[hashvalue] == None:
            self.slots[hashvalue] = key
            self.data[hashvalue] = data
        else:
            if self.slots[hashvalue] == key:
                self.data[hashvalue] = data
            else:
                newslot = self.rehash(hashvalue)
                while self.slots[newslot] != None and self.slots[newslot] != key:
                    newslot = self.rehash(newslot)
                if self.slots[hashvalue] == None:
                    self.slots[hashvalue] = key
                    self.data[hashvalue] = data
                else:
                    self.data[newslot] = data

        if self.__len__() == self.size:  #此处判断散列表中是否已经没有空间
            self.slots.append(None) #若散列表中已没有空间，则自动延长散列表1位
            self.data.append(None)
            self.size += 1

    def __getitem__(self,key):
       return self.get(key)

    def __setitem__(self,key,data):
       return self.put(key,data)

    def __len__(self):
       account=0
       for i in self.slots:
           if i != None:
            account = account + 1
       return account

    def __delitem__(self,key):
       if key in self.slots:
          temp=self.slots.index(key)
          self.slots.pop(temp)
          self.data.pop(temp)
       else:
          raise IndexError("key is not in map")

    def __contains__(self,key):
       if key in self.slots:
           return True
       else:
           return False

h = HashTable(3)
alist = ['apple','pear','banana','pineapple','watermelon','mango','grape','orange','grass','cucomber','vegetable']
print(alist)
for i in range(len(alist)):
    h.put(i,alist[i])
print(h.slots)
print(h.data)
print(h.__len__())
print(h.__contains__(3))
h.__delitem__(0)
print(h.data)
print(h.__len__())