#算法说明
#本算法改进取中值的方法，中值通过计算待操作的列表中最接近所有数字的平均值的那个数来得到，从而能够使所求的中值更接近列表中数字的中位数，从而提高算法效率

import timeit
import random

def midvalue(alist,a,b): #此为取中值函数，中值为距离列表中所有数的平均数取整最小的那个数
    avgvalue = sum(alist[a:b + 1])/(b+1-a)
    avgvalue = int(avgvalue)
    distance = abs(avgvalue - alist[a])
    saveindex = a
    for i in range(a,b+1):  #找出距离平均值最近的那个数
        if distance > abs(avgvalue - alist[i]):
            distance = abs(avgvalue - alist[i])
            saveindex = i
    return saveindex #返回所找到的中值数的索引

def quickSort(alist):
    quickSortHepler(alist,0,len(alist)-1)

def quickSortHepler(alist,first,last):
    if first < last:
        splitpoint = partition(alist,first,last)
        quickSortHepler(alist,first,splitpoint - 1)
        quickSortHepler(alist,splitpoint+1,last)

def partition(alist,first,last):
    middlevalueindex = midvalue(alist,first,last)
    middlevalue = alist[middlevalueindex]
    leftmark = first#leftmark为左侧标记
    rightmark = last#rightmark为右侧标记
    done = False

    while not done: #这里与普通的快速排序算法的操作相同
        while alist[leftmark] <= middlevalue and leftmark <= rightmark:
            leftmark += 1
        while alist[rightmark] > middlevalue and leftmark <= rightmark:
            rightmark -= 1

        if rightmark < leftmark:
            done = True
        else:
            alist[leftmark],alist[rightmark] = alist[rightmark],alist[leftmark]

    for i in range(first,last + 1): #先找出中值，然后将中值与列表中目前位于中间的那个数交换位置(如果列表元素个数为偶数，则与找到的最后一个小于中值的数交换位置
        if alist[i] == middlevalue:
            alist[i], alist[leftmark -1] = alist[leftmark - 1] ,alist[i]
            return leftmark - 1 #返回中值位置的索引


def partition1(alist,first,last): #这一方法使用的是与课件上相同的使用列表第一个数作为中值的快速排序算法
    pivotvalue = alist[first] #在这里作为参照，通过与上一算法比较来具体判断上一算法改进的效果

    leftmark = first + 1
    rightmark = last

    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] < pivotvalue:
            leftmark = leftmark + 1

        while alist[rightmark] >= pivotvalue and rightmark >= leftmark:
            rightmark = rightmark - 1

        if rightmark < leftmark:
            done = True
        else:
            alist[leftmark],alist[rightmark] = alist[rightmark],alist[leftmark]
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return rightmark

def quickSortHepler1(alist,first,last):
    if first < last:
        splitpoint = partition1(alist,first,last)
        quickSortHepler1(alist,first,splitpoint - 1)
        quickSortHepler1(alist,splitpoint+1,last)

def quickSort1(alist):
    quickSortHepler1(alist,0,len(alist)-1)

alist = list()
x = 0
for i in range(random.randrange(100,1000)):
    alist.append(x + random.randrange(-10000,100000))
for j in range(1,10):
    t1 = timeit.Timer("quickSort(alist)","from __main__ import quickSort,alist,j,x")
    time1 = t1.timeit(number = 100)

    t2 = timeit.Timer("quickSort1(alist)", "from __main__ import quickSort1,alist,j")
    time2 = t2.timeit(number=100)
    print("%.5f %.5f"%(time1,time2))
quickSort(alist)
print(alist)
'''
对两种算法进行比较
一组运行的结果如下（左边一列为优化后算法，右边一列为未优化的快排算法（与课件上相同）
0.12124 0.31165
0.11439 0.29869
0.11881 0.31158
0.17704 0.29629
0.11109 0.29631
0.11694 0.31311
0.11699 0.29399
0.11196 0.29961
0.11656 0.31402
可见通过对求中值方法进行优化，排序的时间消耗可以缩小为原先的三分之一到一半，效果显著
'''