from pythonds.basic.stack import Stack

def infixEval(infixstr):    #定义计算中缀表达式的函数
    prec = {}   #规定各个运算符的优先级
    prec["*"] = 3
    prec["/"] = 3
    prec["+"] = 2
    prec["-"] = 2
    prec["("] = 1
    sstack = Stack()    #建立计算符栈
    nstack = Stack()    #建立计算数栈
    tokenlist = infixstr.split()
    for token in tokenlist:     #遍历所有字符
        if token in "0123456789":   #若字符为计算数，则将转化为整数型的数字压到计算数栈中
            nstack.push(int(token))
        elif token == '(':      #若字符为左括号，则将左括号压到计算符栈中
            sstack.push(token)
        elif token == ')':      #若字符为右括号，则弹出计算符栈栈顶元素
            toptoken = sstack.pop()
            while toptoken != '(':
                #当该元素不为左括号时，弹出计算数栈栈顶的两个元素，并进行运算，直到弹出左括号为止
                operand2 = nstack.pop()
                operand1 = nstack.pop()
                result = domath(toptoken, operand1, operand2)   #将这两个元素与此前弹出的运算符做运算
                nstack.push(result)     #将运算结果压回计算数栈顶
                toptoken = sstack.pop()
        else:
            while (not sstack.isEmpty()) and (prec[sstack.peek()] >= prec[token]):
                #当该字符为运算符时，比较计算符栈栈顶元素与该字符的优先级，若大于，则重复上述计算过程
                toptoken = sstack.pop()
                operand2 = nstack.pop()
                operand1 = nstack.pop()
                result = domath(toptoken, operand1, operand2)
                nstack.push(result)
            sstack.push(token)      #当该字符的优先级大于计算符栈栈顶元素的优先级时，将该元素压进栈内
    while not sstack.isEmpty():     #遍历所有字符后，若计算符栈不为空，则重复上述计算过程
        toptoken = sstack.pop()
        operand2 = nstack.pop()
        operand1 = nstack.pop()
        result = domath(toptoken, operand1, operand2)
        nstack.push(result)
    return nstack.pop()     #最终返回计算数栈内最后一个元素（即运算结果）

def domath(op, op1, op2):   #定义计算函数，根据运算符对两个数字进行相应运算
    if op == "*":
        return op1 * op2
    elif op == "/":
        return op1 / op2
    elif op == "+":
        return op1 + op2
    elif op == "-":
        return op1 - op2

print(infixEval("1 + 2 * ( 3 + 4 )"))
