from pythonds.basic.queue import Queue

def radixsort(numbers):     #定义基数排序函数
    numlist = numbers.split()
    mylist = []     #创建一个列表以存储队列
    for i in range(0, 11):      #在列表中创建11个队列，前十个用于存储不同数字，第11个为主队列
        mylist.append(Queue())
    maxlen = 0      #初始化数字最长位数
    for num in numlist:     #遍历所有数字
        mylist[10].enqueue(num)     #将所有数字顺序存储在主队列中
        if len(num) > maxlen:   #计算数字最长的位数
            maxlen = len(num)
    for i in range(1, maxlen+1):    #从个位开始遍历，直到最高位数
        while not mylist[10].isEmpty():     #将主队列中的元素依次出队
            item = mylist[10].dequeue()
            if len(item) < i:   #对于位数不足i的数字，直接入队列0
                mylist[0].enqueue(item)
            else:   #对于位数大于等于i的数字，根据第i位数字入到相应的队列中
                mylist[int(item[len(item)-i])].enqueue(item)
        for j in range(0, 10):      #将十个队列中的数字顺序进入主队列中
            while not mylist[j].isEmpty():
                mylist[10].enqueue(mylist[j].dequeue())
    s = ""  #创建字符串以记录最终的排序结果
    while not mylist[10].isEmpty():     #将主队列中的元素依次加到字符串中
        s += mylist[10].dequeue()
        s += " "
    return s    #返回排好序的字符串

print(radixsort("1 23 456 3 23 7687 98741 678 87 34 6 9880"))
