from pythonds.basic.stack import Stack

def htmlchecker(mystr):     #定义html匹配检查函数
    s = Stack()     #创建一个栈来存储开标记
    balanced = True     #初始化开闭标记是否平衡的参量
    index = 0
    while index < len(mystr) and balanced:  #当开闭标记匹配时，遍历html文件中的每个字符
        str = ""    #创建一个字符串来记录开闭标记的形式
        if mystr[index] == "<" and mystr[index + 1] != "/":
            #当发现开标记的字符串时，从左括号开始遍历之后的字符
            j = index
            while mystr[j] != ">":  #将开标记字符记录在str中，直到出现右括号为止
                str += mystr[j]
                j += 1
            str += ">"  #形成完整的开标记字符串，记录在str中
            s.push(str)     #将开标记压到栈中
            index += len(str)   #从开标记右括号后的字符开始继续遍历整个html文件
        elif mystr[index] == "<" and mystr[index + 1] == "/":
            #当发现闭标记的字符串时，从左括号开始遍历之后的字符
            j = index
            while mystr[j] != ">":  #将闭标记字符记录在str中，直到出现右括号为止
                str += mystr[j]
                j += 1
            str += ">"  #形成完整的闭标记字符串，记录在str中
            if s.isEmpty():     #若栈为空，则没有开标记与闭标记匹配，匹配失败
                balanced = False
            else:   #若栈不为空，则弹出栈顶元素，检查该开标记与闭标记是否匹配
                top = s.pop()
                if not matches(top, str):   #若开闭标记不匹配，则匹配失败，否则继续遍历
                    balanced = False
            index += len(str)   #从闭标记右括号后的字符开始继续遍历整个html文件
        else:
            index += 1  #若不是开闭标记，则继续遍历html文件
    if balanced and s.isEmpty():    #若开闭标记匹配而且栈中没有剩余的开标记，则说明html文件完全匹配
        return True
    else:
        return False

def matches(open, close):   #定义匹配函数，检查开标记和闭标记中的tag字段是否完全一致
    return open[1:] == close[2:]

print(htmlchecker('''<html>
<head>
<title>
Example
</title>
</head>
<body>
<h1>Hello, world</h1>
</body>
</html>'''))