import timeit
import random

def binarySearch(alist, item):  # 带有切片的二分搜索，与课件上的程序相同
    if len(alist) == 0:
        return False
    else:
        midpoint = len(alist)//2
        if alist[midpoint] == item:
            return True
        else:
            if item < alist[midpoint]:
                return binarySearch(alist[:midpoint], item)
            else:
                return binarySearch(alist[midpoint+1:], item)

def newbinarySearch(alist, item, first, last):  # 不带切片的二分搜索，改为传递起始点和终止点
    if first >= last:   # 当起始点在终止点之后时，停止搜索，返回未找到
        return False
    else:   # 当起始点在终止点之前时（即搜索未完成）
        midpoint = (first + last)//2    # 设置中值为起始点和终止点的一半
        if alist[midpoint] == item:     # 若中值点恰好为所查找的对象，直接返回找到
            return True
        else:   # 若中值点不是所查找的对象
            if item < alist[midpoint]:  # 若查找的对象小于中值点，则将终止点设置为中值点的前一个点
                last = midpoint - 1
                return newbinarySearch(alist, item, first, last)    # 递归调用左半部分的列表，继续进行二分搜索
            else:
                first = midpoint + 1    # 若查找的对象大于中值点，则将起始点设置为中值点的后一个点
                return newbinarySearch(alist, item, first, last)    # 递归调用右半部分的列表，继续进行二分搜索

alist = []
num = 0
for i in range(1000000):    # 建立一个百万级别的列表，保证该列表为有序表，单调递增
    num += random.randint(1, 10)
    alist.append(num)
first = 0
last = len(alist) - 1
for j in range(1, 9000000, 90000):  # 对二分搜索的性能进行测试，对不同的搜索对象进行时间测试
    t1 = timeit.Timer("binarySearch(alist, j)", "from __main__ import binarySearch, alist, j")
    t2 = timeit.Timer("newbinarySearch(alist, j, first, last)",
                      "from __main__ import newbinarySearch, alist, j, first, last")
    # 分别记录有切片的二分搜索和无切片的二分搜索的运算时长
    time1 = t1.timeit(number=100)
    time2 = t2.timeit(number=100)
    print("%15.5f %15.5f" % (time1, time2))
    # 具体运算和分析结果见附件中的word文档
