import timeit
import random

def quickSort(alist):   # 与讲义中相同
    quickSortHelper(alist, 0, len(alist) - 1)

def quickSortHelper(alist, first, last):   # 与讲义中相同
    if first < last:
        splitpoint = partition(alist, first, last)
        quickSortHelper(alist, first, splitpoint - 1)
        quickSortHelper(alist, splitpoint + 1, last)

def partition(alist, first, last):   # 与讲义中相同
    pivotvalue = alist[first]
    leftmark = first + 1
    rightmark = last
    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pivotvalue:
            leftmark += 1
        while alist[rightmark] >= pivotvalue and rightmark >= leftmark:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return rightmark

# 我的算法思路是每次递归调用快排函数前计算整个列表的均值，将与均值最为接近的元素设置为中值

def newquickSort(alist):    # 定义改进后的快排函数
    newquickSortHelper(alist, 0, len(alist) - 1)

def newquickSortHelper(alist, first, last):     # 定义改进后的快排助手
    if first < last:
        splitpoint = newpartition(alist, first, last)
        newquickSortHelper(alist, first, splitpoint - 1)
        newquickSortHelper(alist, splitpoint + 1, last)

def midindex(alist, first, last):   # 定义取中值函数
    sum = 0
    for i in range(first, last + 1):    # 计算列表中元素总和
        sum += alist[i]
    average = sum // (last - first + 1)     # 计算平均数
    pos = first
    for j in range(first, last + 1):    # 找到列表中与平均数最近的元素
        if abs(alist[j] - average) < abs(alist[pos] - average):
            pos = j
    return pos

def newpartition(alist, first, last):   # 定义新的分裂函数
    pivotindex = midindex(alist, first, last)   # 通过中值函数找到中值的位置
    alist[first], alist[pivotindex] = alist[pivotindex], alist[first]   #将中值换到列表头
    pivotvalue = alist[first]   # 以下与课件完全相同
    leftmark = first + 1
    rightmark = last
    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pivotvalue:
            leftmark += 1
        while alist[rightmark] >= pivotvalue and rightmark >= leftmark:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return rightmark

alist1 = []
x = 10000
for i in range(1000):   # 构建两个相同的列表用于测试函数性能
    alist1.append(x + random.randint(-1000, 1000))
alist2 = alist1
for j in range(20):
    t1 = timeit.Timer("quickSort(alist1)", "from __main__ import quickSort, alist1")
    t2 = timeit.Timer("newquickSort(alist2)", "from __main__ import newquickSort, alist2")
    # 分别计算两个快排函数的时长
    time1 = t1.timeit(number=100)
    time2 = t2.timeit(number=100)
    print("%15.5f %15.5f" % (time1, time2))
    # 具体分析结果见附件中的word文档
