class HashTable:    # 定义映射类

    def __init__(self):     # 与讲义中相同
        self.size = 11
        self.slots = [None] * self.size
        self.data = [None] * self.size

    def hashfunction(self, key):    # 与讲义中相同
        return key % self.size

    def rehash(self, oldhash):    # 与讲义中相同
        return (oldhash + 1) % self.size

    def put(self, key, data):   # 定义加入键值对函数
        threshold = 0.8     # 设置阈值
        hashvalue = self.hashfunction(key)
        if self.slots[hashvalue] is None:   # 以下部分与讲义相同
            self.slots[hashvalue] = key
            self.data[hashvalue] = data
        else:
            if self.slots[hashvalue] == key:
                self.data[hashvalue] = data
            else:
                newslot = self.rehash(hashvalue)
                while self.slots[newslot] is not None and self.slots[newslot] != key:
                    newslot = self.rehash(newslot)
                if self.slots[newslot] is None:
                    self.slots[newslot] = key
                    self.data[newslot] = data
                else:
                    self.data[newslot] = data
        # 长度自动增长
        num = 0
        for item in self.slots:     # 计算列表中非空的槽的个数
            if item is not None:
                num += 1
        if num / self.size >= threshold:    # 比较负载因子与阈值
            self.size += 1  # 若负载因子超过阈值，槽个数加一，相应列表变长
            self.slots.append(None)
            self.data.append(None)

    def get(self, key):     # 定义取值函数（基本与讲义上相同）
        startslot = self.hashfunction(key)
        data = None
        stop = False
        found = False
        position = startslot
        while not found and not stop:   # 由于增长的槽可能为空，因此必须遍历整个列表才能判断key是否在其中
            if self.slots[position] == key:
                found = True
                data = self.data[position]
            else:
                position = self.rehash(position)
                if position == startslot:
                    stop = True
        return data

    def __getitem__(self, key):    # 与讲义中相同
        return self.get(key)

    def __setitem__(self, key, data):    # 与讲义中相同
        return self.put(key, data)

# 测试用例
H = HashTable()
H[54] = "cat"
H[26] = "dog"
H[93] = "lion"
H[17] = "tiger"
H[77] = "bird"
H[31] = "cow"
H[44] = "goat"
H[55] = "pig"
print(H.slots)
print(H.data)
H[20] = "chicken"
H[64] = "fish"
H[75] = "sheep"
H[90] = "elephant"
print(H.slots)
print(H.data)
print(H[44])