class HashTable:    # 创建map类

    def __init__(self):     # 定义初始化函数
        self.size = 11
        self.slots = [[None] for i in range(self.size)]     # 创建一个二维列表以保存key
        self.data = [[None] for i in range(self.size)]      # 创建一个二维列表以保存data

    def hashfunction(self, key):    # 与讲义中相同
        return key % self.size

    def put(self, key, data):   # 定义加入键值对函数
        hashvalue = self.hashfunction(key)  # 计算key的散列值
        if self.slots[hashvalue] == [None]:  # 若对应的槽为空，则将key作为该槽的第一个元素，同时将data记录到对应位置
            self.slots[hashvalue] = [key]
            self.data[hashvalue] = [data]
        else:   # 若对应的槽不为空
            if key in self.slots[hashvalue]:    # 若key已在对应槽的列表中，则更新data表中的对应数据
                self.data[hashvalue][self.slots[hashvalue].index(key)] = data
            else:   # 若key不在对应槽的列表中，则分别将key和data加入对应列表中
                self.slots[hashvalue].append(key)
                self.data[hashvalue].append(data)

    def get(self, key):     # 定义取值函数
        pos = self.hashfunction(key)    # 计算key的散列值
        if key in self.slots[pos]:  # 判断key是否在对应槽的列表中
            return self.data[pos][self.slots[pos].index(key)]   # 若存在，直接返回该key对应的data
        else:
            return None     # 若不存在，返回None

    def __delitem__(self, key):     # 定义删除函数
        hashvalue = self.hashfunction(key)  # 计算key的散列值
        pos = self.slots[hashvalue].index(key)  # 记录key在对应槽中的位置
        self.slots[hashvalue].pop(pos)  # 删除key和data的键值对
        self.data[hashvalue].pop(pos)

    def __len__(self):  # 定义长度函数
        num = 0
        for alist in self.slots:    # 遍历所有槽，计算非空元素的个数
            for item in alist:
                if item is not None:
                    num += 1
        return num

    def __contains__(self, key):    # 定义in函数
        found = False   # 初始化参量
        for alist in self.slots:    # 遍历所有槽，返回key是否在槽中
            if key in alist:
                found = True
        return found

    def __getitem__(self, key):     # 与讲义中相同
        return self.get(key)

    def __setitem__(self, key, data):   # 与讲义中相同
        self.put(key, data)

# 测试用例，与讲义上的例子相同
H = HashTable()
H[54] = "cat"
H[26] = "dog"
H[93] = "lion"
H[17] = "tiger"
H[77] = "bird"
H[31] = "cow"
H[44] = "goat"
H[55] = "pig"
H[20] = "chicken"
print(H.slots)
print(H.data)
print(len(H))
print(77 in H)
print(H[20])
H[20] = "duck"
print(H[20])
print(H[99])
del H[77]
print(H.slots)
print(H.data)



