class HashTable:
    def __init__(self,num):
        self.size = 11
        self.hushnum = num
        self.length = 0
        self.slots = [[None for i in range(self.hushnum)] for i in range(self.size)]
        self.data = [[None for i in range(self.hushnum)] for i in range(self.size)]
    def hashfunction(self, key, size):
        return key % size

    def put(self, key, data):
        hashvalue = self.hashfunction(key, self.size)
        i=0
        while i<self.hushnum:
            if self.slots[hashvalue][i] == None:
                self.slots[hashvalue][i] = key
                self.data[hashvalue][i] = data
                self.length=self.length+1
                break
            if self.slots[hashvalue][i] == key:
                self.data[hashvalue][i] = data  # 重写覆盖
                break
            i=i+1
        if i==self.hushnum:
            raise IndexError("The Hushtable is full!")

    def get(self, key):
        i=0
        hashvalue = self.hashfunction(key, self.size)
        while i<self.hushnum:
            if self.slots[hashvalue][i]==key:
                return self.data[hashvalue][i]
            i=i+1
        return None
    def __contains__(self, key):
        hashvalue = self.hashfunction(key, self.size)
        return key in self.slots[hashvalue]
    def __getitem__(self, key):
        return self.get(key)
    def __setitem__(self, key, data):
        self.put(key, data)
    def __str__(self):#返回HashTable的字符串表示形式 #使print(m)可行
        list_item=[]
        for i in range(self.size):
            for j in range(self.hushnum):
                if self.slots[i][j]!=None:
                    list_item.append((self.slots[i][j],self.data[i][j]))
        return 'dict_values(%s)' % (list_item)
    def __len__(self):#返回已经占用的长度
        return self.length
    def __delitem__(self, key): #删除某一个键#使del m[X]可行
        i=0
        hashvalue = self.hashfunction(key, self.size)
        while i<self.hushnum:
            if self.slots[hashvalue][i] == key:
                self.slots[hashvalue][i] = None
                self.data[hashvalue][i] = None
                self.length=self.length-1
                break
            i=i+1


num=int(input("输入数据链长度:（注意测试数据要求长度大于3，否则报错）\n"))

#测试Map()和__str__:
hash=HashTable(num)
print(hash)
#dict_values([])

#测试put()和get()：
hash.put(0,"o")
hash.put(1,"a")
hash.put(2,"b")
hash.put(3,"c")
hash.put(4,"d")
hash.put(5,"e")
hash.put(6,"f")
print([hash.get(i) for i in range(10)])
#['o', 'a', 'b', 'c', 'd', 'e', 'f', None, None, None]
hash[1]="GPA"
hash[3]="SESS"
print([hash.get(i) for i in range(10)])
#['o', 'GPA', 'b', 'SESS', 'd', 'e', 'f', None, None, None]

#测试 __setitem__：
hash[11]="oo"
hash[22]="ooo"
hash[33]="oooo"
print(hash[11],hash[22],hash[33])
#oo ooo oooo

#测试 __contains__：
print(1 in hash)
#True
print(10 in hash)
#False

#测试__str__和__len__:
print(hash)
#dict_values([(0, 'o'), (11, 'oo'), (22, 'ooo'), (33, 'oooo'), (1, 'GPA'), (2, 'b'), (3, 'SESS'), (4, 'd'), (5, 'e'), (6, 'f')])
print(len(hash))
#10

#测试del:
del hash[11]
print(hash)
#dict_values([(0, 'o'), (22, 'ooo'), (33, 'oooo'), (1, 'GPA'), (2, 'b'), (3, 'SESS'), (4, 'd'), (5, 'e'), (6, 'f')])
print(len(hash))
#9