#三数取中法
def sub_sort(array, low, high):#对一个list进行快排——选出一个中值，并将比中值小的数放在中值左边，大者右边
    m=(low+high)//2
    if (array[low] > array[high]):#保证右端较大
        array[low],array[high]=array[high],array[low]
    if (array[m] > array[high]):#保证右端较大
        array[m], array[high] = array[high], array[m]
    if (array[m] > array[low]):#保证中间最小
        array[low], array[m] = array[m], array[low]
    key = array[low]# 选第一个为中值
    while low < high:
        while low < high and array[high] >= key:  # 当右边数大于中值时，此数位置不变，右边数索引左移一位
            high -= 1
        while low < high and array[high] < key:  # 当右边数小于中值时，此数位置不变，索引左移一位
            array[low] = array[high]  # key值所在位置（左边数）赋值为右边数
            low += 1  # 左边数索引右移一位
            array[high] = array[low]  # “空出来”的右边数赋值为左边数，（空出来的）左边数为key的重新插回留出位置
    array[low] = key  # 插回中值key
    return low  # 返回中指key所在索引
def quick_sort(array, low, high):
    if low < high:
        key_index = sub_sort(array, low, high)  # 给定中值点
        quick_sort(array, low, key_index)  # 以中值点分割，左右分别调用quick_sort()
        quick_sort(array, key_index + 1, high)
def quick_sort_helper(array):  # 排序初设置
    quick_sort(array, 0, len(array) - 1)
#固定基准元法
def sub_sort1(array, low, high):#对一个list进行快排——选出一个中值，并将比中值小的数放在中值左边，大者右边
    m=(low+high)//2
    key = array[low]# 选第一个为中值
    while low < high:
        while low < high and array[high] >= key:  # 当右边数大于中值时，此数位置不变，右边数索引左移一位
            high -= 1
        while low < high and array[high] < key:  # 当右边数小于中值时，此数位置不变，索引左移一位
            array[low] = array[high]  # key值所在位置（左边数）赋值为右边数
            low += 1  # 左边数索引右移一位
            array[high] = array[low]  # “空出来”的右边数赋值为左边数，（空出来的）左边数为key的重新插回留出位置
    array[low] = key  # 插回中值key
    return low  # 返回中指key所在索引
def quick_sort1(array, low, high):
    if low < high:
        key_index = sub_sort1(array, low, high)  # 给定中值点
        quick_sort1(array, low, key_index)  # 以中值点分割，左右分别调用quick_sort()
        quick_sort1(array, key_index + 1, high)
def quick_sort_helper1(array):  # 排序初设置
    quick_sort1(array, 0, len(array) - 1)

import timeit
import random
list = [random.choice(range(1,10000)) for i in range(300)]
list1 = [random.choice(range(1,10000)) for i in range(300)]
print(list,list1)
t = timeit.Timer("quick_sort_helper(list)", "from __main__ import quick_sort_helper,list")
t1 = timeit.Timer("quick_sort_helper1(list1)", "from __main__ import quick_sort_helper1,list1")
print("随机序列三数取中 所用时长为：%f seconds" % (t.timeit(100)))
print("随机序列固定基准元 所用时长为：%f seconds" % (t1.timeit(100)))
print(list,list1)

array = [i for i in range(300)]
array1 = [i for i in range(300)]
print(array,array1)
t = timeit.Timer("quick_sort_helper(array)", "from __main__ import quick_sort_helper,array")
t1 = timeit.Timer("quick_sort_helper1(array1)", "from __main__ import quick_sort_helper1,array1")
print("有序序列三数取中 所用时长为：%f seconds" % (t.timeit(100)))
print("有序序列固定基准元 所用时长为：%f seconds" % (t1.timeit(100)))
print(array,array1)