class hashtable:
    def __init__(self):
        self.size = 11                      #设定hash表的大小
        self.loadfactor = 0.7
        self.slots = [None] * self.size     #两个列表一个存keys一个存data
        self.data = [None] * self.size
        self.len = 0                         #len记录存进去关联对的数量

    def hashfunction(self,key):             #hash的方法，取余
        return key% self.size

    def rehash(self,oldhash):               #rehash
        return (oldhash+1) % self.size

    def put(self,key,data):                 #put方法,来自课件
        hashvalue = self.hashfunction(key)
        if self.slots[hashvalue] == None:
            self.slots[hashvalue] = key
            self.data[hashvalue] = data
            self.len = self.len + 1         #关联对数量加一
        else:
            if self.slots[hashvalue] == key :
                self.data[hashvalue] = data
            else:
                nextslot = self.rehash(hashvalue)
                while self.slots[nextslot] != None and \
                     self.slots[nextslot] != key:
                    nextslot = self.rehash(nextslot)
                if self.slots[nextslot] == None:
                    self.slots[nextslot] = key
                    self.data[nextslot] = data
                    self.len = self.len + 1         #关联对数量加一
                else:
                    self.data[nextslot] = data
        if self.len / self.size > self.loadfactor:  #如果负载超过负载因子，扩张散列表
            self.grow()

    def get(self,key):                          #get方法，来自课件
        startslot = self.hashfunction(key)

        data = None
        stop = False
        found = False
        position = startslot
        while self.slots[position] != None and \
                not found and not stop:
            if self.slots[position] == key:
                found = True
                data = self.data[position]
            else:
                position = self.rehash(position)
                if position == startslot:
                    stop = True
        return data

    def __delitem__(self,key):                                     #重载__delitem__
        self.data[self.data.index(self.get(key))] = None           #使这个key对应位置的key和data变成None
        self.slots[self.slots.index(key)] = None
        self.len = self.len - 1                                     #关联对数量减一

    def __len__(self):                  #重载__len__
        return self.len                 #返回self.len

    def __contains__(self, key):            #重载__contains__
        if self.get(key) != None:       #如果这个key存在
            return True                     #返回True
        else:
            return False                    #否则返回False

    def __getitem__(self,key):              #重载__getitem__
        return self.get(key)

    def __setitem__(self,key,data):         #重载__setitem__
        self.put(key,data)

    def grow(self):                                 #扩张散列表
        temp_slots = [x for x in self.slots if x is not None]   #把slots中非None的元素取出来
        temp_data = [x for x in self.data if x is not None]     #把data中非None的元素取出来
        self.size = self.size * 2 + 1                             #使散列表长度乘2加1
        self.slots = [None] * self.size                           #清空slots和data，以及关联对数量
        self.data = [None] * self.size
        self.len = 0
        for x in temp_slots:                                      #把暂存的slots和data放到扩展了的散列表里
            self.put(x,temp_data[temp_slots.index(x)])


