import timeit
import random

def binarysearch(alist,item):       #课件中的切片二分搜索
    if len(alist) == 0:
        return False
    else:
        midpoint = len(alist) // 2
        if alist[midpoint] == item:
            return True
        else:
            if item < alist[midpoint]:
                return binarysearch(alist[:midpoint],item)
            else:
                return  binarysearch(alist[midpoint + 1 : ],item)

def binarysearch1(alist,start,end,item):    #传入起始结束点的二分搜索
    if start == end+1:                        #如果起始点到了结束点右边，则表明搜索范围已空，没有这个元素
        return False
    else:
        midpoint = ( start + end ) // 2        #中点为起点加结束点地板除2
        if alist[midpoint] == item:             #如果中点的元素等于item，则找到
            return True
        else:                                   #否则，item比中点元素小找中点左侧，item比中点元素大找中点右侧
            if item < alist[midpoint]:
                return binarysearch1(alist,start,midpoint-1,item)
            else:
                return  binarysearch1(alist,midpoint + 1,end, item)


for i in range(10000000,100000001,10000000):
    alist = sorted( random.sample( range(i), 1000000))          #从一千万到一个亿中随机取一百万个数后排序
    #两种搜索方法计时
    binarysearchhhh = timeit.Timer("binarysearch(alist,random.randrange(%d))"%i,"from __main__ import random,binarysearch,alist")
    binarysearch1hhh = timeit.Timer("binarysearch1(alist,0,len(alist)-1,random.randrange(%d))"%i,"from __main__ import random,binarysearch1,alist")
    binarysearch_time = binarysearchhhh.timeit(number=100)              #每种执行100次
    binarysearch1_time = binarysearch1hhh.timeit(number=100)
    print("%d,%10.5f,%10.5f"%(i,binarysearch_time,binarysearch1_time))


