class hashtable:
    def __init__(self):
        self.size = 11                      #设定hash表的大小
        self.slots = [None] * self.size     #两个列表一个存keys一个存data
        self.data = [None] * self.size
        self.len = 0                         #len记录存进去关联对的数量
    def hashfunction(self,key):             #hash的方法，取余
        return key% self.size
    def put(self,key,data):                 #put方法
        hashvalue = self.hashfunction(key)  #取key的hash值
        if self.slots[hashvalue] == None:   #如果这个hash值是空的
            self.slots[hashvalue] = [key]   #把key和data以列表的形式放入各自列表中该hash值的位置，用于数据链冲突解决技术
            self.data[hashvalue] = [data]
            self.len = self.len + 1         #关联对数量加一
        else:
            if key in self.slots[hashvalue] :   #如果这个key已经存在
                self.data[hashvalue][self.slots[hashvalue].index(key)] = data   #对应位置上replace data
            else:                               #如果这个key不存在
                self.slots[hashvalue].append(key)       #在这个hash值处的两个列表后面加上这个key和data
                self.data[hashvalue].append(data)
                self.len = self.len + 1         #关联对数量加一
    def get(self,key):                          #get方法
        hashvalue = self.hashfunction(key)       #取key的hash值
        return self.data[hashvalue][self.slots[hashvalue].index(key)]   #返回这个key对应的data
    def __delitem__(self,key):                                     #重载__delitem__
        hashvalue = self.hashfunction(key)                          #取key的hash值
        del self.data[hashvalue][self.slots[hashvalue].index(key)] #del这个key对应的data
        self.slots[hashvalue].remove(key)                           #remove这个key
        self.len = self.len - 1                                     #关联对数量减一
    def __len__(self):                  #重载__len__
        return self.len                 #返回self.len
    def __contains__(self, key):            #重载__contains__
        hashvalue = self.hashfunction(key)  #取key的hash值
        if key in self.slots[hashvalue]:    #如果这个key存在
            return True                     #返回True
        else:
            return False                    #否则返回False
    def __getitem__(self,key):              #重载__getitem__
        return self.get(key)
    def __setitem__(self,key,data):         #重载__setitem__
        self.put(key,data)


