import random
import timeit

def quickSort(alist):                           #快排，来自课件
    quickSortHelper(alist,0,len(alist)-1)


def quickSortHelper(alist,first,last):
    if first<last:
        splitpoint = partition(alist,first,last)

        quickSortHelper(alist,first,splitpoint-1)
        quickSortHelper(alist,splitpoint+1,last)


def partition(alist,first,last):
    pivotvalue = alist[first]

    leftmark = first+1
    rightmark = last

    done = False
    while not done:

        while leftmark <= rightmark and \
                alist[leftmark] <= pivotvalue:
            leftmark = leftmark + 1

        while alist[rightmark] >= pivotvalue and \
                rightmark >= leftmark:
            rightmark = rightmark - 1

        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp

    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp


    return rightmark


def quickSort1(alist):                      #快排，改变取中值的方法
    quickSortHelper1(alist,0,len(alist)-1)


def quickSortHelper1(alist,first,last):
    if first<last:
        splitpoint = partition1(alist,first,last)

        quickSortHelper(alist,first,splitpoint-1)
        quickSortHelper(alist,splitpoint+1,last)


def partition1(alist,first,last):
    n = random.randrange(len(alist)-1)              #随机取alist中的一个元素作为中值，把它放到列表的首位，之后的代码就和课件中的完全一样了
    pivotvalue = alist[n]
    temp = alist[first]
    alist[first] = alist[n]
    alist[n] = temp

    leftmark = first+1
    rightmark = last

    done = False
    while not done:

        while leftmark <= rightmark and \
                alist[leftmark] <= pivotvalue:
            leftmark = leftmark + 1

        while alist[rightmark] >= pivotvalue and \
                rightmark >= leftmark:
            rightmark = rightmark - 1

        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp

    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp


    return rightmark

for i in range(100,901,100):
    alist = list(range(i))              #生成一个有序的列表
    quickSorttime = timeit.Timer("quickSort(alist)","from __main__ import quickSort,alist")
    quickSort1time = timeit.Timer("quickSort1(alist)","from __main__ import quickSort1,alist")
    quickSort_time = quickSorttime.timeit(number = 100)
    quickSort1_time = quickSort1time.timeit(number = 100)           #比较两种算法的性能
    print("%d,%10.5f,%10.5f"%(i,quickSort_time,quickSort1_time))
for i in range(100,901,100):
    alist = list(range(i))
    random.shuffle(alist)           #生成一个随机的列表
    quickSorttime = timeit.Timer("quickSort(alist)","from __main__ import quickSort,alist")
    quickSort1time = timeit.Timer("quickSort1(alist)","from __main__ import quickSort1,alist")
    quickSort_time = quickSorttime.timeit(number = 1)
    quickSort1_time = quickSort1time.timeit(number = 1)           #比较两种算法的性能
    print("%d,%10.5f,%10.5f"%(i,quickSort_time,quickSort1_time))
