import turtle
import random

def Plates(n): #画出n个盘子的函数
    plates = [turtle.Turtle() for i in range(n)] #先创建n个海龟
    for j in range(n):
        plates[j].penup()
        plates[j].goto(-350, -150+j*21) #盘子按顺序叠在左边的柱子上
        plates[j].shape('square')
        plates[j].shapesize(1, n-j+1) #确定好形状和大小
        #plates[j].color(random.choice(['red', 'black', 'blue', 'pink', 'green', 'purple', 'yellow', 'orange'])) #随机选择颜色…其实不太好看把这句注释掉也好…
    return plates

def Background(): #画背景需要的三个柱子还有底盘（？）
    pen = turtle.Turtle()

    pen.pensize(10)
    pen.penup()
    pen.goto(-500, -160)
    pen.pendown()
    pen.forward(1000) #先画底部

    pen.pensize(6)
    for i in range(3):
        pen.penup()
        pen.goto(-350 + 350*i, -160)
        pen.pendown()
        pen.setheading(90)
        pen.forward(280) #再画三个柱子

class Stack:
    def __init__(self):
        self.items = []

    def isEmpty(self):
        return self.items == []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop()

    def peek(self):
        return self.items[len(self.items)-1]

    def size(self):
        return len(self.items)

def moveTower(fp, tp, wp, poles, plates, n):
    if n >= 1:
        moveTower(fp, wp, tp, poles, plates, n-1)
        moveDisk(fp, tp, poles, plates)
        moveTower(wp, tp, fp, poles, plates, n-1)

def moveDisk(fp, tp, poles, plates):
    movenum = poles[fp].pop()
    plates[movenum].goto(-350+350*fp, 150) #将要移动的盘子提到柱子上方
    plates[movenum].goto(-350+350*tp, 150) #再移到目标柱子上方
    plates[movenum].goto(-350+350*tp, -150+21*poles[tp].size())
    poles[tp].push(movenum)

Background()
n = int(input()) #输入汉诺塔的层数
plates = Plates(n) #画出n个盘子
poles = [Stack() for i in range(3)] #每个柱子创建为一个栈
for j in range(n):
    poles[0].push(j) #第一个柱子中存入n个盘子
moveTower(0, 2, 1, poles, plates, n) #完美地开始表演
