import random
from timeit import Timer
def binarySearch1(alist,item):
    # 这是经由切片实现的二分搜索法
    if len(alist)==0:
        return False
    else:
        midpoint = len(alist)//2
        # 选择中点
        if alist[midpoint]==item:
            return True
        else:
        # 如果item比中点值小,就调用左边部分;否则调用右边部分
            if item < alist[midpoint]:
                return binarySearch1(alist[:midpoint],item)
            else:
                return binarySearch1(alist[midpoint+1:],item)
def binarySearch2(alist,first,last,item):
    # 这是不使用切片实现的二分搜索法
    if first > last:
        return False
    else:
        midpoint = (first + last) // 2
        # 选择中点
        if alist[midpoint] == item:
            return True
        else:
        # 如果item比中点值小,就调用左边部分;否则调用右边部分
            if item < alist[midpoint]:
                return binarySearch2(alist,first,midpoint-1,item)
            else:
                return binarySearch2(alist,midpoint+1,last, item)

n = random.randint(1000000, 10000000)
test = [i for i in range(n)]
# 生成测试用有序表,范围从一百万到一千万
num = random.randint(0, 2 * n)
# 随机生成要查找的数据，有一半几率在表中
t1 = Timer('binarySearch1(test,num)', 'from __main__ import binarySearch1,test,num')
t2 = Timer('binarySearch2(test,0,n-1,num)', 'from __main__ import binarySearch2,test,n,num')
print('测试列表的大小为%d，需要查找的数据为%d' % (n, num))
print('数据项在表中：%s，利用切片实现的查找用时（执行100次）为：%fs' \
      % (binarySearch1(test, num), t1.timeit(100)))
print('数据项在表中：%s，不利用切片实现的查找用时（执行100次）为：%fs' \
      % (binarySearch2(test, 0, n - 1, num), t2.timeit(100)))