from timeit import Timer
import random
import sys
sys.setrecursionlimit(1000000)
# 由于存在倒序表排序，需要增加递归深度
def quickSort(s):
    alist = list(s)
    quickSortHelper(alist,0,len(alist)-1)
    return alist
    # 简化函数参数
def quickSortHelper(alist,first,last):
    if first < last:
        splitpoint = partition(alist,first,last)
        quickSortHelper(alist,first,splitpoint-1)
        quickSortHelper(alist,splitpoint+1,last)
    # 调用中点前面和后面的列表，并且执行快排
def partition(alist,first,last):
    n = 1
    # n的大小可以调节
    point = []
    for i in range(n):
        point.append(random.choice(alist))
    pivotvalue = get_median(point)
    # 随机取n个数，将这n个数字的中位数作为中值
    leftmark = first + 1
    rightmark = last

    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pivotvalue:
            leftmark += 1
        while rightmark >= leftmark and alist[rightmark] >= pivotvalue:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            alist[leftmark],alist[rightmark] = alist[rightmark],alist[leftmark]
    alist[first], alist[rightmark] = alist[rightmark], alist[first]
    return rightmark
def get_median(point):
    point.sort()
    return point[len(point)//2]
    # 返回一个列表的中位数
for i in range(10):
    test_list1 = list(range(100*(i+1)))
    test_list2 = test_list1[::-1]
    # 创建倒序表
    random.shuffle(test_list1)
    # 创建乱序表
    t1 = Timer('quickSort(test_list1)', 'from __main__ import quickSort,test_list1')
    t2 = Timer('quickSort(test_list2)', 'from __main__ import quickSort,test_list2')
    print('测试列表大小为%d' % (100*(i+1)))
    print('乱序表快排用时为：%fs' % t1.timeit(100))
    print('倒序表快排用时为：%fs' % t2.timeit(100))