class HashTable:
    def __init__(self):
        self.size = 11
        self.slots = [[]for i in range(self.size + 1)]
        self.data = [[]for i in range(self.size + 1)]
    # 采用数据链的冲突解决技术,故键与值都存在列表中
    def hashfunction(self,key):
        return key % self.size
    def put(self,key,data):
        hashvalue = self.hashfunction(key)
        if key not in self.slots[hashvalue]:
        # 如果这个键不存在于对应槽中,就添加之,并且添加相应的值
            self.slots[hashvalue].append(key)
            self.data[hashvalue].append(data)
        else:
        # 如果这个键已存在于对应槽中,就用新的值替换原来的值
            self.data[hashvalue][self.slots[hashvalue].index(key)] = data #replace
    def get(self,key):
        hashvalue = self.hashfunction(key)
        if key in self.slots[hashvalue]:
        # 如果这个键已存在于对应槽中,就返回对应位置的值
            return self.data[hashvalue][self.slots[hashvalue].index(key)]
        else:
        # 否则返回None
            return None
    def __setitem__(self, key, data):
        self.put(key,data)
    def __getitem__(self, key):
        return self.get(key)
    # 实现put和get的魔术方法
    def __delitem__(self, key):
        hashvalue = self.hashfunction(key)
        index = self.slots[hashvalue].index(key)
        # 得到key在这个槽中的位置
        self.slots[hashvalue].pop(index)
        # 删除对应的键
        self.data[hashvalue].pop(index)
        # 删除对应的值
    def __len__(self):
        count = 0
        for x in range(self.size + 1):
        # 从头至尾遍历槽
            count += len(self.slots[x])
        # 每次count增加槽（用来存放键的列表）中元素的数量
        return count
    def __contains__(self, key):
        hashvalue = self.hashfunction(key)
        return key in self.slots[hashvalue]
        # 如果这个键存在于对应槽中,就返回True；否则返回False

# 以下为测试代码
test = HashTable()
test.put(1,99)
test.put(2,98)
test.put(13,97)
test[24] = 96
test.put(3,90)
print('现在键值对个数为：%d' % len(test))
print('键24对应的值为%d\n键2对应的值为%d'\
    % (test.get(24),test[2]))
print('13在表中：%s，14在表中：%s'%(13 in test,14 in test))
del test[2]
print('2在表中：%s'% (2 in test))
print('现在键值对个数为：%d' % len(test))
# 经测试，以上方法都能实现
