#inport
import turtle
import random

#定义笔直的枝干
def line(lineLen,t,lineSize):
    # 设置颜色
    t.color("black")
    # 设置枝干初始粗细
    t.pensize(lineSize)
    # 设置枝干的弯曲方式和粗细变化
    t.fd(lineLen)
    if lineLen > 30:
        line(lineLen - 6, t, lineSize - 1)
    if lineLen > 5 and lineLen <= 30:
        line(lineLen - 4, t, lineSize - 1.5)

#定义弯曲的枝干
def arc(arcLen,t,arcSize):
    #设置颜色
    t.color("black")
    #设置枝干初始粗细
    t.pensize(arcSize)
    #设置枝干的弯曲方式和粗细变化
    t.fd(arcLen)
    if arcLen > 30:
        t.rt(5)
        arc(arcLen - 6,t,arcSize)
    if arcLen > 5 and arcLen <= 30:
        t.lt(5)
        arc(arcLen - 4,t,arcSize - 1)

#定义树的第一部分（二叉）
def part1(branchLen,t,branchSize):
    #设置递归的终止条件
    if branchLen > 5:
        #设置颜色
        if branchLen > 15:
            t.color("black")
        elif branchLen <= 15 and branchLen > 8:
            t.color("green")
        else:
            t.color(30,213,15)
        #设置参数
        r_angle = random.randint(10, 15)
        l_angle = random.randint(10, 15)
        r_dl = 3
        l_dl = 5
        t.pensize(branchSize)
        #画一画
        t.fd(branchLen)
        t.rt(r_angle)
        part1(branchLen - r_dl, t ,branchSize / 1.3)
        t.lt(r_angle + l_angle)
        part1(branchLen - l_dl, t ,branchSize / 1.3)
        t.rt(l_angle)
        t.up()
        t.bk(branchLen)
        t.down()

#定义树的第二部分（三叉）
def part2(branchLen,t):
    # 设置递归的终止条件
    if branchLen > 5:
        # 设置颜色
        if branchLen > 15:
            t.color("black")
        elif branchLen <= 15 and branchLen > 8:
            t.color("green")
        else:
            t.color(30,213,15)
        # 设置参数
        r_angle = random.randint(5,10)
        l_angle = random.randint(100,105)
        m_angle = random.randint(30,35)
        r_dl = 3
        l_dl = 8
        m_dl = 4
        t.pensize(branchLen / 4)
        #画一画
        t.fd(branchLen)
        t.rt(r_angle)
        part2(branchLen - r_dl, t)
        t.lt(r_angle + l_angle)
        part2(branchLen - l_dl, t)
        t.rt(l_angle - m_angle)
        part2(branchLen - m_dl, t)
        t.rt(m_angle)
        t.up()
        t.bk(branchLen)
        t.down()

#定义画法
def main():
    # 屏幕设置
    myWin = turtle.Screen()
    myWin.colormode(255)
    myWin.screensize(1200, 800)
    #海龟t
    t = turtle.Turtle()
    #暴走所需
    turtle.tracer(0)
    #设置起始点与起始方向
    t.up()
    t.setpos(-300,-350)
    t.seth(90)
    t.down()
    #调用函数画主干
    line(50,t,35)
    #调用函数画主树冠
    part1(45,t,20)
    #调用函数画侧枝1
    t.up()
    t.setpos(-300,-60)
    t.down()
    t.seth(10)
    arc(40, t,15)
    part2(30,t)
    t.down()
    # 调用函数画侧枝2
    t.up()
    t.setpos(-300, -200)
    t.down()
    t.seth(10)
    arc(60, t, 20)
    part2(35, t)
    t.down()
    # 调用函数画侧枝3
    t.up()
    t.setpos(-300, -200)
    t.down()
    t.seth(0)
    arc(40, t, 18)
    part2(30, t)
    t.down()
    # 调用函数画侧枝4
    t.up()
    t.setpos(-300, -230)
    t.down()
    t.seth(-20)
    arc(20, t, 15)
    part2(32, t)
    t.down()
    # 调用函数画侧枝5
    t.up()
    t.setpos(-300, -80)
    t.down()
    t.seth(120)
    arc(10, t, 10)
    part2(20, t)
    t.down()
    # 调用函数画侧枝6
    t.up()
    t.setpos(-300, -150)
    t.down()
    t.seth(150)
    arc(15, t, 10)
    part2(25, t)
    t.down()
    # 调用函数画侧枝7
    t.up()
    t.setpos(-300, -40)
    t.down()
    t.seth(30)
    arc(15, t, 10)
    part2(20, t)
    t.down()
    # 暴走所需
    turtle.update()
    #屏幕显示
    myWin.exitonclick()

#突然发现各种侧枝可以简化成定义一个函数，然后反复调用，无奈没时间改了
main()