from pythonds.basic.stack import Stack


def calculator(expr):
    prec = {"*": 3, "/": 3, "+": 2, "-": 2, "(": 1}
    opStack = Stack()
    numStack = Stack()
    tokenlist = expr.split()
    for token in tokenlist:
        if token in "0123456789":
            numStack.push(int(token))                       #如果是数字就压入numStack
        elif token == '(':
            opStack.push(token)
        elif token == ')':
            topToken = opStack.pop()
            while topToken != '(':
                oper(numStack, topToken)                    #每次从opStack倒出运算符是就调用oper计算一次
                topToken = opStack.pop()
        else:
            while (not opStack.isEmpty()) and \
                    (prec[opStack.peek()] >= prec[token]):
                oper(numStack, opStack.pop())
            opStack.push(token)
    while not opStack.isEmpty():
        oper(numStack, opStack.pop())
    return numStack.pop()                                   #返回numStack最后一个数字即运算结果

def doMath(op, op1, op2):
    if op == "*":
        return op1 * op2
    elif op == "/":
        return op1 / op2
    elif op == "+":
        return op1 + op2
    else:
        return op1 - op2


def oper(numStack,topToken):
    a = numStack.pop()
    b = numStack.pop()
    c = doMath(topToken, b, a)
    numStack.push(c)                                        #从numStack倒出两个数并计算结果再压入numStack


print(calculator(input()))