#双链表结构
class d_Node: #添加prev变量，引用前一个节点
    def __init__(self, initdata):
        self.data = initdata
        self.next = None
        self.prev = None

    def getData(self):
        return self.data

    def getNext(self):
        return self.next

    def getPrev(self):
        return self.prev

    def setData(self, newdata):
        self.data = newdata

    def setNext(self, newnext):
        self.next = newnext

    def setPrev(self,newprev):
        self.prev = newprev

class d_UnorderedList: #增加tail变量，引用列表中的最后一个节点
    def __init__(self):
        self.head = None
        self.tail = None
    def isEmpty(self):
        return self.head == None
    def append(self,item):
        temp = d_Node(item)
        if self.isEmpty():
            self.head = temp
            temp.setnext(self.tail)
        else:
            self.tail = temp

    def add(self,item):
        temp = d_Node(item)
        if self.isEmpty():
            self.head = temp
            temp.setnext(self.tail)
        else:
            temp.setNext(self.head)
            self.head = temp

#由d_Node组成的双向列表在remove、pop等方法时不需要一直维护current的前一个节点
    def remove(self, item):
        current = self.head
        found = False
        while not found:
            if current.getData() == item:
                found = True
            else:
                current = current.getNext()
        previous = current.getPrev()
        if previous == None:
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext)#前一个节点的next指向current的下一个节点即删除

    def pop(self, index):
        current = self.head
        num = 0
        while num != index:
            current = current.getNext()
            num = num + 1
        previous = current.getPrev() #找到current后再获取前一个节点信息
        if previous == None: #空列表的特殊情况
            self.head = current.getNext()
        else:
            previous.setNext(current.getNext())

    def insert(self, pos, item): #在pos位置插入item
        temp = d_Node(item)
        current = self.head
        num = 0 #num标记current的位置
        while pos != num:
            current = current.getNext()
            num = num + 1
        previous = current.getPrev()  # 找到current后再获取前一个节点
        if previous == None: #插入表头特殊情况
            temp.setNext(current)
            self.head = temp
        else:
            temp.setNext(current)
            previous.setNext(temp)