class Node:#节点的定义
    def __init__(self,initdata):#节点中含有data和next两个变量
        self.data=initdata
        self.next=None
    def getData(self):#取节点的值的操作
        return self.data
    def getNext(self):#读取节点的指向的操作
        return self.next
    def setData(self,newdata):#节点赋值
        self.data=newdata
    def setNext(self,newnext):#节点连接下一个节点
        self.next=newnext

class UnorderedList:#无序表的定义
    def __init__(self):
        self.head=None

    def add(self,item):#add操作
        temp=Node(item)
        temp.setNext(self.head)
        self.head=temp

    def append(self, item):#append操作
        current = self.head#current为遍历无序表的变量
        if(current!=None):#若一开始不是空表
            while (current.getNext() != None):#如果current没有到表尾
                current = current.getNext()#current前进到链表的下一个节点
            temp = Node(item)#temp为将item转换为节点
            current.setNext(temp)#将表尾连接temp
        else:#若一开始就是空表
            temp = Node(item)#temp为将item转换为节点
            self.head = temp#将表头连接temp

    def index(self, item):#index操作
        current = self.head#current为遍历无序表的变量
        found = False#found为是否找到item的布尔值，初始值为False
        position = 0#position为表示位置的变量，初始位置为0
        while (not found and current != None):#若没找到item且没有到表尾
            if current.getData() == item:#如果current的值就是item
                found = True#found值变为True，，找到对象
            else:
                current = current.getNext()#否则的话current前进到下一个节点
                position += 1#同时把位置加1
        if found:#如果找到了
            return position#将位置返回
        else:
            return 'Not found'#否则输出Not found

    def pop(self):#定义pop操作
        current = self.head#current为遍历无序表的变量
        previous = None#previous为current先前的值，初始值为空
        while (current.getNext() != None):#如果没有到表尾
            previous = current#将previous变为current,previous前进
            current = current.getNext()#current前进道下一个节点
        if previous == None:#若原链表只有一个值
            self.head = None#直接链表头指向空值
        else:#若链表有多个值
            previous.setNext(None)#将previous指向空值,previous成为新的表尾
        return current.getData()#同时返回current的数值

    def insert(self,pos,item):#定义insert变量
        current=self.head#current为遍历无序表的变量
        previous=None#previous为current先前的值，初始值为空
        postion=0#position为表示位置的变量，初始位置为0
        temp = Node(item)#temp为将item转换为节点
        while(postion!=pos):#如果还没有到插入位置
            previous=current#将previous变为current,previous前进
            current=current.getNext()#current前进道下一个节点
            postion+=1#位置值自增1
        previous.setNext(temp)#到了插入位置之后，previous的下一个node变为temp
        temp.setNext(current)#temp的下一个node变为current

    def __str__(self):#转换成字符串操作
        s='['#返回生成的字符串，初始为'['
        current = self.head#current为遍历无序表的变量
        while(current.getNext()!=None):#若没有到表尾
            s = s + '%s,' % (current.getData())#将s增加当前current的值，再加上一个,
            current=current.getNext()#current前进道下一个节点
        else:
            s+='%s' % (current.getData())#将s增加当前current的值，不加,
        s+=']'#s加上']'
        return  s#返回s

    def __getitem__(self, item):#定义链表的切片，此处item为切片slice类型
        if isinstance(item,slice):#isinstance函数，判断变量类型，如果item变量是slice切片类型，返回True值
            start=item.start#切片的start
            stop=item.stop#切片的stop
            newList=UnorderedList()#生成返回的链表
            L=[]#L为切片的列表
            current=self.head#current为遍历无序表的变量
            for i in range(stop):#i为遍历值，从0到stop值
                if i>=start:#如果i大于等于strat，开始操作
                    L.append(current.getData())#L中加上current的值
                current=current.getNext()#current前进道下一个节点
            L.reverse()#将列表L翻转
            for i in L:#对于现在的L中的每一个值
                newList.add(i)#将newList加上i，调用add函数
        return newList#返回newList
