class Node():
    def __init__(self,data):
        self.data = data
        self.next = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self,newdata):
        self.data = newdata
    def setNext(self,newnext):
        self.next = newnext
    #在栈的构建中同样引入lsize来表示其所含元素个数
class Stack():
    def __init__(self):
        self.head = None
        self.lsize = 0
    def push(self,item):#将该元素放在栈顶，即第一个节点
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp
        self.lsize+=1
    def pop(self):#将第一个节点中的元素删除并返回
        current = self.head
        self.head = current.getNext()
        self.lsize-=1
        return current.getData()
    def peek(self):#将第一个节点中的元素读出
        return self.head.getData()
    def isEmpty(self):#判断栈是否为空
        return self.head==None
    def size(self):#判断栈中元素个数
        return self.lsize
    #创建队列的过程中我也加入了lsize来表示队列大小
class Queue():
    def __init__(self):
        self.head = None
        self.lsize = 0
    def enqueue(self,item):#将元素加入队列的第一个节点中
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp
        self.lsize+=1
    def dequeue(self):#从最后一个节点移除元素
        current = self.head
        previous = None
        if current.getNext()==None:#对只有一个元素的队列单独讨论
            self.head = None
        else:
            while current.getNext()!=None:
                previous = current
                current = current.getNext()
            previous.setNext(None)
        self.lsize-=1
        return current.getData()
    def isEmpty(self):#判断队列是否为空
        return self.head==None
    def size(self):#判断队列中元素个数
        return self.lsize
# 以下是我用来检验是否正确时所采用的
a = Stack()
b= Queue()
b.enqueue(123)
b.enqueue(134)
a.push(1)
a.push(2)
print(a.pop())
print(a.pop())
print(a.isEmpty())
print(b.dequeue())
print(b.dequeue())
print(b.isEmpty())
print(a.size())
print(b.size())