# coding=utf-8
# 希尔伯特曲线

import turtle

def Hilbert(layer,size,pen,clockwise=1):
    # 递归绘制希尔伯特曲线
    # layer为层数；size为线度参量；pen为海龟；clockwise为是否顺时针绘制（左进右出）
    if layer==0:  # 终止条件
        if clockwise==1:
            pen.forward(size)
            pen.right(90)
            pen.forward(size)
            pen.right(90)
            pen.forward(size)
        else:
            pen.forward(size)
            pen.left(90)
            pen.forward(size)
            pen.left(90)
            pen.forward(size)
    elif layer%2==1:  # 层数为奇数
        if clockwise==1:
            pen.right(90)
            Hilbert(layer-1,size/2,pen,-1)
            pen.right(90)
            pen.forward(size/(2**layer))
            Hilbert(layer-1, size/2, pen,1)
            pen.left(90)
            pen.forward(size/(2**layer))
            pen.left(90)
            Hilbert(layer-1, size/2, pen,1)
            pen.forward(size/(2**layer))
            pen.right(90)
            Hilbert(layer-1, size/2, pen,-1)
        else:
            pen.left(90)
            Hilbert(layer - 1, size / 2, pen, 1)
            pen.left(90)
            pen.forward(size / (2**layer))
            Hilbert(layer - 1, size / 2, pen, -1)
            pen.right(90)
            pen.forward(size / (2**layer))
            pen.right(90)
            Hilbert(layer - 1, size / 2, pen, -1)
            pen.forward(size / (2**layer))
            pen.left(90)
            Hilbert(layer - 1, size / 2, pen, 1)
    else:  # 层数为偶数，机制与奇数略有不同。
        if clockwise==1:
            pen.right(90)
            Hilbert(layer-1,size/2,pen,-1)
            pen.forward(size/(2**layer))
            Hilbert(layer-1, size/2, pen,1)
            pen.forward(size/(2**layer))
            pen.left(90)
            Hilbert(layer-1, size/2, pen,1)
            pen.right(90)
            pen.forward(size/(2**layer))
            pen.right(90)
            Hilbert(layer-1, size/2, pen,-1)
        else:
            pen.left(90)
            Hilbert(layer - 1, size / 2, pen, 1)
            pen.forward(size/(2**layer))
            Hilbert(layer - 1, size /2, pen, -1)
            pen.forward(size /(2**layer))
            pen.right(90)
            Hilbert(layer - 1, size /2, pen, -1)
            pen.left(90)
            pen.forward(size /(2**layer))
            pen.left(90)
            Hilbert(layer - 1, size /2, pen, 1)



frac=turtle.Turtle()
scr=turtle.Screen()
frac.up()
frac.backward(192)
frac.left(90)
frac.backward(192)
frac.down()
# 移动到屏幕左下处
Hilbert(4,256,frac)
scr.exitonclick()