# coding=utf-8
# 汉诺塔可视化
# 输入：盘片数，由于柱子和盘片大小限制，要求不超过24
# 请全屏观看

import turtle
import time

class platestack:
    # 扩展后的栈
    def __init__(self,x,y):
        self.items = []
        self.x=x
        self.y=y
        # 绘制柱子（此创意来自beerbread特此鸣谢）
        pole=turtle.Turtle()
        pole.pensize(5)
        pole.up()
        pole.goto(x,y)
        pole.down()
        pole.forward(50)
        pole.backward(100)
        pole.forward(50)
        pole.left(90)
        pole.forward(450)
        pole.hideturtle()
    def push(self, item):
        self.items.append(item)
        item.setposition(self.x,self.y+12+20*(self.size()-1))
    def pop(self):
        return self.items.pop()
    def size(self):
        return len(self.items)

colorlist=["red","orange","yellow","aqua","green","blue",\
           "indigo","purple","pink","brown","black","gray"]

def Hanoi(layer,pfrom,pto,pvia):
    if layer>=1:
        Hanoi(layer-1,pfrom,pvia,pto)
        time.sleep(1)  # 停止1秒
        Move(pfrom,pto)
        Hanoi(layer-1,pvia,pto,pfrom)

def Move(pfrom,pto):
    turtle=pfrom.pop()
    pto.push(turtle)

n=int(input())
A=platestack(-300,-200)
B=platestack(0,-200)
C=platestack(300,-200)  # 三个柱子
for i in range(n):
    plate=turtle.Turtle()
    plate.shape("square")
    plate.shapesize(1,10*(n+1-i)/n)
    plate.fillcolor(colorlist[i%12])
    plate.up()
    A.push(plate)
    # 生成盘片并置入左柱
wnd = turtle.Screen()
Hanoi(n,A,C,B)
wnd.exitonclick()