from pythonds.basic.stack import Stack

def minEditDistance(target,source,procedure):               ###最小编辑距离函数
    m = len(target)
    n = len(source)
    insert = 20      ##插入计分
    delete = 20     ##删除计分
    D = [[0 for j in range(n+1)]for i in range(m+1) ]    ##创建列表记录最小距离（不能用D=[[0]*2]*3,会同时修改多个元素）
    for i in range(m+1):     ##最小规模之插入
        D[i][0] = insert*i
    for j in range(n+1):      ##最小规模之删除
        D[0][j] = delete*j

    for i in range(1, n + 1):       ##考虑目标串前i个字符
        for j in range(1,m+1):         ##考虑源串前j个字符

            D[i][j] = min(D[i-1][j]+insert,D[i-1][j-1]+copy(target[i-1],source[j-1]),D[i][j-1]+delete)  ##目标串第i个字符有三种产生方法，挑选距离最小的一个

            if D[i][j] == D[i-1][j]+insert:  ##记录距离最小操作
                procedure[i][j] = "insert"
            elif D[i][j] == D[i-1][j-1]+copy(target[i-1],source[j-1]):
                procedure[i][j] = "copy"
            elif D[i][j] == D[i][j-1]+delete:
                procedure[i][j] = "delete"

    return D[m][n]            ##返回最小距离


def copy(x,y):      ##字符相同则进行复制，计分为5
    if x == y:
        return 5
    else:               ##如果字符不同，由于没有替换功能，则设定较大计分，使之大于insert+delete
        return 45

def printProcedure(target,source,procedure):          ###显示操作步骤的函数
    i = len(target)
    j = len(source)
    pro = Stack()                  ##建立栈储存操作步骤
    while i >0 and j >0:         ##将各步操作存入栈中
            if procedure[i][j] == "copy":
                pro.push("copy:%s"%(source[j-1]))
                i = i-1
                j = j-1
            elif procedure[i][j] == "insert":
                pro.push("insert:%s"%(target[i-1]))
                i = i-1
            elif procedure[i][j] == "delete":
                pro.push("delete:%s"%(source[j-1]))
                j = j-1
    while not pro.isEmpty():  ##依次从栈顶输出
        print(pro.pop())

def main():
    source = input()  ##输入源串
    target = input()  ##输入目标串
    procedure = [[0 for i in range(len(target)+1)] for j in range(len(target)+1)]  ##建立操作列表
    print("minScore:")
    print(minEditDistance(target,source,procedure)) ##显示总分数
    printProcedure(target,source,procedure)         ##显示操作步骤

main()