from timeit import Timer
import random

# dividesort1不使用切片
def dividesort1(item, alist, first, last):    # 搜索范围：从first（缺省为0）到last（缺省为-1）
    # 只要first不大于last且没找到，继续搜索
    if first <= last:
        # 拆分点为mid
        mid = (first + last) // 2
        # 如果mid处值就是目标，返回Ture；如果mid处值小于目标，搜索mid+1到last范围；如果mid大于目标，搜索first到mid-1范围
        return True if alist[mid] == item else (dividesort1(item, alist, mid+1, last) if alist[mid] < item else dividesort1(item, alist, first, mid-1))
    # 搜索了所有可能的位置都没找到，那么返回False
    return False

# dividesort2使用切片
def dividesort2(item, alist):
    if len(alist) >= 1:
        # 拆分点为mid
        mid = len(alist) // 2
        # 如果mid处值就是目标，返回Ture；如果mid处值小于目标，搜索mid+1到last范围；如果mid大于目标，搜索first到mid-1范围
        return True if alist[mid] == item else (dividesort2(item, alist[mid+1:]) if alist[mid] < item else dividesort2(item, alist[:mid-1]))
    # 搜索了所有可能的位置都没找到，那么返回False
    return False


for i in range(1, 10):

    # 从0~10^7中随机产生一个含有i百万个自然数的列表，并将其排序
    mylist = random.sample(list(range(10 ** 7)), i*(10 ** 6))
    mylist.sort()
    # 产生一个待查找的随机数
    testnum = random.randrange(10 ** 7)


    # 分别使用不切片和切片两种二分查找函数查找testnum，并使用timeit计时
    def test1():
        dividesort1(testnum, mylist, 0, len(mylist)-1)
    def test2():
        dividesort2(testnum, mylist)

    t1 = Timer("test1()", "from __main__ import test1")
    t2 = Timer("test2()", "from __main__ import test2")
    # 打印两种二分查找所花费的时间

    print("列表长度：%d， 不切片用时%f秒，切片用时%f秒\n" % (i*(10**6), t1.timeit(number=10), t2.timeit(number=10)))


#分析结果
print("上述结果表明，使用切片的二分查找的时间复杂度近似为O(n)，不使用切片的时间复杂度近似为O(log n)")
