#采用数据链实现映射数据类型
class Map:
    def __init__(self):
        self.size = 577
        self.slots = [None] * self.size     #.....槽
        self.data = [None] * self.size     #.....数据

    def Hash(self, key):      #......散列函数（求余）
        return key % self.size

    def put(self, key, data):       #.....创建key-value关联
        hashvalue = self.Hash(key)
        if self.slots[hashvalue] == None:    #.....哈希值之前没有对应任何key；创建新的数据链
            self.slots[hashvalue] = [key]
            self.data[hashvalue] = [data]
        else:
            found = False
            for i in range(len(self.slots[hashvalue])):   #.......数据链不为空，遍历寻找key
                if self.slots[hashvalue][i] == key:     #.....key之前已经存在；赋新值
                   found = True
                   self.data[hashvalue][i] = data
                   break
            if not found:      #......key之前不存在；数据链末尾添加新项
                self.slots[hashvalue].append(key)
                self.data[hashvalue].append(data)

    def get(self, key):        #......由key得到data（关联不存在时得到None）
        hashvalue = self.Hash(key)
        if self.slots[hashvalue] == None:      #.......关联不存在的第一种情况(数据链为空）
            return None
        else:
            for i in range(len(self.slots[hashvalue])):     #.......数据链不为空，遍历寻找key
                if self.slots[hashvalue][i] == key:
                    return self.data[hashvalue][i]       #返回data
            return None      #......关联不存在的第二种情况（数据链中不存在key）

    def __delitem__(self, key):       #.........删除键值关联（默认关联之前存在）
        hashvalue = self.Hash(key)
        for i in range(len(self.slots[hashvalue])):     #....查找key在相应数据链中的位置
            if self.slots[hashvalue][i] == key:
                break
        self.slots[hashvalue].pop(i)    #......执行删除操作
        self.data[hashvalue].pop(i)

    def __len__(self):       #.....求已有键值关联的数目
        count = 0
        for i in range(self.size):     #.....遍历所有哈希值对应的数据链
            if self.slots[i] != None:
                count += len(self.slots[i])      #........数据链不为空时计入链中key的数目
        return count

    def __contains__(self, key):       #.......判断关联是否存在
        hashvalue = self.Hash(key)
        if self.slots[hashvalue] == None:      #....不存在的第一种情况（相应数据链为空）
            return False
        else:         #........返回key在相应数据链中是否存在的布尔值
            return key in self.slots[hashvalue]
