
"""本代码用于实现：
用单向链表实现数据结构：Stack，Queue"""
#定义类：节点
class Node:
	def __init__(self, initdata):
		self.data = initdata
		self.Next = None
	def getData(self):
		return self.data
	def getNext(self):
		return self.Next
	def setData(self, newdata):
		self.data = newdata
	def setNext(self, newNext):
		self.Next = newNext
#定义类：栈
class Stack:
	#初始化
	def __init__(self):
		self.head = None
	#定义push压入栈操作，为降低复杂度在head处添加元素
	def push(self, item):
		newNode = Node(item)
		newNode.setNext(self.head)
		self.head = newNode
	#定义isEmpty是否为空，通过head是否有节点判断
	def isEmpty(self):
		if self.head==None:
			return True
		else:
			return False
	#定义返回栈大小函数，通过遍历计数
	def size(self):
		pCurrent = self.head
		count = 0
		while pCurrent!= None:
			count += 1
			pCurrent = pCurrent.Next
		return count
	#定义peek偷窥操作，尝试看head上连的节点的数值，除非空栈
	def peek(self):
		if self.isEmpty():
			return 'Error: Empty Stack'
		else:
			return self.head.getData()
	#定义pop操作，尝试删去head上连的节点，除非空栈
	def pop(self):
		if self.isEmpty():
			return 'Error: Empty Stack'
		else:
			out = self.head.getData()
			self.head = self.head.getNext()
			return out
#定义类：队列
class Queue:
	#初始化
	def __init__(self):
		self.head = None
	#定义是否为空操作，直接通过head上有无节点判断
	def isEmpty(self):
		if self.head==None:
			return True
		else:
			return False
	#定义返回大小函数，通过遍历实现计数
	def size(self):
		pCurrent = self.head
		count = 0
		while pCurrent!=None:
			count += 1
		return count
	#定义加入队列操作，位置在head所连首位
	def enqueue(self, item):
		newNode = Node(item)
		newNode.setNext(self.head)
		self.head = newNode
	#定义清除队列操作，清除链表的末节点，除非空队列
	def dequeue(self):
		if self.isEmpty():
			return 'Error:Empty Queue'
		pCurrent = self.head
		pPrev = None
		#pCurrent指向链表末节点，pPrev指向倒数第二个。存储pCurrent数据。
		while pCurrent.Next!=None:
			pPrev = pCurrent
			pCurrent = pCurrent.getNext()
		out = pCurrent.getData()
		#若仅一个节点，head清空；否则pPrev指向空
		if pPrev == None:
			self.head = None
		else:
			pPrev.setNext(None)
		return out
	
#日期戳：2017/3/31
