class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
    def setdata(self,newnext):
        self.data = newnext
    def getdata(self):
        return self.data
    def setnext(self,newdata):
        self.next = newdata
    def getnext(self):
        return self.next
# 以上实现Node结构的基本功能

# 链表队列类
class Cqueue:

    def __init__(self):
        # 创建一个链表，表头初始为None
        self.head = None

    def isEmpty(self):
        # 队列为空等价于链表的头为None
        return self.head == None

    def enqueue(self,item):
        # temp为待加入的节点
        temp = Node(item)
        # 将链表头一端作为栈的入口，将新节点插入链表头
        temp.setnext(self.head)
        self.head = temp

    def dequeue(self):
        if self.isEmpty():
            print("Empty Queue")
        else:
            # 将previous指向最后一个节点,previous指向倒数第二个节点
            current = self.head
            previous = None
            while current.getnext() != None:
                previous = current
                current = current.getnext()
            # 如果queue中只有一个节点即previous为None，作为情况一
            if previous == None:
                a = self.head.getdata()
                self.head = None
                return a
            # queue中不只有一个节点的情况
            else:
                previous.setnext(current.getnext())
                return current.getdata()

    def size(self):
        # size存queue的大小，初始为0
        size = 0
        # current历遍所有的节点，每指向一个新的节点，size加一
        current = self.head
        while current != None:
            current = current.getnext()
            size += 1
        # 返回值为size
        return size
# 链表栈类
class Cstack:

    def __init__(self):
        # 创建一个链表，表头初始为None
        self.head = None

    def isEmpty(self):
        # 栈为空等价于表头为None
        return self.head == None

    def push(self,item):
        # 将表头端作为栈的开口,temp为待压入的节点
        temp = Node(item)
        temp.setnext(self.head)
        self.head = temp

    def pop(self):
        # 如果栈是空的，打印提示“空栈”
        if self.isEmpty():
            print("Empty Stack")
        # 否则删除并返回链表头的值，a临时储存所要返回的值
        else:
            a = self.head.getdata()
            self.head = self.head.getnext()
            return a

    def peek(self):
        # 如果栈是空的，打印提示“空栈”
        if self.isEmpty():
            print("Empty Stack")
        # 否则返回链表头的值
        else:
            return self.head.getdata()

    def size(self):
        # size存栈的大小，初始为0
        size = 0
        # current历遍所有节点，每指向一个新节点size加一
        current = self.head
        while current != None:
            current = current.getnext()
            size += 1
        # 返回size就是栈的大小
        return size

