#分形树。实现递归不同深度枝干颜色变化，粗细变化。由于递归次数多，亲测大约350s出结果
#引入随机数，随机修改某一支的某一深度递归枝干长度、分叉角度。总体呈现右偏。枝干中有树叶。
import turtle
import random
#画树叶。传参：树叶长度、海龟对象、树叶节点位置
def leaves(leaflen, myTurtle, Start):
	#画左树叶。初始化：调整粗细、方向、颜色。
	myTurtle.pensize(1)
	myTurtle.left(60)
	myTurtle.color(0.3, 0.6, 0.3)
	#沿中心叶脉达到最远点，进入填充模式，掉头画完整个树叶回到最远点
	myTurtle.forward(leaflen)
	myTurtle.fillcolor(0.3, 0.6, 0.3)
	myTurtle.begin_fill()
	myTurtle.left(150)
	myTurtle.forward(leaflen/2)
	myTurtle.circle(leaflen/4, 240)
	myTurtle.forward(leaflen/2)
	myTurtle.end_fill()
	#根据传入的参数Start回到节点处
	myTurtle.penup()
	myTurtle.goto(Start)
	#画右树叶。步骤同上
	myTurtle.right(150)
	myTurtle.pendown()
	myTurtle.forward(leaflen)
	myTurtle.fillcolor(0.3, 0.6, 0.3)
	myTurtle.begin_fill()
	myTurtle.left(150)
	myTurtle.forward(leaflen/2)
	myTurtle.circle(leaflen/4, 240)
	myTurtle.forward(leaflen/2)
	myTurtle.end_fill()
	myTurtle.penup()
	myTurtle.goto(Start)
	myTurtle.left(30)
	myTurtle.pendown()

#绘制花瓣的函数
def singleflower(flower, flen, typecode):
	if typecode==0:
		redset = 0.8
		blueset = 0.6
	else:
		redset = 0.6
		blueset = 0.8
	flower.pensize(1)
	flower.color(redset, 0.6, blueset)
	#进入填充模式，掉头画完整个瓣回到原点
	flower.fillcolor(redset, 0.6, blueset)
	flower.begin_fill()
	flower.right(30)
	flower.forward(flen)
	flower.circle(flen/3**0.5, 240)
	flower.forward(flen)
	flower.end_fill()
	flower.left(150)

#随机绘制花朵的函数
def drawflower(flower):
	flen = random.randrange(3, 7)
	typecode = random.randrange(0, 2)
	num = random.randrange(4, 7)
	for i in range(num):
		singleflower(flower, flen, typecode)
		flower.right(360/num)
		
	
#画树枝。传参：树枝长度，海龟对象，初始角
def treebranch(branchlen, myTurtle, angle):
	#枝干长度足够大，画枝干
	if branchlen>5:
		#初始化。调整颜色、粗细，均和长度有关
		myTurtle.color(0.8-branchlen/200, 1-branchlen/100, 0.6-branchlen/200)
		myTurtle.pensize(200/(100-branchlen))
		#先画一半，在中间节点调用leaves函数描绘树叶
		myTurtle.forward(branchlen/2)
		pos1 = myTurtle.pos()
		leaves(400/(100-branchlen), myTurtle, pos1)
		#重置参数。画剩下一半树枝
		myTurtle.color(0.8-branchlen/200, 1-branchlen/100, 0.6-branchlen/200)
		myTurtle.pensize(200/(100-branchlen))
		myTurtle.forward(branchlen/2)
		#引入随机数，作为随机修改的参考值
		rannum = random.randint(-100, 100)
		"""调用自身。先向右转角度（基准为45，以随机数为随机修改参考值），绘制下一级枝
		向左转角度，基准30，绘制下一级枝杈。返回原点"""
		myTurtle.right(45+rannum*abs(rannum)/400)
		treebranch(branchlen-5+rannum/100, myTurtle, angle+45+rannum*abs(rannum)/400)
		myTurtle.left(75+2*rannum*abs(rannum)/400)
		treebranch(branchlen-7+rannum/100, myTurtle, angle-30-rannum*abs(rannum)/400)
		myTurtle.right(30+rannum*abs(rannum)/400)
		myTurtle.up()
		myTurtle.backward(branchlen)
		myTurtle.down()
	#枝干长小于5，则绘制末端红花（直线代替）
	else:
		myTurtle.color(0.7, 0.5, 0.5)
		myTurtle.pensize(1)
		myTurtle.left(15)
		myTurtle.forward(5)
		myTurtle.penup()
		myTurtle.backward(5)
		myTurtle.right(30)
		myTurtle.pendown()
		myTurtle.forward(5)
		myTurtle.penup()
		myTurtle.backward(5)
		myTurtle.left(15)
		myTurtle.pendown()
		
#主函数，用于调用以上函数。生成海龟对象，初始化页面。设置tracer。初始化海龟
def main():
	myTurtle = turtle.Turtle()
	myWin = turtle.Screen()
	myWin.tracer(0)
	myTurtle.left(90)
	"""以下指令主要处于美观考虑，由于将树的造型设置为右向优势生长，此处将树的主干左偏
	同时，向下平滑连接竖直根基"""
	myTurtle.up()
	myTurtle.backward(370)
	myTurtle.down()
	myTurtle.color(0.4, 0.3, 0.2)
	myTurtle.pensize(20)
	myTurtle.forward(10)
	for i in range(20):
		myTurtle.pensize(10+10/(i+1))
		myTurtle.forward(13-i/4)
		myTurtle.left(1)
	#调用画树枝的函数，画落花，最后update
	treebranch(75, myTurtle, -20)
	for i in range(20):
		randposx = random.randrange(-400, 300)
		randposy = random.randrange(-500, -100)
		myTurtle.penup()
		myTurtle.goto(randposx, randposy)
		drawflower(myTurtle)
	myWin.update()
	myWin.exitonclick()

main()
#日期戳：2017/4/2 修改：2017/4/7
		
