import random
import turtle #导入模块
t = turtle.Turtle() #生成一只海龟
w = turtle.Screen() #获取屏幕对象，用于最后的点击自动关闭窗口
w.tracer(0)   #暴走乌龟
w.bgpic('red2.png')  #设置背景
t.up()  #将画笔抬起，进行初始位置设定
t.setpos(-450,-300)
t.down()
t.left(90)  #进行初始角度设定，指向正前方
def leaf1(r=100):  #画树叶的函数，通过r调节树叶的大小
    pensize = int(r * 0.05)  #画笔的粗细随树叶的大小而改变，主要用来画叶脉
    t.pensize(pensize)
    t.begin_fill()
    t.color(1,random.randint(2,100)/100,0)  #通过随机数，让树叶的颜色从浅黄到红色变换
    t.circle(r, 60)    # 弧线1
    t.left(120)        #调整角度
    t.circle(r, 60)   #  弧线2，通过弧线1和弧线2，画出叶子的轮廓
    t.left(150)       #调整角度
    t.end_fill()

    t.pencolor(0.7, 0, 0)  #确定叶脉的颜色
    t.forward(r / 4)     #以下是通过前后左右移动进行叶脉的绘制
    t.left(30)
    t.forward(0.2 * r)
    t.backward(0.2 * r)
    t.right(30)
    t.forward(r / 4)
    t.right(30)
    t.forward(0.2 * r)
    t.backward(0.2 * r)
    t.left(30)
    t.forward(r / 4)
    t.left(30)
    t.forward(0.1 * r)
    t.backward(0.1 * r)
    t.right(30)
    t.forward(r/4)
    t.backward(r)   #回到开始画叶子的起始点
    t.right(30)    #回到开始画叶子的起始角度
def brunch1(length,level,pensize,r=0.3,g=0.2,b=0.2,a1=330,a2=600):  #树，length树干的长度，level递归的次数，相当于树分叉的多少，r,g,b树干的颜色，a1和a2调整树分叉位置的张角（张角为a1a2之间的随机数)
    t.pensize(pensize)    #pensize就是画笔的粗细
    t.pencolor(r,g,b)    #画笔的颜色，用来画树干
    if level <= 0:   #结束条件
        return
    elif level <= 5:  #当画到树枝部分时，需要加一些树叶，在此处进行调整
        t.forward(length)  #相当于画‘丫’下面的枝干
        angle = random.randint(a1, a2) / 10   #angle控制两树枝之间的张角，是a1到a2范围的随机数
        t.left(angle)    #调整角度，相当于画‘丫’左边枝干
        brunch1(random.randint(750, 900) / 1000 * length, level - 1, pensize * 0.8, g=0.3)  #进行递归调用，并减小树干长度，减小画笔粗细，调整画笔颜色为绿色
        leaf1(level * 10)  #调用leaf1  进行树叶的绘制，树叶的大小随树分叉次数的加大，不断减小
        t.right(angle * 2)  #调整角度，相当于画‘丫’右边枝干
        brunch1(random.randint(750, 900) / 1000 * length, level - 1, pensize * 0.8, g=0.3)  #一样进行递归调用
        leaf1(level * 10)  #画叶子
        t.left(angle)  #将角度调整到初始位置
        t.up()  #将画笔抬起来
        t.backward(length)  #往回走， 回到刚刚开始画的地方，将画笔抬起来就是为了避免backward时的干扰
        t.down()
    else:   #当画树干部分，不需要树叶，同上一个一样
        t.forward(length)
        angle = random.randint(220,330)/10
        t.left(angle)
        brunch1(random.randint(750,900)/1000 * length,level - 1,pensize * 0.8,r*1.08)  #通过r*1.08进行树干颜色的变化
        t.right(angle*2)
        brunch1(random.randint(750,900)/1000 * length, level - 1, pensize * 0.8,r*1.08)  #通过r*1.08进行树干颜色的变化
        t.left(angle)
        t.up()
        t.backward(length)
        t.down()

#画地上的落叶，落叶随机出现，方向随机，大小随机，但不同区域的树叶数应该不同，所以下面分了四个部分
for i1 in range(300):  #画树底下一片，此片区域树叶数目应该比较多
    t.penup()
    t.setpos(random.randint(-660,-100),random.randint(-330,-200))  #位置随机
    t.setheading(random.randint(-180,180))  #角度随机
    t.pendown()
    leaf1(random.randint(10,50))  #树叶大小随机
for i2 in range(150):   #画树周围一圈区域，表现出树叶被风吹落的效果
    t.penup()
    t.setpos(random.randint(-660, -50), random.randint(-330, 340))  #位置随机
    t.setheading(random.randint(-180, 180))  #角度随机
    t.pendown()
    leaf1(random.randint(10, 50))  #树叶大小随机
for i3 in range(30):  #整个图的右半部分，由于离树较远，树叶量减小
    t.penup()
    t.setpos(random.randint(-100,300),random.randint(-330,0))  #位置随机
    t.setheading(random.randint(-180,180))  #角度随机
    t.pendown()
    leaf1(random.randint(10,50))  #树叶大小随机
for i4 in range(15):  #更远离树，树叶量更少
    t.penup()
    t.setpos(random.randint(300,650),random.randint(-330,-100))  #位置随机
    t.setheading(random.randint(-180,180))  #角度随机
    t.pendown()
    leaf1(random.randint(10,50))  #树叶大小随机

#画树
t.up()
t.setpos(-450,-300)   #将树的初始位置定在左下角
t.down()
t.setheading(90)  #画笔的初始方向，指向正上方
t.right(10)  #调整角度，向右倾斜10度
brunch1(130,8,18,a1=200,a2=280)  #画一棵树
t.up()
t.setpos(-450,-300)  #回到同一地方
t.down()
t.setheading(90)  #指向正上方
t.left(10)   #调整角度，向左倾斜10度
brunch1(140,9,20,a1=250,a2=380)  #再画一棵树

#以下几行代码是将树干延长一点
t.up()
t.pencolor(0.3,0.2,0.2)
t.pensize(21)
t.setpos(-450,-300)
t.down()
t.setheading(-90)
t.forward(30)

w.update()  #暴走乌龟
w.exitonclick() #作图完毕，欣赏结束后可以点击关闭窗口