from pythonds.basic.stack import Stack
def Levenshtein(word1, word2):
    s1 = '0' + word1
    s2 = '0' + word2
    l1 = len(word1)
    l2 = len(word2)
    step = [[None for i in range(l2 + 1)]for j in range(l1 + 1)]#将记录步骤的二重列表初始化
    distance = [[0 for i in range(l2 + 1)]for j in range(l1 + 1)]#将记录距离的二重列表初始化
    points = [[0 for i in range(l2 + 1)]for j in range(l1 + 1)]#将记录分数的二重列表初始化
    for i in range(1, l1 + 1):
        distance[i][0] = i
        points[i][0] = 20 * i
        step[i][0] = 'delete'#从word1[i]到空字符串，动作为删除，每删除一次分数为20，进行i次距离为i
    for j in range(1, l2 + 1):
        distance[0][j] = j
        points[0][j] = 20 * j
        step[0][j] = 'add'#由空字符串到word2[j]，动作为添加，每添加一次分数为20，进行j次距离为j
    for i in range(1, l1 + 1):
        for j in range(1, l2 + 1):
            copy = points[i-1][j-1] + 5 #若两个字母相同，进行copy只需要在word1[i-1]到word2[j-1]的基础上加5分
            delete = points[i - 1][j] + 20  # 比word1[i-1]到word2[j]要多删除一位
            add = points[i][j - 1] + 20  # 比word1[i]到word2[j-1]要多添加一位
            if s1[i] == s2[j] and copy < delete and copy < add :
                #两位字母相同，且在这个位置copy比在这个位置进行add 或 delete 总分数更少
                points[i][j] = points[i-1][j-1] + 5
                step[i][j] = 'copy'
                distance[i][j] = distance[i-1][j-1] + 1
            else:
                points[i][j] = min(delete, add)
                if delete < add:
                    step[i][j] = 'delete'
                    distance[i][j] = distance[i-1][j] + 1
                else:
                    step[i][j] = 'add'
                    distance[i][j] = distance[i][j-1] + 1
    print("最小分数为%d分" % points[l1][l2])
    print("该得分下编辑距离为%d次" % distance[l1][l2])
    print("操作过程为：")
    i, j = l1, l2
    #下面需要获取单词编辑的每一个步骤,从step[l1][l2]开始向前推
    routin = Stack()#最先得到的应该是最后的步骤，根据stack先入后出的特性，可将每一步存在栈内然后就可以逆序输出
    i, j= l1, l2
    for p in range(distance[l1][l2]):#动作次数
        if i > 0:#word1内仍有字母
            if step[i][j] == 'copy':
                routin.push('copy %c' % s1[i])
                i -= 1
                j -= 1  # copy动作word1 word2都要向前动一步
            elif step[i][j] == 'delete':
                routin.push('delete %c' % s1[i])
                i -= 1  # delete动作，只需要word1先前动一个字母
            else:
                routin.push('add %c' % s2[j])
                j -= 1  # word2向前动一步
        else:#若word1已空仍未结束，剩下的步骤为add
            routin.push('add %c' % s2[j])
            j = j -1
    while routin.size() > 0:
        print(routin.pop())
str1 = input()
str2 = input()
Levenshtein(str1, str2)