class Map:
    def __init__(self):#加入了map大小len参数,将slots和data改为嵌套列表
        self.size = 11
        self.slots = [[None]] * self.size
        self.data = [[None]] * self.size#嵌套列表
        self.len = 0#map的大小len初始为0

    def hashfunction(self,key):#hashfunction不变，去掉rehash
        return key % self.size

    def put(self,key,data):
        hashvalue = self.hashfunction(key)#算出hashvalue找到所在位置
        for i in range(len(self.slots[hashvalue])):
            if self.slots[hashvalue][i] == key:#在相应数据链中发现key
                self.data[hashvalue][i] = data#对其data进行修改
                break
        else:#如果循环没有中途break，说明没有这个key，在slots和data里加入数据
            self.slots[hashvalue].append(key)
            self.data[hashvalue].append(data)#采用列表的append方法进行添加
            self.len += 1#map的len+1
    def get(self,key):#找到key则返回相应的data，否则返回None
        hashvalue = self.hashfunction(key)
        data = None
        for i in range(len(self.slots[hashvalue])):
            if self.slots[hashvalue][i] == key:
                data = self.data[hashvalue][i]
                break
        return data

    def __getitem__(self, key):
        return self.get(key)

    def __setitem__(self, key, data):
        self.put(key,data)

    def __len__(self):#返回映射中key-val关联的数目
        return self.len

#定义del方法，找到key后删除key-val关联
    def __delitem__(self, key):
        hashvalue = self.hashfunction(key)
        for i in range(len(self.slots[hashvalue])):
            if self.slots[hashvalue][i] == key:
                self.slots[hashvalue].pop(i)
                self.data[hashvalue].pop(i)
                self.len -= 1
                break

#定义in方法
    def __contains__(self, key):
        hashvalue = self.hashfunction(key)
        found = False
        for i in range(len(self.slots[hashvalue])):
            if self.slots[hashvalue][i] == key:
                found = True#找到返回True
                break
        return found

#测试用例
mymap = Map()
mymap.put(1,1)
mymap.put(2,2)
mymap.put(13,3)
print(mymap.get(13))
print(len(mymap))
del mymap[1]
print(1 in mymap)