#设散列表的负载因子的阈值为0.5，超过阈值则扩大散列表的大小至原来的二倍加一
class Hashtable:
    def __init__(self,size = 11):#添加了len和lamda负载因子
        self.size = size
        self.slots = [None] * self.size
        self.data = [None] * self.size
        self.len = 0
        self.lamda = 0#负载因子初始化为0

    def hashfunction(self,key):#无改动
        return key % self.size

    def rehash(self,oldhash):#无改动
        return (oldhash + 1) % self.size

    def put(self,key,data):#修改put方法
        self.lamda = self.len / self.size#检查负载因子
        if self.lamda <= 0.5:#负载因子未超过阈值，与原方法一致
            hashvalue = self.hashfunction(key)
            if self.slots[hashvalue] == None:
                self.slots[hashvalue] = key
                self.data[hashvalue] = data
                self.len += 1
            else:
                if self.slots[hashvalue] == key:
                    self.data[hashvalue] = data
                else:
                    nextslot = self.rehash(hashvalue)
                    while self.slots[nextslot] != None and self.slots[nextslot] != key:
                        nextslot = self.rehash(nextslot)
                    if self.slots[nextslot] == None:
                        self.slots[nextslot] = key
                        self.data[nextslot] = data
                        self.len += 1
                    else:
                        self.data[nextslot] = data
        #超过阈值，扩充散列表
        else:
            dict = {self.slots[i]:self.data[i] for i in range(self.size) if self.slots[i]}#将原表数据放入字典暂存
            self.size = self.size * 2 + 1#扩增散列表大小至原来的二倍加1
            self.slots = [None] * self.size#重新初始化slots,data,len
            self.data = [None] * self.size
            self.len = 0
            for keys in dict.keys():#将数据重新加入扩充后新的散列表
                self.put(keys,dict[keys])
            self.put(key,data)#加入新的映射

    def get(self,key):#get方法不作改动
        startslot = self.hashfunction(key)
        data = None
        stop = False
        found = False
        position = startslot
        while self.slots[position] != None and not found and not stop:
            if self.slots[position] == key:
                found = True
                data = self.data[position]
            else:
                position = self.rehash(position)
                if position == startslot:
                    stop = True
        return data

    def __getitem__(self, key):#不作改动
        return self.get(key)

    def __setitem__(self, key, data):#不作改动
        self.put(key,data)

    def __len__(self):#增加len方法
        return self.len

    def __delitem__(self, key):#定义del方法
        hashvalue = self.hashfunction(key)
        if self.slots[hashvalue] == key:
            self.slots[hashvalue] = None
            self.data[hashvalue] = None
            self.len -= 1
        else:
            nextslot = self.rehash(hashvalue)
            while self.slots[nextslot] != key:
                nextslot = self.rehash(nextslot)
            self.slots[nextslot] = None
            self.data[nextslot] = None
            self.len -= 1

    def __contains__(self, key):#定义in方法
        startslot = self.hashfunction(key)
        stop = False
        found = False
        pos = startslot
        while self.slots[pos] != None and not found and not stop:
            if self.slots[pos] == key:
                found = True
            else:
                pos = self.rehash(pos)
                if pos == startslot:
                    stop = True
        return found

