import random
from timeit import Timer
#课件中的方法
def quickSort(alist):
    quickSortHelper(alist,0,len(alist)-1)
    return alist
def quickSortHelper(alist,first,last):
    if first<last:
        splitpoint=partition(alist,first,last)
        quickSortHelper(alist,first,splitpoint-1)
        quickSortHelper(alist,splitpoint+1,last)
def partition(alist,first,last):
    pivotvalue=alist[first]
    leftmark=first+1
    rightmark=last
    done=False
    while not done:
        while leftmark<=rightmark and alist[leftmark]<=pivotvalue:
            leftmark=leftmark+1
        while alist[rightmark]>=pivotvalue and rightmark>=leftmark:
            rightmark=rightmark-1
        if rightmark<leftmark:
            done=True
        else:
            temp=alist[leftmark]
            alist[leftmark]=alist[rightmark]
            alist[rightmark]=temp
        temp=alist[first]
        alist[first]=alist[rightmark]
        alist[rightmark]=temp
        return rightmark
#采用随机选取中值的方法，只有分裂方法需要修改
def quickSort2(alist):
    quickSortHelper2(alist,0,len(alist)-1)
    return alist
def quickSortHelper2(alist, first, last):
    if first < last:
        splitpoint = partition2(alist, first, last)
        quickSortHelper2(alist, first, splitpoint - 1)
        quickSortHelper2(alist, splitpoint + 1, last)
def partition2(alist,first,last):
    pivotpos = random.randrange(first, last)  # 随机找一个中值位置
    pivotvalue = alist[pivotpos]
    alist[pivotpos]=alist[first]
    alist[first]=pivotvalue#将首位与选取的中值交换位置
    leftmark=first+1
    rightmark=last
    done=False
    while not done:
        while leftmark<=rightmark and alist[leftmark]<=pivotvalue:
            leftmark=leftmark+1
        while alist[rightmark]>=pivotvalue and rightmark>=leftmark:
            rightmark=rightmark-1
        if rightmark<leftmark:
            done=True
        else:
            temp=alist[leftmark]
            alist[leftmark]=alist[rightmark]
            alist[rightmark]=temp
    temp=alist[first]
    alist[first]=alist[rightmark]
    alist[rightmark]=temp
    return rightmark
#计时实验进行性能比较
for i in range(20):
    alist = [random.random() for i in range(900)]  # 生成900个数的随机数列表
    Time1 = Timer("quickSort(alist)", "from __main__ import quickSort,alist")  # 记录执行qSortStd()100遍的时间并输出
    Time2 = Timer("quickSort2(alist)", "from __main__ import quickSort2,alist")  # 记录执行qSortRan()100遍的时间并输出
    print("%f  %f" % (Time1.timeit(number=100), Time2.timeit(number=100)))
