import turtle
class Stack:
    def __init__(self):
        self.items = []

    def isEmpty(self):
        return self.items == []

    def push(self, item):
        self.items.append(item)

    def pop(self):
        return self.items.pop()

    def peek(self):
        return self.items[len(self.items)-1]

    def size(self):
        return len(self.items)

#shapesize中的参数与goto中的参数换算比值为1:20

#生成柱子
def build_pole():
    for i in range(3):
        t = turtle.Turtle()
        t.speed(0)
        t.up()
        t.hideturtle()
        t.shape('square')
        t.shapesize(10, 0.1)
        t.goto((i-1)*200, 0)
        t.showturtle()
    t = turtle.Turtle()
    t.speed(0)
    t.up()
    t.hideturtle()
    t.shape('square')
    t.shapesize(1, 30)
    t.goto(0, -110)
    t.showturtle()

#生成汉诺塔
def build_tower(n, pos):
    for i in range(n):
        t = turtle.Turtle()
        t.speed(0)
        t.up()
        t.hideturtle()
        t.shape('square')
        t.shapesize(1, 2.5*(3-i*0.3))
        t.goto(pole_pos[pos], -90 + i*20)
        t.showturtle()
        pole[pos].push(t)

#递归移动
def move(n, pos_from, pos_to, pos_with):
    if n == 1:
        t = pole[pos_from].pop()
        t.speed(5)
        t.goto(pole_pos[pos_from], 150)
        t.goto(pole_pos[pos_to], 150)
        s = pole[pos_to].size()
        t.goto(pole_pos[pos_to], -90 + s*20)
        pole[pos_to].push(t)
    else:
        move(n-1, pos_from, pos_with, pos_to)
        move(1, pos_from, pos_to, pos_with)
        move(n-1, pos_with, pos_to, pos_from)

#每个柱子用栈来表示, 且为全局变量
def Hanoi(n):
    global A, B, C, pole, pole_pos
    A = Stack()
    B = Stack()
    C = Stack()
    #用字典来记录柱子的位置和对应的栈
    pole_pos = {'A':-200, 'B':0, 'C':200}
    pole = {'A':A, 'B':B, 'C':C}
    build_pole()
    build_tower(n, 'A')
    move(n, 'A', 'B', 'C')

def main():
    #阶数尽量不要设置太大, 因为柱子和塔参数目前是固定的. 阶数太大看起来不好看
    #而且按照上面的参数设置, 11层的汉诺塔最小宽度是0, 会报错
    Hanoi(10)
    turtle.Screen().exitonclick()

if __name__ == '__main__':
    main()