#希尔伯特曲线

import turtle

size = int(input("输入希尔伯特曲线的阶数："))
len = 500/(2**size)                     #合适的线段长

def Hilbert(size,direction,t):          #direction取0为从左向右正向画，取1为从右向左反向画
    if size == 1:                       #基本结束条件
        t.forward(len)
        t.right(direction*180+90)       #direction取0为右转，取1为左转
        t.forward(len)
        t.right(direction*180+90)
        t.forward(len)
    else:
        t.right(90*(1-2*direction))
        Hilbert(size-1,1-direction,t)   #降低问题规模，n阶的化为4个n-1阶的连接：1、4为反向，2、3为正向
        t.right(90*((size+1)%2)*(1-2*direction))
        t.forward(len)                  #图形间的连接线段
        Hilbert(size-1,direction,t)
        t.left(90*((size+1)%2)*(1-2*direction))
        t.forward(len)
        t.left(90*(1-2*direction))
        Hilbert(size-1,direction,t)
        t.right(90*(size%2)*(1-(2*direction)))
        t.forward(len)
        t.right(90*(1-(2*direction)))
        Hilbert(size-1,1-direction,t)

def main():
    t = turtle.Turtle()
    myWin = turtle.Screen()
    myWin.tracer(10000,)        #快速制图
    t.up()
    t.backward(240)
    t.left(90)
    t.backward(240)             #调至合适的初始位置
    t.down()
    t.color('violet')
    Hilbert(size,0,t)           #绘制n阶希尔伯特曲线
    myWin.update()              #快速制图
    myWin.exitonclick()

main()

