# 调用海龟模块
import turtle
# 读入阶数n
n = int(input())
# 计算最小边长len
len = 300/(2**n+1)
# 定义衔接步骤Move：
# 每两个递归调用之间用一个衔接步骤，衔接步骤的选取由阶数的奇偶、该阶图形的正反和衔接步骤的序号决定
def Move(num, mode, step):
    # nmode表示阶数num的奇偶
    nmode = num % 2
    # mode表示正反，0正1反
    mode = mode % 2
    # 构造奇数阶图形时
    if nmode == 1:
        # 如果所构造的图形是正的
        if mode == 0:
            # 如果衔接序号是1
            if step == 1:
                t.right(90)
                t.forward(len)
            # 如果衔接序号是2
            elif step == 2:
                t.left(90)
                t.forward(len)
                t.left(90)
            # 如果衔接序号是3
            else:
                t.forward(len)
                t.right(90)
        # 如果要构造一个反图形
        else:
            # 如果衔接序号是1
            if step == 1:
                t.left(90)
                t.forward(len)
            # 如果衔接序号是2
            elif step == 2:
                t.right(90)
                t.forward(len)
                t.right(90)
            # 如果衔接序号是3
            else:
                t.forward(len)
                t.left(90)
    # 如果要构造一个偶数阶图形
    else:
        # 如果要的是正图形
        if mode == 0:
            # 如果衔接序号是1
            if step == 1:
                t.forward(len)
                t.left(90)
            # 如果衔接序号是2
            elif step == 2:
                t.forward(len)
            # 如果衔接序号是3
            else:
                t.left(90)
                t.forward(len)
        # 如果要的是反图形
        else:
            # 如果衔接序号是1
            if step == 1:
                t.forward(len)
                t.right(90)
            # 如果衔接序号是2
            elif step == 2:
                t.forward(len)
            # 如果衔接序号是3
            else:
                t.right(90)
                t.forward(len)
# 递归产生希尔伯特曲线的函数
def hilbertcurve(num, mode, t, len):
    # mode是图形的正反，0正1反
    mode = mode % 2
    # 结束条件：num为0
    if num == 0:
        if mode == 0:
            t.right(90)
            for i in range(3):
                t.left(90)
                t.forward(len)
        else:
            t.left(90)
            for i in range(3):
                t.right(90)
                t.forward(len)
    # num大于0
    else:
        # 调用一次num-1阶，同正反，同一只海龟，同样单位长度的曲线
        hilbertcurve(num - 1, mode, t, len)
        # 衔接一个阶数为num，同正反，序号为1的衔接步骤
        Move(num, mode, 1)
        # 调用一次num-1阶，不同正反，同一只海龟，同样单位长度的曲线
        hilbertcurve(num - 1, mode+1, t, len)
        # 衔接一个阶数为num，同正反，序号为2的衔接步骤
        Move(num, mode, 2)
        # 调用一次num-1阶，不同正反，同一只海龟，同样单位长度的曲线
        hilbertcurve(num - 1, mode+1, t, len)
        # 衔接一个阶数为num，同正反，序号为3的衔接步骤
        Move(num, mode, 3)
        # 调用一次num-1阶，同正反，同一只海龟，同样单位长度的曲线
        hilbertcurve(num - 1, mode, t, len)


# 创建一只海龟t
t = turtle.Turtle()
# 创建屏幕
mywin = turtle.Screen()
# 设置更新频率和延迟
mywin.tracer(3,1)
# 调整划线的宽度
t.width(0.02)

# 调整海龟位置
t.up()
t.backward(500)
t.right(90)
t.backward(300)
t.down()
# 画一个n阶的希尔伯特曲线
hilbertcurve(n, 0, t, len)
# 更新屏幕
mywin.update()
# 单击鼠标退出
mywin.exitonclick()