import turtle

#引入x1, y1, y2, x2来描述四种方向以及四种方向之间的关系
def HilbertCurve(x0, y0, x1, y1, y2, x2, n, t):
    #(x0, y0)表示希尔伯特曲线开始点的角落的坐标
    #(x1, y1)表示画一个宽为x1, 高为y1的曲线, 且先画x方向, 再画y方向
    #(y2, x2)表示画一个宽为x2, 高为y2的曲线, 且先画y方向, 再画x方向
    #具体可以看main里面的例子
    if n == 0:
        x = x0 + (x1 + x2) / 2
        y = y0 + (y2 + y1) / 2
        r = x / 600 + 0.5
        g = y / 600 + 0.5
        b = 1 - r * g
        t.color(r, g, b)
        global is_first
        if is_first:
            #如果是第一步, 不留印迹
            is_first = False
            t.up()
            t.goto(x,y)
            t.down()
        else:
            t.goto(x, y)
    else:
        HilbertCurve(x0,               y0,               x2/2,  y2/2,  y1/2,  x1/2, n - 1, t)
        HilbertCurve(x0 + x1/2,        y0 + y2/2,        x1/2,  y1/2,  y2/2,  x2/2, n - 1, t)
        HilbertCurve(x0 + x1/2 + x2/2, y0 + y2/2 + y1/2, x1/2,  y1/2,  y2/2,  x2/2, n - 1, t)
        HilbertCurve(x0 + x1/2 + x2,   y0 + y2/2 + y1,  -x2/2, -y2/2, -y1/2, -x1/2, n - 1, t)

def main(n):
    myWin = turtle.Screen()
    t = turtle.Turtle()
    turtle.tracer(0)
    #全局变量, 判断是否为第一步
    global is_first
    is_first = True
    #以下为四种不同方向的希尔伯特曲线
    HilbertCurve(-300, -300,    0,    0,  600,  600, n, t)
    # HilbertCurve( 300,  300,    0,    0, -600, -600, n, t)
    # HilbertCurve(-300, -300,  600,  600,    0,    0, n, t)
    # HilbertCurve( 300,  300, -600, -600,    0,    0, n, t)

    turtle.update()
    myWin.exitonclick()

if __name__ == '__main__':
    main(6)





