#稍作拓展的柯克雪花曲线
import turtle
#绘制雪花曲线的一边（共三边）。传参：长度、级数、海龟对象
def FlakeSide(Len, degree, myTurtle):
	#储存该边端点位置
	pos1 = myTurtle.pos()
	#myTurtle.speed(1)
	#绘制边的第一段。当级数还允许下行时，调用自身，绘制长度为1/3的次级雪花曲线边
	if degree>1:
		FlakeSide(Len/3, degree-1, myTurtle)
	#否则，直接按直线绘制1/3长度的边
	else:
		myTurtle.forward(Len/3)
	#右转60度，衔接该边的第二段
	myTurtle.right(60)
	#绘制边的第二段，与第一段类似，最后左转120度衔接第三段
	if degree>1:
		FlakeSide(Len/3, degree-1, myTurtle)
	else:
		myTurtle.forward(Len/3)
	myTurtle.left(120)
	#绘制边的第三段，类似上，最后右转60度衔接第四段
	if degree>1:
		FlakeSide(Len/3, degree-1, myTurtle)
	else:
		myTurtle.forward(Len/3)
	myTurtle.right(60)
	#绘制边的第四段。
	if degree>1:
		FlakeSide(Len/3, degree-1, myTurtle)
	else:
		myTurtle.forward(Len/3)
	#如果级数较高，返回端点pos1，围绕这一边向外拓展两个次级雪花的外围
	if degree>2:
		myTurtle.up()
		myTurtle.goto(pos1)
		myTurtle.down()
		myTurtle.right(90)
		FlakeSide(Len/3**0.5, degree-2, myTurtle)
		myTurtle.left(120)
		FlakeSide(Len/3**0.5, degree-2, myTurtle)
		myTurtle.right(60)
		FlakeSide(Len/3**0.5, degree-2, myTurtle)
		myTurtle.left(120)
		FlakeSide(Len/3**0.5, degree-2, myTurtle)
		myTurtle.right(90)
#调用三次形成柯克雪花曲线边的函数
def KochSnowFlake(Len, degree, myTurtle):
	for i in range(3):
		FlakeSide(Len, degree, myTurtle)
		myTurtle.left(120)
		
#主函数，传参：初始长度、初始级数
def main(Len, degree):
	myTurtle = turtle.Turtle()
	myWin = turtle.Screen()
	myWin.tracer(0)
	#myTurtle.speed(1)
	myTurtle.up()
	myTurtle.goto(-150, -100)
	myTurtle.down()
	myTurtle.pencolor(.4, .4, .8)
	myTurtle.speed(0)
	KochSnowFlake(Len, degree, myTurtle)
	myWin.update()
	myWin.exitonclick()
	
main(300, 8)
#日期戳 2017/4/1 修改：2017/4/3
