source = input('Please input the source word: ')
target = input('Please input the target word: ')
# 录入原单词和目标单词
def min_edit_score(source, target, subst, insert, delete):
    # 定义求最小编辑距离的函数，参数有原单词，目标单词，替换成本，插入成本，删除成本
    score_temp = [[0 for j in range(len(source) + 1)] for i in range(len(target) + 1)]
    trace_back = [[None for j in range(len(source) + 1)] for i in range(len(target) + 1)]
    # 生成两个二维列表，分别用来存储当前的最小编辑距离和操作的步骤
    for i in range(len(target) + 1):
        for j in range(len(source) + 1):
            if i == 0 and j == 0:
                score_temp[0][0] = 0
            # 设定初值 对于（0,0）点，未进行任何操作，最小编辑距离应该是0
            elif i == 0:
                score_temp[0][j] = delete * j
                trace_back[0][j] = 2
            # 设定初值， 将目标函数未填充单词，但是原函数一直向前遍历的编辑距离设置为删除成本乘以相应的字母数量
            elif j == 0:
                score_temp[i][0] = insert * i
                trace_back[i][0] = 1
            # 同上述情况，只是把删除成本换成了插入的成本
            else:
                temp2 = score_temp[i - 1][j] + insert
                temp3 = score_temp[i][j - 1] + delete
                # 三个temp值分别代表进行替换，插入，删除操作对应的编辑距离
                if target[i - 1] == source[j - 1]:
                    temp1 = score_temp[i - 1][j - 1] + subst
                    score_temp[i][j] = min(temp1, temp2, temp3)
                    # 对比三种操作，将最小操作距离取为操作的最小值
                    if temp1 == score_temp[i][j]:
                        trace_back[i][j] = 0
                    elif temp2 == score_temp[i][j]:
                        trace_back[i][j] = 1
                    else:
                        trace_back[i][j] = 2
                    # 1,2,3分别记录三种操作在后面的进行的对应回溯
                else:
                    score_temp[i][j] = min(temp2, temp3)
                    if temp2 == score_temp[i][j]:
                        trace_back[i][j] = 1
                    else:
                        trace_back[i][j] = 2
                    # 同上，只是当两个字母不相等的时候，不需进行替换操作
    i = len(target)
    j = len(source)
    print('The operating processes are as follows: ')
    while i >= 0 and j >= 0 and i + j >0:
        if trace_back[i][j] == 0:
            print('Copy %s'%(target[i - 1]))
            i -= 1
            j -= 1
        # 如果上面记录的回溯值是0，那么返回打印Copy操作
        elif trace_back[i][j] == 1:
            print('Insert %s'%(target[i - 1]))
            i -= 1
        # 如果上面记录的回溯值是1，那么返回打印Insert操作
        else:
            print('Delete %s'%(source[j - 1]))
            j -= 1
        # 如果上面记录的都不是以上的值，即记录值是3，那么返回打印Delete操作
    return score_temp[len(target)][len(source)]
    #返回最小操作距离
print('The minimum edit score is: %d' %(min_edit_score(source, target, 5, 20, 20), ))
# 打印出来最小操作距离