import turtle
import random

# 主要思路：
#       三种分叉角度，和主干夹角分别为0~30°，30°~60°以及60°~90°；
#       三种分叉模式的选取：从modelist中随机取一个元素，‘4’对应60°~90°，‘6’对应30°~60°，‘8’对应0~30°；
#       modelist中不同模式对应元素个数在列表中占比代表该模式出现的可能性

# 模式列表，有1个‘4’，40个‘6’，150个‘8’
modelist = ['4'] * 1 + ['6'] * 40 + ['8'] * 150

# 将随机的-30°~30°的范围偏角转换成海龟的真实偏转角
def TrueDegree(Tempdegree,mode):
    times = ['4','6','8'].index(mode)
    if Tempdegree >= 0:
        return (30 * times + Tempdegree)
    else:
        return (180 - 30 * times + Tempdegree)


def tree(branchlen,width,t):
# 只要树枝长度大于1，宽度大于0.5，就继续画
    if branchlen > 1 and width > 0.5:
        # 宽度小于1.2的树枝为绿色，宽度大于等于1.2的为黑色
        if width <= 1.2 :
            t.color('green4')
        else:
            t.color('black')
        # 在长度<=10或宽度<=0.7的末梢处，树枝出现随机生长，树枝可能变长，进而可能出现循环
        if branchlen <= 10 or width <= 0.7:
            branchlen = 0.5*random.randrange(14, 21, 1)
            width = 0.1*random.randrange(6, 9, 1)
        # 将宽度更新并继续绘制
        t.width(width)
        t.forward(branchlen)
        # 海龟初始朝向垂直主干向右
        t.right(90)
        # 分枝的数目从2,3,4中随机选取
        branchnum = random.randrange(2,5)
        # 对于每一个分枝
        for i in range(0,branchnum):
            # 随机选取一种模式
            mode = modelist[random.randrange(191)]
            # 产生一个随机临时偏离角
            tempdegree = random.randrange(-30, 31, 1)
            # 得到海龟向左偏转的真实偏转角
            truedegree = TrueDegree(tempdegree,mode)
            # 让海龟向左偏转一个角度
            t.left(truedegree)
            # 在这个方向递归画一棵分枝树
            tree(branchlen*0.1*int(mode),width*0.08*int(mode),t)
            # 将海龟右转回到初始位置
            t.right(truedegree)
        # 让海龟回到主干底部
        t.left(90)
        t.up()
        t.backward(branchlen)
        t.down()

t = turtle.Turtle()
mywin = turtle.Screen()

# 将64行和74的‘#’删掉可以加快作图，但是看着它一点一点长出来比较有意思【笑哭.jpg】
mywin.tracer(10000,0.1)

# 调整海龟初始位置
t.left(90)
t.up()
t.backward(400)
t.down()
# 画一棵主干长150宽20的树
tree(150, 20, t)

# mywin.update()
mywin.exitonclick()
