#将有序表作为无序表的子类实现；继承的方法中须修改add和search；另外，append和insert方法应不再使用
#注：这里定义的有序表为递增顺序，越小的数据项越靠近表头
from UOL import Node, UnorderedList   #..........导入之前写好的无序表模块


class OrderedList(UnorderedList):        #...........继承父类UnorderedList
    def add(self, item):                          #..............修改add方法
        stop = False
        previous = None               # ............记录当前节点的前一项，便于链表维护
        current = self.head
        while current != None and not stop:
            if current.getData() < item:       #........遍历链表直至找到第一个不小于item的节点的位置
                previous = current
                current = current.getNext()
            else:
                stop = True
        temp = Node(item)     #..........创建新节点
        temp.setNext(current)       #..............初始化新节点的next
        if previous == None:                 #..............对应item排到表头插入的情况，单独处理head
            self.head = temp
        else:                  #.................item插入位置不在表头，连接前一节点与新节点
            previous.setNext(temp)

    def search(self, item):         #.............修改search方法
        found = False
        stop = False
        current = self.head
        while current != None and not stop:         #...........遍历链表
            if current.getData() == item:       #..........找到item，终止遍历
                found = True
                stop = True
            elif current.getData() > item:  #....按照有序性，在当前节点的data大于item之前还未找到，搜索失败，终止遍历
                stop = True
            else:
                current = current.getNext()
        return found                   #...........返回布尔值
