#自定义快排代码，中值选取为alist[midleft], alist[mid], alist[midright]的中位数；
#其中mid = (fisrt + last) // 2, midleft = (first + mid) // 2, midright = (mid + last) // 2
def quickSort(alist):
    quickSortHelper(alist, 0, len(alist) - 1)

def quickSortHelper(alist, first, last):
    if first < last:
        splitpoint = partition(alist, first, last)
        quickSortHelper(alist, first, splitpoint - 1)
        quickSortHelper(alist, splitpoint + 1, last)

def partition(alist, first, last):
    mid = (first + last) // 2           #.............自定义中值选取
    midleft = (first + mid) // 2
    midright = (mid + last) // 2
    if alist[midleft] <= alist[mid] <= alist[midright] or alist[midright] <= alist[mid] <= alist[midleft]:
        pivotpos = mid
    elif alist[mid] <= alist[midleft] <= alist[midright] or alist[midright] <= alist[midleft] <= alist[mid]:
        pivotpos = midleft
    else:
        pivotpos = midright
    pivotvalue = alist[pivotpos]
    leftmark = first
    rightmark = last
    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pivotvalue:
            leftmark += 1
        while rightmark >= leftmark and alist[rightmark] >= pivotvalue:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            alist[leftmark], alist[rightmark] = alist[rightmark], alist[leftmark]
    #确定分裂点的代码片段和quickSort_raw有所不同；后者是前者的子情况
    if pivotpos > leftmark:
        alist[pivotpos], alist[leftmark] = alist[leftmark], alist[pivotpos]
        return leftmark
    elif pivotpos < rightmark:
        alist[pivotpos], alist[rightmark] = alist[rightmark], alist[pivotpos]
        return rightmark
    else:
        return pivotpos
