#测试代码；考察中值选取方法随排序效率和稳定性的影响
from quickSort_raw import quickSort_raw
from quickSort import quickSort
import sys
sys.setrecursionlimit(1000000)
import random
from timeit import Timer

#先对比快排调用的时间及其稳定性
print("Testing time consumed on importing:")
for i in range(3):        #.........共三组对比
    t10 = Timer("from __main__ import quickSort_raw").timeit(number=1)
    t20 = Timer("from __main__ import quickSort").timeit(number=1)
    print("Group %d:\n" % (i+1), "t10 = %f\n" % t10, "t20 = %f" % t20, sep='      ')

#再对比排序时间
print("\nTesting time consumed on sorting:")
scale = 1000     #..........用于控制排序的数据规模
for k in range(7):      #........共七组对比
    raw = tuple([random.randrange(scale) for i in range(scale)])   # .........原始序列用不可变类型存储
    lst1 = list(raw)
    t1 = Timer("quickSort_raw(lst1)", "from __main__ import quickSort_raw, lst1").timeit(number=1)
    lst2 = list(raw)
    t2 = Timer("quickSort(lst2)", "from __main__ import quickSort, lst2").timeit(number=1)
    print("Group %d:\n" % (k + 1), "t1 = %.17f\n" % t1, "t2 = %.17f" % t2, sep='      ')
