import turtle
from pythonds.basic import Stack

# 读入汉诺塔的层数
n = int(input("请输入一个不大于8的正整数\n"))


# 添加横向移动方法
class Turtle(turtle.Turtle):
    # 横移函数，规定初始海龟朝北，i为移动步数（i为负数时向左，i为正数时向右），步长规定为350
    def rowward(self, i):
            self.goto(self.xcor() + 350 * i, 300)

def MoveTower(height, frompole, topole, withpole):
    if height >= 1:
        MoveTower(height-1, frompole, withpole, topole)
        Movedisk(frompole,topole)
        MoveTower(height-1,withpole,topole,frompole)

# 将fp处的最上面一只海龟移动到tp的最上面
def Movedisk(fp, tp):
    # i为移动步数
    i = ([A, B, C].index(tp) - [A, B, C].index(fp))
    # t为从fp最上面pop出来的一只小海龟
    t = fp.pop()
    # 将t移动到天花板
    t.forward(300 + n*40 - 40*fp.size())
    # 横移到tp上方
    t.rowward(i)
    # 下降到tp最上面
    t.backward(300 + n*40 - 40*tp.size())
    # 加到tp栈中
    tp.push(t)


# 创建一个屏幕
mywin = turtle.Screen()
# A、B、C是三个栈，储存方块

A = Stack()
B = Stack()
C = Stack()

# 先在A处产生一坨
for i in range(n, 0, -1):
    t1 = Turtle()
    t1.up()
    t1.backward(350)
    t1.left(90)
    t1.shape('square')
    t1.shapesize(3+i, 1, 20)
    t1.backward(40*i)
    A.push(t1)

# 将汉诺塔从A栈移到C栈
MoveTower(n, A, C, B)

# 单击鼠标退出
mywin.exitonclick()