#基本思路是使用put方法时若负载因子超过阈值，
#将散列表扩大一倍
#将数据暂存在一个列表中
#扩大后再把数据移回去
#由于是一个一个加负载，所以新的散列表负载因子为0

class HashTable:
    def __init__(self,n):
        self.size = 11
        self.nowsize= 0 # 负载量
        self.repeat = 0 # 负载因子
        self.n = n #阈值
        self.slots = [None] * self.size
        self.data = [None] * self.size
        self.list = [] *self.size #初始化一个用于扩大列表时暂存数据

    def expand(self):# 扩展散列表的函数
        self.list= []*self.size #初始化暂存列表
        for i in self.slots:
            if i!= None:
                self.list[i] = self[i]#把数据转存到暂存列表中（实现用到[]getitem和setitem方法）
        self.size = self.size +11
        self.slots = [None] * self.size# 扩展key列表和数据列表
        self.data = [None] * self.size
        for i in self.list:
            self[i] = self.list[i]#再存入原先的所有key-data
        self.nowsize=0#负载量归零

    def hashfunction(self,key):
        return key % self.size

    def rehash(self,oldhash):
        return (oldhash+1) % self.size

    def put(self,key,data):#只有普通方法需要用到扩展
        self.nowsize = self.nowsize +1
        self.repeat= self.nowsize / self.size  # 计算负载因子
        if self.repeat>= self.n:# 当负载因子超过阈值，扩展散列表
            self.expandTable()
        hashvalue = self.hashfunction(key)#put方法与课件上相同
        if self.slots[hashvalue] == None:
            self.slots[hashvalue] = key
            self.data[hashvalue] = data
        elif self.slots[hashvalue] == key:
            self.data[hashvalue] = data
        else:
            nextslot = self.rehash(hashvalue)
            while self.slots[nextslot] != None and self.slots[nextslot] != key:
                nextslot = self.rehash(nextslot)
            if self.slots[nextslot] == None:
                self.slots[nextslot] = key
                self.data[nextslot] = data
            else:
                self.data[nextslot] = data

    def get(self,key): # 实现get方法，与课件相同
        startslot = self.hashfunction(key)
        data = None
        stop = False
        found = False
        position = startslot
        while self.slots[position] != None and not found and not stop:
            if self.slots[position] == key:
                found = True
                data = self.data[position]
            else:
                position = self.rehash(position)
                if position == startslot:
                    stop = True
        return data

    def __getitem__(self,key):
        return self.get(key)

    def __setitem__(self,key,data):
        self.put(key,data)