import timeit
import random

#定义新函数，使得随机生成一个含1000个不重复数字的随机数组，并依次从列表或字典中删掉这1000个不重复的随机数
def delete(y,r):
    for w in random.sample(range(r),1000):
        del y[w]

for i in range(10000,1000001,10000):
    t = timeit.Timer('delete(x,%d)'%i,'from __main__ import random,x,delete')
    #引入自定义函数delete，相当于随机删掉列表或字典中1000个元素
    x = list(range(i+1000))
    lst_time = t.timeit(number=1)
    #由于从列表中删掉了1000个元素，因此操作执行一次相当于1000次删除操作
    x = {j:None for j in range(i+1000)}
    dic_time = t.timeit(number=1)
    #由于从字典中删掉了1000个元素，因此操作执行一次相当于1000次删除操作
    print('%d,%.5f,%.5f' % (i,lst_time,dic_time))

#从测试结果中可以看出，del操作符在列表中的性能远不如在字典中的性能.
#随着序列长度的变化，列表所用的时间呈线性上升趋势，而字典所用的时间基本上不发生变化
#因此在列表中的时间复杂度是O(n)，在字典中的时间复杂度是O(1)
