from Node import Node

class Queue:
    
    def __init__(self):
        self.head = None

    #判断队列是否为空，只需要判断head是否为None
    def isEmpty(self):
        return self.head == None

    #向队列尾加入元素，相当于从链表头加入元素
    def enqueue(self,item):
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp

    #从队列中提取元素，相当于从链表尾删除元素，并返回删除的元素
    #利用preprevious，previous和current来遍历列表
    #如果current是None，此时previous是倒数第一个元素，preprevious是倒数第二个元素
    #令preprevious的下一个元素是current，就达到删除倒数第一个元素的目的
    #同时要返回previous的值，即被删除元素的值
    def dequeue(self):
        current = self.head
        previous = None
        preprevious = None
        while current != None:
            preprevious = previous
            previous = current
            current = current.getNext()
        popitem = previous.getData()
        preprevious.setNext(current)
        return popitem

    #为得到队列的长度，利用current从头遍历到尾，同时用count计数
    #直到current为None，说明达到表尾，此时count即为队列的长度
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getNext()
        return count
