from Node import Node

class Stack:
    
    def __init__(self):
        self.head = None

    #判断栈是否为空，只需要判断head是否为None
    def isEmpty(self):
        return self.head == None

    #向栈中压入元素，相当于从链表头加入元素
    def push(self,item):
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp

    #从栈中提取元素，相当于从链表头删除元素，并返回删除的元素
    #直接令head等于head的下一个元素可以达到删除head当前元素的目的
    def pop(self):
        popitem = self.head.getData()
        self.head = self.head.getNext()
        return popitem

    #窥探栈顶的元素，相当于看一下head，即返回head的值
    def peek(self):
        return self.head.getData()

    #为得到栈的长度，利用current从头遍历链表，同时用count计数
    #直到current为None，说明达到表尾，此时count即为栈的长度
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getNext()
        return count
