from Node import Node
from UnorderedList import UnorderedList

class OrderedList(UnorderedList):
    
    def __init__(self):
        UnorderedList.__init__(self)

    def add(self,item):
        temp = Node(item)
        current = self.head
        previous = None
        #如果列表为空，那么直接加到表头
        if self.head == None:
            temp.setNext(self.head)
            self.head = temp
        #如果列表不为空，则分为添加项按照顺序应该加在表头、表中和表尾三种情况
        else:
            #如果一开始head就比添加项大，那么就应该直接加在表头
            if current.getData() >= item:
                temp.setNext(self.head)
                self.head = temp
            else:
                #如果head比添加项大，说明添加位置在表中或表尾，此时就应该遍历列表
                #如果在表中，那么while循环在找到添加位置后终止，插入中间
                #但如果在表尾，最后current会变成None，while语句不再适用
                #于是每移动一次，就判断一下current是不是None
                #如果是None，说明到表尾了，添加到表尾，并终止while循环
                #如果不是None，就继续，进行合适的插入
                while current.getData() < item:
                    previous = current
                    current = current.getNext()
                    if current == None:
                        previous.setNext(temp)
                        break
                    else:
                        continue
                temp.setNext(current)
                previous.setNext(temp)
    
    #判断列表是否为空，只需要判断head是否为None即可
    def isEmpty(self):
        return self.head == None
    
    #从头开始利用current遍历列表，利用found和stop来控制过程
    #一旦current大于要查找的数据项，说明后面已经不可能再有要查找的数据项，返回False
    #如果current等于要查找的项，found=True,终止while循环；否则一直没有找到，found＝False
    def search(self,item):
        current = self.head
        found = False
        stop = False
        while current != None and not found and not stop:
            if current.getData() == item:
                found = True
            else:
                if current.getData() > item:
                    stop = True
                else:
                    current = current.getNext()
        return found

    insert = None #有序表中没有insert函数，故禁止其运行

    append = None #有序表中没有append函数，故禁止其运行

    
