#定义没有切片的二分搜索，添加两个新参数——端点值first和last，用以记录“切片”的开始和结束
def noSlicebinarySearch(item,alist,first,last):
    #结束条件：如果first等于last，意味着已经到最小切片，即为1个，说明搜索结束，返回False
    if last - first == 0:
        return False
    else:
        #采用middle将数据分为两半，如果middle正好是所要找的值，则True
        middle = (first + last) // 2
        if alist[middle] == item:
            return True
        else:
            #根据middle对应值和查找值的大小比较，重新在左半边或者右半边进行查找，递归调用
            if item < alist[middle]:
                return noSlicebinarySearch(item,alist,0,middle)
            else:
                return noSlicebinarySearch(item,alist,middle+1,last)

#定义有切片的二分搜索，只需要alist和item两个参数即可，采用切片进行递归
def slicebinarySearch(alist,item):
    #结束条件：切片长度为零，搜索结束
    if len(alist) == 0:
        return False
    else:
        #找到midpoint，采用切片方式进行缩小规模
        midpoint = len(alist) // 2
        if alist[midpoint] == item:
            return True
        else:
            #根据midpoint对应值和查找值的大小比较，重新在左半边或者右半边进行查找，递归调用
            if item < alist[midpoint]:
                return slicebinarySearch(alist[:midpoint],item)
            else:
                return slicebinarySearch(alist[midpoint+1:],item)

import random
import timeit
#从千万级别的列表中随机选取百万级别的数
alist = sorted(random.sample(range(10**7),10**6))
#分别记录无切片二分搜索所需要的时间和有切片二分搜索所需要的时间，进行输出和比较
noSliceSearch = timeit.Timer('noSlicebinarySearch(%d,alist,%d,%d)'%(100,0,len(alist)),\
                             'from __main__ import random,noSlicebinarySearch,alist')
noSliceSearchtime = noSliceSearch.timeit(number=10)
sliceSearch = timeit.Timer('slicebinarySearch(alist,%d)'%100,\
                             'from __main__ import random,slicebinarySearch,alist')
sliceSearchtime = sliceSearch.timeit(number=10)
print('%.5f,%.5f' % (noSliceSearchtime,sliceSearchtime))

