#采用三点取样法的快速排序，从数据表的头、尾、中间选出中值
def partition(alist,first,last):
    pivotvalue = alist[first] #选定中值

    #左右标初值
    leftmark = first + 1
    rightmark = last

    done = False
    while not done:
        
        #向右移动左标
        while leftmark <= rightmark and \
              alist[leftmark] <= pivotvalue:
            leftmark = leftmark + 1
        
        #向左移动右标
        while alist[rightmark] >= pivotvalue and \
              rightmark >= leftmark:
            rightmark = rightmark - 1
                
        #两标相错就结束移动
        if rightmark < leftmark:
            done = True
        else: #左右标指向的值交换，继续移动
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp

    #中值就位
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp

    return rightmark #中值点，也是分裂点

def quickSortHelper(alist,first,last):
    if first < last:#基本结束条件
        splitpoint = partition(alist,first,last)#分裂为两部分
        #递归调用，两部分分别进行快速排序
        quickSortHelper(alist,first,splitpoint-1)
        quickSortHelper(alist,splitpoint+1,last)

def oldQuickSort(alist): #传统的快速排序方法，把第一个数作为中值
    quickSortHelper(alist,0,len(alist)-1)

def newQuickSort(alist): #采用三点取样法的快速排序，从数据表的头、尾、中间选出中值
    midvalue = sorted([alist[0],alist[len(alist)//2],alist[-1]])[1]
    temp = alist[0]
    alist[0] = alist[alist.index(midvalue)]
    alist[alist.index(midvalue)] = temp
    quickSortHelper(alist,0,len(alist)-1)

import sys #调整递归深度至1000000层
sys.setrecursionlimit(1000000)

import timeit
alist = [i for i in range(1000)]
#采用首数中值和三点取样的快速排序方法分别对0-999的有序表进行排序，观察所用时间
oldSorta = timeit.Timer('oldQuickSort(alist)',\
                       'from __main__ import oldQuickSort,alist')
oldtimea = oldSorta.timeit(number=1)
newSorta = timeit.Timer('newQuickSort(alist)',\
                       'from __main__ import newQuickSort,alist')
newtimea = newSorta.timeit(number=1)
print('%.10f,%.10f'%(oldtimea,newtimea))

import random
blist = random.sample(range(10000),1000)
#采用首数中值和三点取样的快速排序方法分别对从0-9999种随机取1000个数的数列进行排序，观察所用时间
oldSortb = timeit.Timer('oldQuickSort(blist)',\
                       'from __main__ import oldQuickSort,blist')
oldtimeb = oldSortb.timeit(number=1)
newSortb = timeit.Timer('newQuickSort(blist)',\
                       'from __main__ import newQuickSort,blist')
newtimeb = newSortb.timeit(number=1)
print('%.10f,%.10f'%(oldtimeb,newtimeb))
