from pythonds.basic.stack import Stack

# 说明：算法由百度学习而来，加上了自己对算法的完善
before = {"#":0, "(":6, "+":2, "-":2, "*":4, "/":4, ")":1}
after = {"#":0, "(":1, "+":3, "-":3, "*":5, "/":5}
# 以上字典，将操作符进栈前和进栈后的优先级具体化，以便于判断操作的优先级
operandStack = Stack() # 建立操作数栈
operatorStack = Stack() # 建立操作符栈


def getresult(expression): # 函数getresult
    lst = expression.split() # 按空格区分
    lst.append("#") # 加入终止符#
    for obj in lst: # 对lst中的每个元素obj
        if obj in "0123456789": # 如果obj是数字（仅个位数）
            operandStack.push(int(obj)) # 将数字放入操作数栈中
        elif obj in "+-*/()": # 如果obj是除#之外的操作符
            if not operatorStack.isEmpty(): # 如果操作符栈中不空
                if before[obj] < after[operatorStack.peek()]: # 如果放入栈前obj的优先级低于放入栈后操作符栈顶的操作符的优先级
                    if operandStack.size() != 1: # 如果operand栈不止一个元素
                        operandStack.push(calculate()) # 进行计算
                        # 以下操作，目的是判断前面已有的数是否可以和现在的obj再进行计算，以及是否将当前操作符压入
                        # 前两个目的都是防止后面漏掉，peek操作数栈的时候只peek了栈顶，而理论上最后的栈顶应为结果
                        if (not operatorStack.isEmpty()) and (before[obj] < after[operatorStack.peek()]):
                            # 如果放入栈前obj的优先级低于现在放入栈后操作符栈顶的操作符的优先级 且 操作符栈不为空
                            operandStack.push(calculate()) # 再进行计算
                            operatorStack.push(obj) # 将当前操作符压入栈中
                        elif (not operatorStack.isEmpty()) and (before[obj] == after[operatorStack.peek()]):
                            operatorStack.pop() # 此时，经过各种操作，左右括号相遇，栈顶必为左括号，故将左括号pop出来，右括号不压入
                        else:
                            operatorStack.push(obj) # 将当前操作符压入栈中
                    else:
                        operatorStack.push(obj) # 将当前操作符压入栈中
                elif before[obj] > after[operatorStack.peek()]: # 如果放入栈前obj的优先级高于放入栈后操作符栈顶的操作符的优先级
                    operatorStack.push(obj) # 将当前操作符压入栈中
                else:
                # 如果放入栈前obj的优先级等于放入栈后操作符栈顶的操作符的优先级，
                # 此时，经过各种操作，左右括号相遇，栈顶必为左括号，故将左括号pop出来，右括号不压入
                    operatorStack.pop()
            else:
                operatorStack.push(obj) # 将当前操作符压入栈中
        elif obj == "#": # 如果当前操作符为终止符“#”
            result = calculate() # 计算
            if not operandStack.isEmpty(): # 为防止前面有漏算的，加一个if条件，将前面漏算的也算上
                operandStack.push(result)
                result = calculate()
    return result # 返回result


def calculate(): # 数学计算函数
    number2 = operandStack.pop()
    number1 = operandStack.pop()
    operator = operatorStack.pop()
    if operator == "*":
        return number1 * number2
    elif operator == "/":
        return number1 // number2
    elif operator == "+":
        return number1 + number2
    elif operator == "-":
        return number1 - number2

print(getresult(input()))

# 说在后面：网上说可以先放一个#在操作符栈里，不过想来想去似乎起不了什么作用？还是要判断。