# 实现一个基数排序算法，用于10进制的正整数排序。思路是保持10个队列（
# 队列0、队列1……队列9、队列main），开始，所有的数都在main队列，
# 没有排序。

from pythonds.basic.queue import Queue

def queue_sort(expression):
    lst = expression.split() # 去掉空格，形成列表
    main_queue = Queue() # 建立main队列
    dict = {} # 建立一个字典，键为数字，值为队列
    result = [] # 建立一个值的列表

    for i in range(10): # 建立队列0~9
        dict[i] = Queue()
    size = len(lst[0]) # 取队列第一项长度
    for obj in lst:
        if len(obj) > size:
            size = len(obj) # 功能1：获得最大数字的位数长度，以决定循环次数
        main_queue.enqueue(int(obj)) # 功能2：将所有数字放入main队列

    digit = 1 # 将数位设置为1
    while digit <= pow(10,size-1): # 设置条件：数位小于等于最大数的数位
        while not main_queue.isEmpty(): # 设置条件：main队列不为空
            element = main_queue.dequeue() # 取出main队列的一个元素
            dict[int((element/digit)%10)].enqueue(element) # 将取出的数放进对应的dict队列
        for k in range(10):
            while not dict[k].isEmpty(): # 如果该队列不为空
                main_queue.enqueue(dict[k].dequeue()) # 将数字从该队列中取出
        digit *= 10 # 数位*10

    while not main_queue.isEmpty():  # main队列不为空
        result.append(str(main_queue.dequeue()))  # 将队列加入一个列表

    return result # 返回排好序的列表

print(" ".join(queue_sort(input())))