from pythonds.basic.stack import Stack

def check_tag(file):
    tagStack = Stack() # 建立一个标签栈
    content = file.read() # 将文件全部读入content中，形成一个字符串
    for i in range(len(content)): # 对content中的所有字符，循环计算
        if content[i] == "<": # 如果遇到<
            j = i # 记下此时的位置
            str = "" # 建立一个空字符串
            while content[j+1] != ">":
                if content[j+1] != "/":
                    str = str + content[j+1] # 将后面内容读入字符串中，注意：/不读入！这样是便于对是否配对进行判断
                j += 1
            tagStack.push(str) # 将读取完毕的标签压入标签栈中
            if tagStack.size() > 1: # 如果标签栈内有至少2个元素
                tag1 = tagStack.pop() # 先后弹出
                tag2 = tagStack.pop()
                if tag1 != tag2: # 若不相等，还回去
                    tagStack.push(tag2)
                    tagStack.push(tag1)

    if tagStack.isEmpty(): # 判断：若栈空了，表明全部配对正确。理论上，最内层总是有配对成功的标签，可以根据这一点从内向外消除。
        return True
    else: # 若栈没空，即消除不成功，表明有配对错误的！
        return False

example = open("example.txt", "r") # 打开一个以txt格式储存的HTML代码文件，在这里我写了一个示例。
print(check_tag(example)) # 附：在不考虑html标签内有<符号的基础上，这个代码是成立的。。。
example1 = open("example1.txt", "r")
print(check_tag(example1))