import random
import timeit
import sys
sys.setrecursionlimit(1000000)
def quicksort(alist):
    quicksorthelper(alist,0,len(alist)-1)
def quicksorthelper(alist,first,last):
    if first < last:
        splitpoint = part1(alist,first,last)
        quicksorthelper(alist,first,splitpoint-1)
        quicksorthelper(alist,splitpoint+1,last)
def part1(alist,first,last):
    pvalue = alist[first]

    leftmark = first+1
    rightmark = last

    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pvalue:
            leftmark += 1
        while alist[rightmark] >= pvalue and rightmark >= leftmark:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return  rightmark


def quicksort2(alist):#中值为全数列平均数
    quicksorthelper2(alist,0,len(alist)-1)
def quicksorthelper2(alist,first,last):
    if first < last:
        splitpoint2 = part2(alist,first,last)
        quicksorthelper2(alist,first,splitpoint2-1)
        quicksorthelper2(alist,splitpoint2+1,last)
def part2(alist,first,last):
    pvalue = 0
    for i in range(0,last-first):
        pvalue += alist[first+i]
    pvalue = pvalue//(last-first)
    while pvalue not in alist[first:last]:
        pvalue -= 1
    for i in range(0,last-first):
        if pvalue == alist[first+i]:
            u = first+i
    alist[first],alist[u] = alist[u],alist[first]

    leftmark = first+1
    rightmark = last

    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pvalue:
            leftmark += 1
        while alist[rightmark] >= pvalue and rightmark >= leftmark:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return rightmark






def quicksort4(alist,n):#中值为任取n（奇数）数中值
    quicksorthelper4(alist,0,len(alist)-1,n)
def quicksorthelper4(alist,first,last,n):
    if first < last-n:
        splitpoint4 = part4(alist,first,last,n)
        quicksorthelper4(alist,first,splitpoint4-1,n)
        quicksorthelper4(alist,splitpoint4,last,n)
    else:#排列n数字
        for passnum in range(last-first,0,-1):
            for i in range(passnum):
                if alist[first+i]>alist[first+i+1]:
                    alist[first+i],alist[first+i+1]=alist[first+i+1],alist[first+i]

def part4(alist,first,last,n):
    a = [j for j in range(0,last-first)]
    random.shuffle(a)
    plist = []
    qlist = []
    for i in range(0,n):
        plist.append(a[i])
        qlist.append(alist[first+a[i]])
    qlist.sort()
    pvalue = qlist[n//2]
    count = 0
    for j in range(0,n):
        if alist[first+plist[j]] == pvalue:
            count = plist[j]
    alist[first],alist[first+count] = alist[first+count],alist[first]
    leftmark = first+1
    rightmark = last

    done = False
    while not done:
        while leftmark <= rightmark and alist[leftmark] <= pvalue:
            leftmark += 1
        while alist[rightmark] >= pvalue and rightmark >= leftmark:
            rightmark -= 1
        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp
    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp
    return rightmark

for i in range (10,1001,10):#进行时间计算
    t1 = timeit.Timer("quicksort(alist)","from __main__ import random,alist,quicksort,quicksorthelper,part1")
    t2 = timeit.Timer("quicksort2(alist)","from __main__ import random,alist,quicksort2,quicksorthelper2,part2")
    t4 = timeit.Timer("quicksort4(alist,3)","from __main__ import random,alist,quicksort4,quicksorthelper4,part4")
    b = [j for j in range(0,1000)]
    random.shuffle(b)
    alist = b[:i]
    time1 = t1.timeit(number=10)
    time2 = t2.timeit(number=10)

    time4 = t4.timeit(number=10)
    print("%d\t%10.8f\t%10.8f\t%10.8f"%(i,time1,time2,time4))