class Node():
    def __init__(self, data):
        self.data = data
        self.next = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self, newdata):
        self.data = newdata
    def setNext(self, newnext):
        self.next = newnext
# 建立节点
# 在建立无序表的时候引进一个lsize表示列表的大小，方便之后进行一系列的操作，当然这个属性需要去维护
class unorderedlist():
    def __init__(self):
        self.head = None
        self.lsize = 0
    def add(self, item):  # 在列表顶端加入一个元素
        temp = Node(item)
        temp.setNext(self.head)  # 在列表的顶端加入该节点
        self.head = temp
        self.lsize += 1  # 列表大小加一，以后方法中涉及到大小改变的都要做类似处理
    def append(self, item):  # 在列表尾端加入一个元素
        temp = Node(item)
        if self.head == None:  # 空列表单独拿出来讨论
            self.head = temp
        else:  # 含有元素的列表进行以下处理
            current = self.head
            while current.getNext() != None:
                current = current.getNext()
            current.setNext(temp)
        self.lsize += 1
    def index(self, item):  # 找到某元素第一次出现的位置
        current = self.head
        i = 0  # 设计一个变量存储元素的位置
        while current.getNext() != None and current.getData() != item:
            current = current.getNext()
            i += 1
        if current.getData() != item:  # 考虑该元素不存在的情况返回None
            return None
        else:
            return i
    def pop(self, num=-1):  # 删去列表中某位置的数，默认值为列表尾端
        if num < 0:
            num += self.lsize  # 首先将输入参数进行处理使之为正数
        current = self.head
        previous = None  # 设计一个变量存储前一个节点
        if num == 0:  # 队首情况单独拿出来讨论
            self.head = current.getNext()
        else:  # 删去指定位置的节点
            i = 0  # 用一个变量来找到对应位置
            while i < num:
                previous = current
                current = current.getNext()
                i += 1
            result = current.getData()
            previous.setNext(current.getNext())
        self.lsize -= 1
        return result
    def insert(self, num, item):  # 将一个元素加入到设定好的位置中
        if num < 0:  # 首先将数据转化为正数进行处理
            num += self.lsize
        temp = Node(item)
        if num == 0:  # 队首情况单独拿出来进行处理
            temp.setNext(self.head)
            self.head = temp
        else:  # 其余情况的处理
            i = 0  # 设计一个变量来方便找到指定位置
            current = self.head
            while i < num - 1:
                current = current.getNext()
                i += 1
            temp.setNext(current.getNext())
            current.setNext(temp)
        self.lsize += 1
    def __str__(self):  # 将无序表转化为字符串输出
        s = '['
        i = 0
        current = self.head
        if current == None:  # 考虑表格为空的情况
            s += ']'
        else:  # 表格不为空的情况
            while current.getNext() != None:
                s = s + repr(current.getData()) + ','
                current = current.getNext()
            s = s + repr(current.getData()) + ']'
        return s  # 将编排好的字符串返回
    def __getitem__(self, num):  # 找到对应位置的元素或者进行切片
        if isinstance(num, int):  # 首先如果输入的是int类型，就找到对应位置的数
            if num < 0:  # 首先将位置的数转换成正数
                num += self.lsize
            current = self.head
            i = 0  # 设计一个变量来找到对应位置
            while i < num:
                current = current.getNext()
                i += 1
            return current.getData()
        else:  # 如果是一个slice类型，则对它进行切片
            start = num.start
            stop = num.stop
            step = num.step
            if step == None:  # 首先对步数是正还是负进行讨论
                step = 1
            if step > 0:  # 如果步数为正则进行以下操作来规范数据
                if start == None:
                    start = 0
                elif start + self.lsize < 0:
                    start = 0
                elif start < 0:
                    start += self.lsize
                if stop == None:
                    stop = self.lsize
                elif stop + self.lsize < 0:
                    stop = 0
                elif stop > self.lsize:
                    stop = self.lsize
                elif stop < 0:
                    stop += self.lsize
            if step < 0:  # 如果步数为负则进行以下操作来规范数据，思路与正数相同，只是正负性恰好相反
                if start == None:
                    start = -1
                elif start - self.lsize >= 0:
                    start = -1
                elif start >= 0:
                    start -= self.lsize
                if stop == None:
                    stop = -1 - self.lsize
                elif stop - self.lsize >= 0:
                    stop = -1
                elif stop < -self.lsize:
                    stop = -1 - self.lsize
                elif stop >= 0:
                    stop -= self.lsize
            s = unorderedlist()  # 设计一个新的无序表来存数据
            for x in range(start, stop, step):
                s.append(self[x])
            return s
    def isEmpty(self):  # 判定列表是否为空
        return self.head == None
    def size(self):  # 求列表的大小，即元素个数
        return self.lsize
    def remove(self, item):  # 从列表中移除一个数据
        current = self.head
        previous = None  # 设定一个变量来存前一个节点
        found = False  # 设定一个变量来判定是否终止寻找
        while not found:
            if current.getData() == item:
                found = True
            else:
                previous = current
                current = current.getNext()
        if previous==None:#元素在队首的情况
            self.head = current.getNext()
        else:#其余情况
            previous.setNext(current.getNext())
        self.lsize -= 1
    def search(self, item):#设置一个函数来寻找元素
        current = self.head
        while current.getNext() != None:
            if current.getData() == item:#若找到该元素则终止
                return True
            else:
                current = current.getNext()
        if current.getData() != item:#如果最终得到的仍不是元素，则未找到
            return False
        else:
            return True

#以下是我用来检验是否正确时所采用的,因它会在我下一篇中对无序表引用一同出现，故加上了注释符号
# a = unorderedlist()
# for i in range(10):
#     a.append(i)
# a.add('hlb')
# print(a)
# print(a.index(2))
# result = a.pop(2)
# print(result)
# a.insert(4, 'hhh')
# print(str(a))
# print(a[-1])
# print(a[1:9:2])
# print(a[-2:0:-2])
# a.remove('hhh')
# print(a)
# print(a.search('hhh'))
# print(a.size())