#取中值采用最大值最小值求平均数
#时间量级稳定在n（logn+2）,有时候比用首项当中值快，有时慢


def quecksort(aList,n):
    quecksortHelper(aList,0,len(aList)-1,n)
def quecksortHelper(aList,first,last,n):
    if first < last:
        splitpoint = partition(aList,first,last,n)
        quecksortHelper(aList, first, splitpoint - 1,n)
        quecksortHelper(aList, splitpoint + 1, last,n)
def partition(aList,first,last,n):
    pivotvalue = n
    leftmark = first + 1
    rightmark = last
    done = False
    while not done:
        while leftmark <= rightmark and aList[leftmark] <= pivotvalue:
            leftmark = leftmark + 1
        while leftmark <= rightmark and aList[rightmark] >= pivotvalue:
            rightmark = rightmark - 1
        if rightmark < leftmark:
            done = True
        else:
            temp = aList[leftmark]
            aList[leftmark] = aList[rightmark]
            aList[rightmark] = temp
    temp = aList[first]
    aList[first] = aList[rightmark]
    aList[rightmark] = temp
    return  rightmark
import timeit
import random
myfunction=timeit.Timer("quecksort(alist,n)","from __main__ import quecksort,n,alist")#取了中值的函数
oldfunction=timeit.Timer("quecksort(alist,alist[0])","from __main__ import quecksort,alist")#以第一项为中值的函数
print("  my     old one")
for i in range(100,1000,100):
    alist=list(range(i))
    random.shuffle(alist)#打乱列表
    oldtime = oldfunction.timeit(number=1000)
    i = 0
    min = max = alist[0]
    while i < len(alist):
        if alist[i] < min:
            min = alist[i]#遍历寻找最大值和最小值
        elif alist[i] > max:
            max = alist[i]
        i = i + 1
    n = (max + min) // 2#取平均
    print(n)
    mytime = myfunction.timeit(number=1000)
    print("%5.5f  %5.5f"%(mytime,oldtime))