import copy

class UnoderedlistUnderFlowError(ValueError):           #定义无序链表的大小过小时的下溢异常
    pass

class Node:                         #定义节点以及其方法用于封装
    def __init__(self, item):
        self.data = item
        self.next = None
    def getData(self):
        return self.data
    def getNext(self):
        return self.next
    def setData(self, item):
        self.data = item
    def setNext(self, node):
        self.next = node

class Unorderedlist:
    def __init__(self):             #初始器，返回一个空链表
        self.head = None
    def add(self, item):        #分空的和非空的两种情况添加元素
        if self.head == None:
            self.head = Node(item)
            self.head.setNext(None)
        else:
            temp = Node(item)       #建立一个临时变量方便书写代码
            temp.setNext(self.head)
            self.head = temp
    def size(self):                         #利用循环到末尾None来返回长度
        i = 0
        current = self.head
        while current != None:
            i += 1
            current = current.getNext()
        return i
    def search(self, item):         #循环检测是否存在该数据
        current = self.head
        while current !=None:
            if current.getData() != item:
                current = current.getNext()
            else:
                return True
        return False
    def remove(self, item):         #分为只有一个元素和有多个元素几种情况。
        pre = self.head
        current = self.head.getNext()
        if self.head.getData() == item:
            self.head = self.head.getNext()
        else:
            while current !=None:
                if current.getData() != item:
                    pre = current
                    current = current.getNext()
                else:
                    pre.setNext(current.getNext())
    def append(self, item):         #分为链表为空和链表非空两种情况，利用循环找到末尾然后进行处理
        if self.head == None:
            self.head = Node(item)
        else:
            current = self.head
            while current.getNext() != None:
                current = current.getNext()
            current.setNext(Node(item))
    def index(self, item):          #利用循环，查找的同时累加计数器
        i = 0
        current = self.head
        while current != None:
            if current.getData() == item:
                return i
            else:
                current = current.getNext()
                i += 1
    def pop(self, num = None):          #将默认值设置为None是为了方便书写，实际上的默认值利用if设置为最后一位
        n = self.size()                     #将长度算出方便计算
        if num == None:
            num = n -1
        if num >= n or self.head == None:           #分为溢出，在开始处pop，结尾处pop，其他情况，其中结尾处pop又分为只有一个元素和多个元素几种情况
            raise UnoderedlistUnderFlowError
        elif num == 0:                              #开始处pop
            temp = self.head
            self.head = self.head.getNext()
            return temp.getData()
        elif num == n - 1:                  #末尾处pop
            if self.head.getNext() == None:         #只有一个元素
                temp = self.head.getData()
                self.head = None
                return temp
            else:                                       #有多个元素
                pre = self.head
                current = self.head.getNext()
                while current.getNext() != None:
                    pre = current
                    current = current.getNext()
                temp = current.getData()
                pre.setNext(None)
                return temp
        else:                               #在其他的位置pop
            i = 1
            pre = self.head
            current = self.head.getNext()
            while i != num:
                i += 1
                pre = current
                current = current.getNext()
            temp = current.getData()
            pre.setNext(current.getNext())
            return temp
    def insert(self, num, item):            #利用循环查找位置，然后插入
        if num > self.size():
            raise UnoderedlistUnderFlowError
        elif num ==0:                       #在开始位置插入
            temp = Node(item)
            temp.setNext(self.head)
            self.head = temp
        else:                           #在其他位置插入
            i = 0
            current = self.head
            while i != num - 1:
                i += 1
                current = current.getNext()
            temp = Node(item)
            temp.setNext(current.getNext())
            current.setNext(temp)
    def __str__(self):              #利用列表解析和迭代器返回列表形式的输出字符串
        return [x for x in self].__str__()
    def __next__(self):         #构造next方法，其中定义一个locator用于记录当前状况，每次返回当前所在位置的数据
        if self.locator != None:
            temp = self.locator.getData()
            self.locator = self.locator.getNext()
            return temp
        else:
            raise StopIteration
    def __iter__(self):       #每次构造一个新的迭代器时把locator初始化
        self.locator = self.head
        return self
    def __getitem__(self, n):       #定义索引和切片方法
        if isinstance(n, int):          #定义索引方法，同样利用循环
            if n >= self.size():
                raise IndexError
            else:
                i = 0
                current = self.head
                while i != n:
                    current = current.getNext()
                    i += 1
                return current.getData()
        elif isinstance(n, slice):      #定义切片方法，只需循环到应有的位置，修改开头和结尾的节点即可
            cp = copy.deepcopy(self)    #由于切片应该是复制品，创建一个复制的对象处理。
            start = n.start
            end = n.stop
            i = 0
            current = cp.head
            while i < end - 1:
                if i == start:
                    cp.head = current
                i += 1
                current = current.getNext()
            current.setNext(None)
            return cp
    __repr__ = __str__
