from pythonds.basic.stack import Stack

def do(op,op1,op2):   #操作符运算
    if op =="*":
        return op1*op2
    if op == "/":
        return op1/op2
    if op == "+":
        return op1+op2
    else:
        return op1-op2

def calculate(s):
    prec = {}   #定义优先级
    prec["+"] = 2
    prec["-"] = 2
    prec["*"] = 3
    prec["/"] = 3
    prec["("] = 1
    opstack = Stack()   #opstack暂存运算符
    postack = Stack()   #postack存储操作数，并及时进行进行数字运算
    list = s.split()   #将输入的表达式存成列表格式

    for t in list:
        if t in "0123456789":
            postack.push(int(t))    #将操作数放入postack
        elif t == "(":
            opstack.push(t)    #将括号放入opstack
        elif t == ")":
            top = opstack.pop()
            while top !="(":    #依次弹出opstack中所有（之后的运算符
                op2 = postack.pop()   #弹出运算符后及时与postack中后两位操作数进行运算
                op1 = postack.pop()
                result = do(top,op1,op2)
                postack.push(result)   #将运算得的值放回postack
                top = opstack.pop()
        else:   #若输入的是一个运算符，则弹出opstack中所有比它优先级高的运算符，然后再将该运算符放入opstack
            while (not opstack.isEmpty()) and ( prec[opstack.peek()] >= prec[t] ):
                op2 = postack.pop()   #弹出运算符后及时与postack中后两位操作数进行运算
                op1 = postack.pop()
                result = do(opstack.pop(),op1,op2)
                postack.push(result)   #将运算得的值放回postack
            opstack.push(t)

    while (not opstack.isEmpty()):   #扫描完表达式，opstack与postack中均有可能有剩余操作数/运算符，需将它们处理
        op2 = postack.pop()   #弹出opstack运算符后与postack中后两位操作数进行运算
        op1 = postack.pop()
        result = do(opstack.pop(),op1,op2)
        postack.push(result)   #将运算得的值放回postack

    return postack.pop()   #最终postack中只剩一个数，该数即为整个表达式的值


s = input()
print(calculate(s))