from pythonds.basic.stack import Stack
#定义中缀转后缀并计算的函数
def intopoeval(infixExpr):
#定义操作符优先级
    prec={}
    prec["^"]=4
    prec["*"]=3
    prec["/"]=3
    prec["+"]=2
    prec["-"]=2
    prec["("]=1
#创建操作符栈与操作数栈
    opStack=Stack()
    numStack=Stack()
#读入中缀表达式并解析
    tokenlist=infixExpr.split()
#转化表达式并求值
    for token in tokenlist:
        if token == "(":
            opStack.push(token)       #若读入为'('，压入符栈顶
        elif token == ")":
            topToken=opStack.pop()      #若读入为')',从符栈顶弹出操作符
            while topToken != "(":
                num2=numStack.pop()
                num1=numStack.pop()
                result=domath(topToken,num1,num2)  #从数栈顶弹出两数，利用已弹出的操作符进行计算
                numStack.push(result)     #将计算结果压入数栈顶
                topToken=opStack.pop()      #从符栈顶弹出新的操作符，重复上述步骤，直到出现'('
        elif token in "+-*/^":
            if not opStack.isEmpty() and\
                    prec[token]<=prec[opStack.peek()]: #读入的操作符为数学运算符，比较优先级
                topToken=opStack.pop()      #若读入的操作符优先级低于符栈顶操作符，弹出符栈顶操作符
                num2=numStack.pop()
                num1=numStack.pop()
                result=domath(topToken,num1,num2)
                numStack.push(result)       #弹出数栈顶两数，运算，并压入数栈顶
                opStack.push(token)         #将读入操作符压入符栈顶
            else:
                opStack.push(token)     #若读入操作符优先级高于符栈顶操作符，直接压入符栈顶
        else:
            numStack.push(float(token))       #若读入为数，压入数栈顶
#将剩余的符栈顶操作符与数栈顶的数取出、做运算并压入数栈顶
    while not opStack.isEmpty():
        num2 = numStack.pop()
        num1 = numStack.pop()
        topToken=opStack.pop()
        result = domath(topToken, num1, num2)
        numStack.push(result)
    return numStack.pop()   #返回数栈顶
#定义domath函数
def domath(op,num1,num2):
    if op == '^':
        return num1**num2
    elif op == '*':
        return num1*num2
    elif op == '/':
        return num1/num2
    elif op == '+':
        return num1+num2
    elif op == '-':
        return num1-num2
infixExpr=input()
print(intopoeval(infixExpr))