from timeit import Timer
import random
import sys


def binarySearch1(start, end, alist, item):    #.....不用切片
    if start > end:
        return False
    else:
        mid = (start + end) // 2
        if alist[mid] == item:
            return True
        elif alist[mid] < item:
            return binarySearch1(mid + 1, end, alist, item)
        else:
            return binarySearch1(start, mid - 1, alist, item)


def binarySearch2(alist, item):      #.....用切片
    if len(alist) == 0:
        return False
    else:
        mid = len(alist) // 2
        if alist[mid] == item:
            return True
        elif alist[mid] < item:
            return binarySearch2(alist[mid+1:], item)
        else:
            return binarySearch2(alist[:mid], item)

sys.setrecursionlimit(1000000)        #.......手工设置递归调用深度
alist = sorted([random.randrange(1000000) for i in range(1000000)])      #.......随机生成百万级有序表
for i in range(2):      #......两次对比
    item = random.randrange(1000000)          #.......随机生成待查找项
    print("\nSearching for %d in the OrderedList" % item)
    print("Not using slices:\n",
          Timer("binarySearch1(0, len(alist)-1, alist, item)",
                "from __main__ import binarySearch1, alist, item").timeit(number=100))
    print("Using slices:\n",
          Timer("binarySearch2(alist, item)", "from __main__ import binarySearch2, alist, item").timeit(number=100))
#得出结论
print('''\nConclusion:
    Time consumed can differ by 1,000 times!
    Avoid using slices in the recursion saves time significantly while doing the binary search.''')
