import random
import timeit

#更快的二分查找
#传四个参数，多两个头和尾
def fastbinarySearch(alist,item):
    return fastbinarySearch1(alist,item,0,len(alist) - 1)
def fastbinarySearch1(alist,item,start,end):
    if start > end:
        return False
    else:
        midpoint = (start + end) // 2
        if alist[midpoint] == item:
            return True
        #用头尾参数实现“切片”
        else:
            if item < alist[midpoint]:
                return fastbinarySearch1(alist,item,start,midpoint - 1)
            else:
                return fastbinarySearch1(alist,item,midpoint + 1,end)

#很慢的二分查找
def binarySearch(alist,item):
    if len(alist) == 0:
        return False
    else:
        midpoint = len(alist) // 2
        if alist[midpoint] == item:
            return True
        else:
            if item < alist[midpoint]:
                return binarySearch(alist[:midpoint],item)
            else:
                return binarySearch(alist[midpoint + 1:],item)

#生成百万级别的列表比较两种方法的查找性能
for i in range(1000000,10000000,1000000):
    alist = list(range(i))
    item = random.randrange(i)
    t1 = timeit.Timer('fastbinarySearch(alist,item)','from __main__ import fastbinarySearch,alist,item')
    t2 = timeit.Timer('binarySearch(alist,item)','from __main__ import binarySearch,alist,item')
    现方法时间 = t1.timeit(number=10)
    原方法时间 = t2.timeit(number=10)
    print('长度为%d,原方法时间为%lf，现方法时间为%lf'%(i,原方法时间,现方法时间))