import turtle
import random
#定义基本的画树函数
def drawtree(branchLen,t,size,color):   #参数：每一枝的长度，turtle，枝粗，颜色
    dgree = random.randrange(10,20)     #随机生成一个角度
    t.right(dgree)      #右转该角度
    tree(branchLen - 3, t, size * 0.8, color)       #递归到下一层，变短变细
    t.left(25)      #左转25度
    tree(branchLen - 3, t, size * 0.8, color)       #递归
    t.right(25-dgree)   #转回原方向
    t.up()
    t.backward(branchLen)
    t.down()        #抬起turtle，退回原处，放下turtle

#定义画树的函数
def tree(branchLen,t,size,color):   #参数：每一枝的长度，turtle，枝粗，颜色
    t.pensize(size)
    t.color(color)      #设置海龟的参数和颜色
    if branchLen < 24:
        color = 'green'     #若长度小于24，颜色改为绿
    if branchLen < 21:
        color = (34/255,139/255,34/255)     #长度小于21，改为浅一点的绿
    if branchLen < 15:
        cflag = random.randint(0,5)
        if cflag > 3:
            color = (0,1,0)
        else:
            color = 'pink'      #长度小于15，颜色随机生成为嫩绿或粉
    if branchLen>3:
        t.forward(branchLen)    #长度大于3就继续画
        bflag = random.randint(0,10)
        if branchLen<39:
            if bflag > 0:
                drawtree(branchLen,t,size,color)
            else:
                t.backward(branchLen)       #长度小于39时，随机生成数决定是否在这条枝上继续生长
        else:
            drawtree(branchLen, t, size, color)     #继续画树

#定义画主枝干的函数
def drawtrunk(t,degree1,degree2,m): #参数：turtle，初始的转角，弯曲生长的角度，转向方向（m=1右转，-1左转，0不转）
    t.right(degree1*m)          #turtle转向
    pensize = 10
    for i in range(degree2):
        t.forward(1.5)
        t.left(m)
        pensize = pensize * 0.999
        t.pensize(pensize)      #较圆滑地转向，平滑地变细
    tree(48,t,8,(138/255,54/255,15/255))    #在主枝干上长树
    t.up()
    t.left(180)
    for i in range(degree2):
       t.forward(1.5)
       t.right(m)
    t.down()
    t.right(180)    #返回起始点
    t.color(138/255,54/255,15/255)
    t.pensize(10)   #还原turtle的属性

#定义主函数
def main():
    turtle.tracer(0)
    t=turtle.Turtle()       #引入turtle
    myWin=turtle.Screen()
    t.left(90)
    t.up()
    t.backward(400)
    t.down()
    t.pensize(12)
    t.color(138/255,54/255,15/255)      #turtle转向，后退，设置参数
    t.forward(200)      #画树干
    # 画四个主枝干
    drawtrunk(t,50,30,1)
    drawtrunk(t,100,20,-1)
    drawtrunk(t,70,0,0)
    drawtrunk(t,100,0,1)
    myWin.exitonclick()
    turtle.upadta()
#调用主函数
main()