class HashTable:
    def __init__(self,th_value):
        self.size = 11
        self.slots = [None] * self.size
        self.data = [None] * self.size
        #阈值
        self.th_value = th_value
        #当前负载量
        self.temp = 0
    def hashfunction(self,key):
        return key % self.size

    def rehash(self,oldhash):
        return (oldhash + 1) % self.size

    def put(self,key,data):
        #每次put负载量都加1
        self.temp += 1
        #定义负载因子factor，超过阈值时则扩展散列表
        factor = self.temp / self.size
        if factor > self.th_value:
            self.expand()
        #存入key和data
        hashvalue = self.hashfunction(key)
        #key不存在的情况
        if self.slots[hashvalue] == None:
            self.slots[hashvalue] = key
            self.data[hashvalue] = data
        #key已存在，则替换data
        else:
            if self.slots[hashvalue] == key:
                self.data[hashvalue] = data
            #冲突的情况
            else:
                nextslot = self.rehash(hashvalue)
                while self.slots[nextslot] != None and self.slots[nextslot] != key:
                    nextslot = self.rehash(nextslot)
                if self.slots[nextslot] == None:
                    self.slots[nextslot] = key
                    self.data[nextslot] = data
                else:
                    self.data[nextslot] = data

    def expand(self):
        #定义临时储存key和data的一个字典
        mydict = {}
        for i in self.slots:
            if i != None:
                mydict[i] = self[i]
        #重置所有东西，包括负载量，大小等
        self.temp = 0
        self.size += 11
        self.slots = [None] * self.size
        self.data = [None] * self.size
        #再把原来的数据存进去
        for i in mydict:
            self[i] = mydict[i]

#与expand无关的其他函数如get等省略