def wordMinDistance(word1, word2):

    #word1为原单词, word2为新单词.
    len1 = len(word1)
    len2 = len(word2)
    # 建立两个二维列表，分别存储分数和操作
    grade = [[0] * (len2+1) for i in range(len1+1)]
    op = [[0] * (len2+1) for i in range(len1+1)]

    # 当新单词长度为零时，对应的操作均为删除
    for i in range(1, len1+1):
        grade[i][0] = i * 20
        op[i][0] = "删除 "
    # 当原单词长度为零时，对应的操作均为插入
    for j in range(1, len2+1):
        grade[0][j] = j * 20
        op[0][j] = "插入 "
    #  非零情况，应用动态规划的公式
    for i in range(1, len1+1):
        for j in range(1, len2+1):
            grade[i][j] = grade[i][j - 1] + 20
            op[i][j] = "插入 "
            if grade[i - 1][j] + 20 < grade[i][j]:
                grade[i][j] = grade[i - 1][j] + 20
                op[i][j] = "删除 "
            if word1[i - 1] == word2[j - 1] and grade[i - 1][j - 1] + 5 < grade[i][j]:
                grade[i][j] = grade[i - 1][j - 1] + 5
                op[i][j] = "复制 "
    # 回溯得到每步操作
    oplist = []
    i, j = len1, len2
    while i > 0 or j > 0:
        opi = op[i][j]
        oplist.append(opi)
        if opi == "复制 ":
            i -= 1
            j -= 1
        if opi == "删除 ":
            i -= 1
        if opi == "插入 ":
            j -= 1
    return grade[-1][-1], list(reversed(oplist))
# 测试
print(wordMinDistance("algorithm", "alligator"))
