#0/1背包
#maxw为限重；treasurelist为包含物品重量和价值信息的字典
# dynamic为嵌套列表；dynamic[n][w]表示在w限重下对前n个物品进行选取所能达到的最大价值
# itemsTaken为与（n, w）相对应的布尔值，表征dynamic[n][w]取值时是否选取了第n个物品（序号为n-1）
def DPmaxvalue(maxw, treasurelist, itemsTaken):
    dynamic = [[0] * (maxw + 1)]        #dynamic初始化，表示对于0至maxw的限重和不选取物品的情况，能达到的最大价值为0
    for n in range(1, len(treasurelist)+1):       #考察前n个物品(第n个物品的序号为n-1）
        dynamic.append([])       #随着n的递增，dynamic新添内嵌列表，用于存储与限重为0至maxw的情况相对应的最大价值
        for w in range(maxw + 1):
            if treasurelist[n-1]['w'] > w:        #第n个物品的重量超过了限重
                dynamic[n].append(dynamic[n-1][w])
                itemsTaken[(n, w)] = False        #标记“未选取”
            elif dynamic[n-1][w] >= treasurelist[n-1]['v'] + dynamic[n-1][w-treasurelist[n-1]['w']]:       #未超限重但不选取时获利更大
                dynamic[n].append(dynamic[n-1][w])
                itemsTaken[(n, w)] = False        #标记“未选取”
            else:         #选取时获利更大
                dynamic[n].append(treasurelist[n-1]['v'] + dynamic[n-1][w-treasurelist[n-1]['w']])
                itemsTaken[(n, w)] = True        #标记“选取”
    return dynamic[len(treasurelist)][maxw]        #返回最终条件下的最大价值


def listItems(maxw, treasurelist, itemsTaken):     #.......输出选取方案
    print("Indexes of Items Taken:")
    n = len(treasurelist)
    w = maxw
    while n > 0:        #.......倒序
        if itemsTaken[(n, w)]:     #......若选取则输出序号
            print(n-1)
            w -= treasurelist[n-1]['w']      #........回溯
            n -= 1
        else:
            n -= 1      #.......不输出，直接回溯

maxw = 20
treasurelist = eval(input())
itemsTaken = dict()
maxv = DPmaxvalue(maxw, treasurelist, itemsTaken)
listItems(maxw, treasurelist, itemsTaken)
print("Maximum Value:", maxv)
