#支持整型和浮点型的四则运算和幂次运算，支持输入任意含或不含空格的字符串
#import栈数据结构类型
class Stack:
	def __init__(self):
		self.items = []
	def isEmpty(self):
		return self.items == []
	def push(self, item):
		self.items.append(item)
	def pop(self):
		return self.items.pop()
	def peek(self):
		return self.items[-1]
	def size(self):
		return len(self.items)
#中缀转为后缀表达式
def TransPostfix(list1):
	opstack = Stack()
	outlist = []
	oppriority = {'(':0, '+':1, '-':1, '*':2, '/':2, '^':3}
	for symbol in list1:
		#判断读入字符类型
		#如果为括号
		#如果左括号，压入操作符栈
		if symbol == '(':
			opstack.push(symbol)
		#如果右括号，倾倒栈直到出现对应的左括号
		elif symbol == ')':
			sym1 = opstack.pop()
			while sym1 != '(':
				outlist.append(sym1)
				sym1 = opstack.pop()
		#如果为操作符
		elif isinstance(symbol, str):
			#如果操作符栈不为空，判断它和前者的优先级
			while (not opstack.isEmpty()) and \
			(oppriority[opstack.peek()]>=oppriority[symbol]):
				#倾倒栈直到操作符优先级比该操作符低
				outlist.append(opstack.pop())
				#压符入栈
			opstack.push(symbol)
		#如果为操作数，直接输出
		else:
			outlist.append(symbol)
	#栈中剩余的字符全部倒出
	while not opstack.isEmpty():
		outlist.append(opstack.pop())
	return outlist

#定义一系列运算
def Calculation(num1, num2, operator):
	if operator == '+':
		return num1 + num2
	elif operator == '-':
		return num2 - num1
	elif operator == '*':
		return num2 * num1
	elif operator == '/':
		return num2 / num1
	elif operator == '^':
		return num2 ** num1
		
#后缀运算		
def CalcuPostfix(postfixlist):
	#创建空栈存放计算数
	numlist = Stack()
	#遍历后缀表达式
	for element in postfixlist:
		#对操作符，pop出计算数栈的两个值，操作，压数入栈
		if isinstance(element, str):
			tempnum1 = numlist.pop()
			tempnum2 = numlist.pop()
			numlist.push(Calculation(tempnum1, tempnum2, element))
		#对操作数，压数入栈
		else:
			numlist.push(element)
	return numlist.pop()
#简单优化，自动判别一个字符串中的运算符部分和计算数部分
def splitterm(instr):
	#创建字符串的输出列表
	outlist = []
	#初始化一个首值一个尾值，用于存放数字串的首位置和尾位置
	sliceH = -1
	sliceE = -1
	for i in range(len(instr)):
		#如果是运算符
		if instr[i] in '(+-*/^)':
			#当此时存在正在记录的数字串时，中断数字串并输出
			if sliceH >=0:
				tempterm = instr[sliceH:sliceE+1]
				#判断是否含有小数点，若有转化为浮点数类型，否则整型
				if '.' in tempterm:
					outlist.append(float(tempterm))
				else:
					outlist.append(int(tempterm))		
				#重新初始化首尾值
				sliceE = sliceH = -1
			outlist.append(instr[i])
		#如果是数字。若此时无记录中的数字串，则定位首位置；否则增加尾位置
		elif instr[i] in '.0123456789':
			if sliceH < 0:
				sliceE = sliceH = i
			else:
				sliceE += 1
	#在最后，若还有记录中的数字串则输出
	if sliceH >=0:
		tempterm = instr[sliceH:sliceE+1]
		if '.' in tempterm:
			outlist.append(float(tempterm))
		else:
			outlist.append(int(tempterm))		
	return outlist
			
print(CalcuPostfix(TransPostfix(splitterm(input()))))
#日期戳 2017/3/23
