import random
import timeit

#算法说明：头、尾、中间取三个数，将他们的中位数换到头上，
#用它代表alist的中位数并找到比它大的和比它小的数，然后用
#递归将他们排序好。

def quickSort2(alist,start,end):
    if start >= end:
        return 0
    else:
        a1 = alist[start]
        a2 = alist[(start + end) // 2]
        a3 = alist[end]
        #求出头、尾和中间数的中位数找出来
        if (a1 >= a2 >= a3) or (a3 >= a2 >= a1):
            median = a2
        elif (a1 >= a3 >= a2) or (a2 >= a3 >= a1):
            median = a3
        else:
            median = a1
        #把中位数数和第一个数互换
        tempindex = alist.index(median)
        temp = alist[tempindex]
        alist[tempindex] = alist[start]
        alist[start] = temp

        left = start + 1
        right = end
        while left <= right:
            #在左侧找中位数大的数
            while left <= right and alist[left] <= median:
                left = left + 1
            #在右侧找比中位数小的数
            while left <= right and alist[right] >= median:
                right = right - 1
            #交换位置
            if left < right:
                temp = alist[left]
                alist[left] = alist[right]
                alist[right] = temp
                right = right - 1
                left = left + 1
        temp = alist[right]
        alist[right] = alist[start]
        alist[start] = temp
    #递归调用
    quickSort2(alist, start, right - 1)
    quickSort2(alist, right + 1, end)

#下面是课件的做法
def quickSort1(alist):
    quickSortHelper(alist,0,len(alist) - 1)

def quickSortHelper(alist,first,last):
    if first < last:
        splitpoint = partition(alist,first,last)

        quickSortHelper(alist,first,splitpoint - 1)
        quickSortHelper(alist,splitpoint + 1,last)

def partition(alist,first,last):
    pivotvalue = alist[first]

    leftmark = first + 1
    rightmark = last

    done = False
    while not done:

        while leftmark <= rightmark and alist[leftmark] <= pivotvalue:
            leftmark = leftmark + 1

        while alist[rightmark] >= pivotvalue and rightmark >= leftmark:
            rightmark = rightmark + 1

        if rightmark < leftmark:
            done = True
        else:
            temp = alist[leftmark]
            alist[leftmark] = alist[rightmark]
            alist[rightmark] = temp

    temp = alist[first]
    alist[first] = alist[rightmark]
    alist[rightmark] = temp

alist = []
for i in range(1000):
    alist.append(random.randint(0,10000))
t=timeit.Timer('quickSort2(alist,0,len(alist)-1)','from __main__ import quickSort2,alist')
t1=t.timeit(number=1)
T=timeit.Timer('quickSort1(alist,0,len(alist)-1)','from __main__ import quickSort1,alist')
t2=t.timeit(number=1)
print("随机表，我志己的方法用了%.6lfs，课件上的方法用了%.6lfs" %(t1,t2))

aalist = []
for i in range(1000,0,-1):
    aalist.append(i)
t=timeit.Timer('quickSort2(aalist,0,len(aalist)-1)','from __main__ import quickSort2,aalist')
t1=t.timeit(number=1)
T=timeit.Timer('quickSort1(aalist,0,len(aalist)-1)','from __main__ import quickSort1,aalist')
t2=t.timeit(number=1)
print("倒序表，我志己的方法用了%.6lfs，课件上的方法用了%.6lfs" %(t1,t2))

#从测试数据可以看到，对于随机表我的方法和课件方法用时差不多，甚至慢，因为多出求中位数和交换位置的过程；
#但如果是完全倒序表我的则要快很多的，所以这种算法有其应用价值。