import random
import time
#定义Qsort函数，用Qsorthelper递归
def mqsort(alist):
    mqsorthelper(alist,0,len(alist)-1)
#定义Qsorthelper函数
def mqsorthelper(alist,first,last):
    #数据未排序完成时，分裂，递归调用
    if first<last:
        splitpoint=mpartition(alist,first,last)     #分裂
        mqsorthelper(alist,first,splitpoint-1)
        mqsorthelper(alist,splitpoint+1,last)       #递归调用
#定义分裂函数
def mpartition(alist,first,last):
  #在列表中随机采三个点，取其中值作为列表的中值
    #randomlist = [alist[random.randint(0,len(alist)-1)] for i in range(3)].sort()
    randomlist = []
    for i in range(3):
        randomlist.append(alist[random.randint(0,len(alist)-1)])
    randomlist.sort()
    midvalue = randomlist[1]
    midpoint=alist.index(midvalue)
  #把中值换到第一个，其余与课件所给的快速排序方法相同
    alist[first],alist[midpoint]=alist[midpoint],alist[first]
  #选定中值
    pivotvalue=alist[first]
  #左右标初值
    leftmark=first+1
    rightmark=last
    done=False
  #分裂未完成时
    while not done:
        while leftmark<=rightmark and alist[leftmark]<=pivotvalue:
            leftmark+=1
        while rightmark>=leftmark and alist[rightmark]>=pivotvalue:
            rightmark-=1        #左标右移，右标左移
        if rightmark<leftmark:
            done=True   #两标交错，表示该次分裂已完成，停止移动
        else:
            alist[leftmark],alist[rightmark]=alist[rightmark],alist[leftmark]   #否则交换左右标的值，继续移动
    alist[first],alist[rightmark]=alist[rightmark],alist[first] #中值就位
    return rightmark    #返回中值点暨分裂点

#以下为课件上的取第一个值为中值的Qsort
def oqsort(alist):
    oqsorthelper(alist,0,len(alist)-1)
def oqsorthelper(alist,first,last):
    if first<last:
        splitpoint=opartition(alist,first,last)
        oqsorthelper(alist,first,splitpoint-1)
        oqsorthelper(alist,splitpoint+1,last)
def opartition(alist,first,last):
    pivotvalue=alist[first]
    leftmark=first+1
    rightmark=last
    done=False
    while not done:
        while leftmark<=rightmark and alist[leftmark]<=pivotvalue:
            leftmark+=1
        while rightmark>=leftmark and alist[rightmark]>=pivotvalue:
            rightmark-=1
        if rightmark<leftmark:
            done=True
        else:
            alist[leftmark],alist[rightmark]=alist[rightmark],alist[leftmark]
    alist[first],alist[rightmark]=alist[rightmark],alist[first]
    return rightmark
#定义时间测试函数
def test(qsort,times):
    starttime=time.time()
    for i in range(times):
        testlist=[random.randint(1,1000000) for i in range(5000)]
        qsort(testlist)
    endtime=time.time()
    return endtime - starttime
#注：不知道为什么timeit.Timer不能用，问了同学以后用了这种计时方法

#进行时间测试
print("随机三点取样中值快速排序",test(mqsort,100))
print("首值中值快速排序",test(oqsort,100))

#测试结果：自己写的快排花的时间几乎是课件上的10倍还多。可能是因为取中值的方法过于复杂，反而拖累了整个排序的效率
#以后再调试改进