#动态规划求解最短编辑距离
#定义操作符权重
def mark_op(operator):
    if operator is 'del':
        return 20
    elif operator is 'insert':
        return 20
    elif operator is 'copy':
        return 5

#求最短编辑距离的函数，参数为：两字符串word1，word2，操作列表op
def min_word2word(word1,word2,op):
    #获得每种操作的分数
    md = mark_op('del')
    mi = mark_op('insert')
    mc = mark_op('copy')
    #字符串转为列表
    s1,s2 = list(word1),list(word2)
    #获得两字符串的长度
    len1,len2 = len(s1),len(s2)
    #建立最小分数的二维列表
    min_mark = [[0 for i in range(len2+1)]for j in range(len1+1)]
    #遍历两字符串
    for i in range(1,len1+1):
        min_mark[i][0] = md * i
        for j in range(1,len2+1):
            min_mark[0][j] = mi * j     #初始化第0行和第0列
            #若两字符串的某两个字母相同
            if s1[i-1] == s2 [j-1]:
                #比较分数最小的操作，并加入操作列表（含复制）
                min_mark[i][j] = min(min_mark[i-1][j-1]+mc,min_mark[i-1][j]+md,\
                                             min_mark[i][j-1]+mi)
                if min_mark[i][j] == min_mark[i-1][j-1]+mc:
                    op[i][j] = op[i-1][j-1]+['复制：%c->%c'%(s1[i-1],s2[i-1])]
                elif min_mark[i][j] ==  min_mark[i-1][j]+md:
                    op[i][j] = op[i-1][j]+['删除：%c'%s1[i-1]]
                else:
                    op[i][j] = op[i][j-1]+['插入：%c'%s2[j - 1]]
            # 若两字符串的某两个字母不同
            else:
                # 比较分数最小的操作，并加入操作列表（不含复制）
                min_mark[i][j] = min(min_mark[i-1][j]+md,min_mark[i][j-1]+mi)
                if min_mark[i][j] == min_mark[i - 1][j] + md:
                    op[i][j] = op[i - 1][j]+['删除：%c' %s1[i - 1]]
                else:
                    op[i][j] = op[i][j - 1]+['插入：%c'%s2[j - 1]]
    return min_mark[len1][len2] #返回最小分数列表

#打印操作步骤
def printop(op):
    print("进行的操作是：")
    for s in op[len1][len2]:
        print(s)
#输入输出
word1 = input()
word2 = input()
len1,len2 = len(word1),len(word2)
op = [[[] for i in range(len2+1)]for j in range(len1+1)]    #创建操作列表
print("最小分数为：",min_word2word(word1,word2,op))
printop(op)