from pythonds.basic.stack import Stack
def doMath(op, op1, op2):  #后缀式的运算法则
    if op == '*':
        return op1 * op2
    elif op == '/':
        return op1 / op2
    elif op == '-':
        return op1 - op2
    else:
        return op1 + op2
def PostfixAndCompute(infixexpr):
    prec = {}
    prec['('] = 1
    prec['+'] = 2
    prec['-'] = 2
    prec['*'] = 3
    prec['/'] = 3  #计算符号的优先级
    opstack = Stack()  #用来存操作符
    operandstack = Stack()  #用来存操作值
    tokenlist = infixexpr.split()  #将中缀式每一个字符分开
    for token in tokenlist:  #对每一个字符进行判断
        if token in '1234567890':  #如果是数字
            operandstack.push(int(token))  #就压入操作值的栈顶
        elif token == "(":  #如果是左括号
            opstack.push(token)  #就压入操作符的栈顶
        elif token == ")":  #如果是右括号
            topToken = opstack.pop()  #将操作符栈顶的符号弹出给toptoken
            while topToken != "(":  #如果toptoken不是左括号，是其他操作符
                operand2 = operandstack.pop()  #将操作值栈中最后一个弹出给op2（考虑到运算法则，栈顶为后进入的，应该为op2）
                operand1 = operandstack.pop()  #弹出op2后 继续弹出op1
                operandstack.push(doMath(topToken, operand1, operand2))  #按法则运算
                topToken = opstack.pop()  #将操作符栈顶的符号弹出，准备下一次循环，直到碰到左括号，则删去左括号但不进行操作
        else:  #既不是数字也不是括号的情况
            while (not opstack.isEmpty()) and (prec[opstack.peek()] >= prec[token]): #操作符栈不空，且栈顶的优先级大于token
                operand2 = operandstack.pop()
                operand1 = operandstack.pop()
                operandstack.push(doMath(opstack.pop(), operand1, operand2))  #将优先级高于token的运算符进行运算，直到优先级不大于token为止
            opstack.push(token)  #将token压入操作符栈顶
    while not opstack.isEmpty():  #弹出opstack里的操作符，进行后缀式运算，直至栈空
        operand2 = operandstack.pop()
        operand1 = operandstack.pop()
        operandstack.push(doMath(opstack.pop(), operand1, operand2))
    print(operandstack.pop())  #操作值栈空剩下的为最后结果，打印该值
PostfixAndCompute('5 * 6 + 9 + 3 * ( 5 + 7 )')  #只是个测试用例
